<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

require dirname(__FILE__).'/../inc/admin/prepend.php';

if (!checkPerm('manage_blocs'))
		adminPage::fatalErrorPage(__('You do not have permission to access this page.'));

# Get blocks
$blocs_nav = unserialize(pt_nav_sidebar);
$blocs_extra = unserialize(pt_extra_sidebar);

$availables_blocks = $puntal->blocks->getBlocks();

# Adding widgets to sidebars
if (!empty($_POST['append']) && is_array($_POST['addw']))
{
	# Filter selection
	$addw = array();
	foreach ($_POST['addw'] as $k => $v)
	{
		if (($v == 'extra' || $v == 'nav') && array_key_exists($k, $availables_blocks))
			$addw[$k] = $v;
	}
	
	# Append widgets
	if (!empty($addw))
	{
		foreach ($addw as $k => $v)
		{
			switch ($v)
			{
				case 'nav':
					$blocs_nav[] = $k;
					break;
				case 'extra':
					$blocs_extra[] = $k;
					break;
			}
		}

		$pt_settings->setNamespace('puntal');
		
		$res = true;
		$res &= $pt_settings->put('pt_nav_sidebar',serialize($blocs_nav));
		$res &= $pt_settings->put('pt_extra_sidebar',serialize($blocs_extra));
	
		$pt_settings->setNamespace('');
	
		if ($res)
		{
			logIt('Edit blocks configuration', 2);
			header('Location: blocs.php?updated=1');
			exit;
		}
	}
}

# Update sidebars
if (!empty($_POST['wup']))
{
	if (!isset($_POST['w']) || !is_array($_POST['w'])) {
		$_POST['w'] = array();
	}
	
	# Removing mark as _rem widgets
	foreach ($_POST['w'] as $nsid => $nsw)
	{
		foreach ($nsw as $i => $v)
		{
			if (!empty($v['_rem']))
			{
				unset($_POST['w'][$nsid][$i]);
				continue;
			}
		}
	}
	
	$blocs_nav = isset($_POST['w']['nav']) ? getBlocs($_POST['w']['nav']) : serialize(array());
	$blocs_extra = isset($_POST['w']['extra']) ? getBlocs($_POST['w']['extra']) : serialize(array());

	$pt_settings->setNamespace('puntal');
	
	$res = true;
	$res &= $pt_settings->put('pt_nav_sidebar',$blocs_nav);
	$res &= $pt_settings->put('pt_extra_sidebar',$blocs_extra);

	$pt_settings->setNamespace('');

	if ($res)
	{
		logIt('Edit blocks configuration', 2);
		header('Location: blocs.php?updated=1');
		exit;
	}
}

# message de confirmation
if (!empty($_GET['updated']))
	$common_message = __('Configuration updated');

# Liste de boites
$append_combo = array(
	'-' => 0,
	__('navigation') => 'nav',
	__('extra') => 'extra'
);

# Affichage
adminPage::open(__('Blocks positions'),
'<link rel="stylesheet" type="text/css" href="style/widgets_style.css" />' .
adminPage::jsToolMan().
'<script type="text/javascript" src="js/widgets_dragdrop.js"></script>
<script type="text/javascript" src="js/widgets.js"></script>');
?>
<h2 class="first"><img src="style/img/ico_blocs.png" alt="" class="icon" /> <?php echo __('Blocks positions'); ?></h2>

<form id="listWidgets" action="blocs.php" method="post"  class="widgets">
<fieldset><legend><?php echo __('Available blocks') ?></legend>
<div id="widgets">
<?php
$i=0;
foreach ($availables_blocks as $b=>$infos)
{
	echo
	'<div>'.form::hidden(array('w[void]['.$i.'][id]'),$b)."\n".
	'<h4>'.form::field(array('w[void]['.$i.'][order]'),2,3,0,'hideControl')."\n".
	' '.__('bloc_'.$b).'</h4>'."\n".
	'<p class="js-remove"><label class="classic">'.__('Add to')."\n".
	form::combo(array('addw['.$b.']'),$append_combo).'</label></p>'."\n".
	'</div>'."\n\n";
	$i++;
}
?>
</div>
</fieldset>
<p><input type="submit" class="js-remove submit" name="append" value="<?php echo __('Add') ?>" /></p>
</form>

<form id="sidebarsWidgets" action="blocs.php" method="post">

<div id="sidebarNav" class="widgets">
<?php echo sidebarWidgets('dndnav',__('Navigation sidebar'),$blocs_nav,'nav',__('Empty')) ?>
</div>

<div id="sidebarExtra" class="widgets">
<?php echo sidebarWidgets('dndextra',__('Extra sidebar'),$blocs_extra,'extra',__('Empty')) ?>
</div>

<p id="sidebarsControl">
<input class="submit" type="submit" name="wup" value="<?php echo __('Update') ?>" /></p>
</form>

<?php
adminPage::close();

function sidebarWidgets($id,$title,&$widgets,$pr,$default_msg)
{
	global $puntal, $lang_admin;
	
	$res = '<fieldset><legend>'.$title.'</legend><div id="'.$id.'">';
	
	if (empty($widgets))
		$res .= '<p class="empty-widgets">'.$default_msg.'</p>';
	
	$i = 0;
	foreach ($widgets as $b)
	{
		$iname = 'w['.$pr.']['.$i.']';
		$b_name = __('bloc_'.$b);
		$b_adjust = sprintf(__('adjustments'), $b_name);
		
		$res .=
		'<div>'.form::hidden(array($iname.'[id]'),$b)."\n".
		'<h4>'.form::field(array($iname.'[order]'),2,3,(string)$i,'js-hide','',0,'title="'.__('order').'"')."\n".
		$b_name.((is_callable($puntal->blocks->getAdminBlock($b)) && checkPerm('bloc_'.$b)) ? ' <a href="bloc.php?id='.$b.'" title="'.$b_adjust.'"><img src="style/img/ico_params.png" alt="'.$b_adjust.'" class="icon" /></a>' : '').
		'</h4>'."\n".
		'<p class="removeWidget js-remove"><label class="classic">'."\n".
		form::checkbox(array($iname.'[_rem]'),'1',0).__('Delete')."\n".
		'</label></p>'."\n".
		'</div>'."\n\n";	
		
		$i++;
	}
	$res .= '</div></fieldset>';
	
	return $res;
}

function getBlocs($src)
{
	uasort($src,'arraySort');
	
	$res = array();
	foreach ($src as $b)
		$res[] = $b['id'];
	
	return serialize($res);
}

function arraySort($a, $b)
{
	if ($a['order'] == $b['order'])
		return 0;
	
	return $a['order'] > $b['order'] ? 1 : -1;
}

?>