/* ------------------------------------------------------

	Le contenu de ce fichier ainsi que tout le Javascript 
	de Puntal 2 provient de DotClear 2.
	
	Adapt dans quelques cas  Puntal 2

-------------------------------------------------------- */


/* ChainHandler, py Peter van der Beken
-------------------------------------------------------- */
function chainHandler(obj, handlerName, handler) {
	obj[handlerName] = (function(existingFunction) {
		return function() {
			handler.apply(this, arguments);
			if (existingFunction)
				existingFunction.apply(this, arguments); 
		};
	})(handlerName in obj ? obj[handlerName] : null);
};

/* jQuery extensions
-------------------------------------------------------- */
jQuery.fn.check = function() {
	return this.each(function() {
		if (this.checked != undefined) { this.checked = true; }
	});
};
jQuery.fn.toggleCheck = function() {
	return this.each(function() {
		if (this.checked != undefined) { this.checked = !this.checked; }
	});
};
jQuery.fn.radioVal = function() {
	var res = null;
	this.each(function() {
		if (this.checked != undefined && this.checked) {
			res = this.value;
		}
	});
	return res;
};

jQuery.fn.toggleWithLegend = function(target,s) {
	var defaults = {
		img_on: 'style/img/plus.png',
		img_off: 'style/img/moins.png',
		hide: true,
		fn: false, // A function called on first display,
		cookie: false
	};
	var p = jQuery.extend(defaults,s);
	
	if (!target) { return this; }
	
	var set_cookie = p.hide;
	if (p.cookie && jQuery.cookie(p.cookie)) {
		p.hide = false;
	}
	
	var toggle = function(i) {
		if (p.hide) {
			target.hide();
			if (p.cookie && set_cookie) {
				jQuery.cookie(p.cookie,'',{expires: -1});
			}
		} else {
			target.show();
			if (p.fn) {
				p.fn.apply(target);
				p.fn = false;
			}
			if (p.cookie && set_cookie) {
				jQuery.cookie(p.cookie,1,{expires: 30});
			}
		}
		p.hide = !p.hide;
		$(i).get(0).src = p.hide ? p.img_off : p.img_on;
	};
	
	var prettyToggle = function(i) {
		if (p.hide) {
			target.slideUp('fast');
			if (p.cookie && set_cookie) {
				jQuery.cookie(p.cookie,'',{expires: -1});
			}
		} else {
			target.slideDown('slow');
			if (p.fn) {
				p.fn.apply(target);
				p.fn = false;
			}
			if (p.cookie && set_cookie) {
				jQuery.cookie(p.cookie,1,{expires: 30});
			}
		}
		p.hide = !p.hide;
		$(i).get(0).src = p.hide ? p.img_off : p.img_on;
	};
	
	return this.each(function() {
		var i = document.createElement('img');
		i.src = p.img_off;
		i.alt = '';
		$(i).css('cursor','pointer');
		$(i).css('vertical-align','middle');
		$(i).click(function() {
			prettyToggle(this);
		});
		$(this).prepend(document.createTextNode(' ')).prepend(i);
		
		toggle($(i).get(0));
	});
};

/* Puntal common object
-------------------------------------------------------- */
var puntal = {
	msg: { 		
		select_all: 'select all',
		invert_sel: 'invert selection'
	},
	
	hideLockable: function(ucfirst) {
		$('div.lockable').each(function() {
			$(this).find('input.lockable-in').each(function() {
				this.disabled = true;
				$(this).width(($(this).width()-14) + 'px');
				
				var imgE = document.createElement('img');
				imgE.src = 'style/img/lock.png';
				imgE.style.position = 'absolute';
				imgE.style.top = '1.7em';
				imgE.style.left = ($(this).width()+10)+'px';
				$(imgE).css('cursor','pointer');
				
				var imgR = document.createElement('img');
				imgR.src = 'style/img/refresh.png';
				imgR.style.position = 'absolute';
				imgR.style.top = '1.7em';
				imgR.style.left = ($(this).width()+10)+'px';
				$(imgR).css('cursor','pointer');
				$(imgR).hide();
				
				$(imgE).click(function() {
					$(this).hide();
					$(imgR).show();
					$(this).prev('input.lockable-in').removeAttr('disabled');
				});
				
				$(imgR).click(function() {
					$('input.lockable-in').val(puntal.str2url($('input.lockable-from').val(),ucfirst));
				});
				
				$(this).parent().position('relative');
				$(this).after(imgE,imgR);
			});
		});
	},
	
	str2url: function(str,ucfirst) {
		str = str.toUpperCase();
		str = str.toLowerCase();
		
		str = str.replace(/[\u00E0\u00E1\u00E2\u00E3\u00E4\u00E5]/g,'a');
		str = str.replace(/[\u00E7]/g,'c');
		str = str.replace(/[\u00E8\u00E9\u00EA\u00EB]/g,'e');
		str = str.replace(/[\u00EC\u00ED\u00EE\u00EF]/g,'i');
		str = str.replace(/[\u00F2\u00F3\u00F4\u00F5\u00F6\u00F8]/g,'o');
		str = str.replace(/[\u00F9\u00FA\u00FB\u00FC]/g,'u');
		str = str.replace(/[\u00FD\u00FF]/g,'y');
		str = str.replace(/[\u00F1]/g,'n');
		str = str.replace(/[\u0153]/g,'oe');
		str = str.replace(/[\u00E6]/g,'ae');
		str = str.replace(/[\u00DF]/g,'ss');
		
		str = str.replace(/[^a-z0-9_\s\'\:\/\[\]-]/g,'');
		str = $.trim(str);
		str = str.replace(/[\s\'\:\/\[\]-]+/g,' ');
		str = str.replace(/[ ]/g,'-');
		
		if (ucfirst == 1) {
			c = str.charAt(0);
			str = c.toUpperCase()+str.slice(1);
		}
		
		return str;
	},
	
	checkboxesHelpers: function(e) {
		var a = document.createElement('a');
		a.href='#';
		$(a).append(document.createTextNode(puntal.msg.select_all));
		a.onclick = function() {
			$(this).ancestors('form').find('input[@type="checkbox"]').check();
			return false;
		};
		$(e).append(a);
		
		$(e).append(document.createTextNode(' - '));
		
		a = document.createElement('a');
		a.href='#';
		$(a).append(document.createTextNode(puntal.msg.invert_sel));
		a.onclick = function() {
			$(this).ancestors('form').find('input[@type="checkbox"]').toggleCheck();
			return false;
		};
		$(e).append(a);
	}
};


/* On document ready
-------------------------------------------------------- */
$(function() {
		$('.errorbox').backgroundFade({sColor:'#ffffff',eColor:'#ff9999',steps:50},function() {
				$(this).backgroundFade({sColor:'#ff9999',eColor:'#ffffff'});
		});
		$('.warningbox').backgroundFade({sColor:'#ffffff',eColor:'#ffcc00',steps:50},function() {
				$(this).backgroundFade({sColor:'#ffcc00',eColor:'#ffffff'});
		});
		$('.messagebox').backgroundFade({sColor:'#ffffff',eColor:'#ffffaa',steps:50},function() {
				$(this).backgroundFade({sColor:'#ffffaa',eColor:'#ffffff'});
		});
});


//
// Olds common functions
//
function getElementsByNameAndClass(n,c,e)
{
	if (!document.getElementsByTagName) {
		return false;
	}
	
	var elements = new Array();
	
	if (e == undefined) {
		e = document;
	}
	
	var col = e.getElementsByTagName(n);
	if (col) {
		for (var i=0; i<col.length; i++) {
			var re = new RegExp("\\b" + c + "\\b");
			if (re.test(col[i].className)) {
				elements.push(col[i]);
			}
		}
	}
	
	return elements;
};


function openClose(id,mode,base_src)
{
	if (element = document.getElementById(id))
	{	
		if (base_src)
			img = document.getElementById('img_'+id);
		
		if (element.style)
		{
			if (mode == 0)
			{
				if (element.style.display == 'block' )
				{
					element.style.display = 'none';
					
					if (base_src)
					{
						img.src = base_src+'plus.png';
						img.alt = "+";
					}
				}
				else {
					element.style.display = 'block';
					
					if (base_src)
					{
						img.src = base_src+'moins.png';
						img.alt = "-";
					}
				}
			}
			else if (mode == 1)
			{
				element.style.display = 'block';
					
				if (base_src)
				{
					img.src = base_src+'moins.png';
					img.alt = "-";
				}
			}
			else if (mode == -1)
			{
				element.style.display = 'none';
				
				if (base_src)
				{
					img.src = base_src+'plus.png';
					img.alt = "+";
				}
			}
		}
	}
}

function openCloseMemory(id,cookie_name,mode,base_src)
{
	var cookie_exp = new Date ();
	cookie_exp.setTime (cookie_exp.getTime() + (365 * 24 * 60 * 60 * 1000)); // ouais, 1 ans !
	
	saved = new Array();
	clean = new Array();
	if (tmp = readCookie(cookie_name))
	{
		saved = tmp.split(',');
	}
	
	for (var i=0; i<saved.length; i++)
	{
		if (saved[i] != id && saved[i] != "")
		{
			clean[clean.length] = saved[i];
		}
	}
	
	if (mode != null)
	{
		openClose(id,mode,base_src);
		
		e = document.getElementById(id);
		if (e.style.display == 'block')
		{
			createCookie(cookie_name,clean.join(','),cookie_exp);
		}
		else {
			clean[clean.length] = id;
			createCookie(cookie_name,clean.join(','),cookie_exp);
		}
	}
	else {		
		var finded = false;
		for (var i=0; i<saved.length; i++)
		{
			if (saved[i] == id && saved[i] != "")
			{
				openClose(id,-1,base_src);
				finded = true;
			}
		}
		
		if (!finded)
			openClose(id,1,base_src);
	}
}

function mOpenClose(idArray,mode,base_src)
{
	for(var i=0;i<idArray.length;i++) {
		openClose(idArray[i],mode,base_src);
	}
}

function readCookie(name)
{
	var nameEQ = name + "=";
	var ca = document.cookie.split(';');
	for (var i=0; i < ca.length; i++)
	{
		var c = ca[i];
		while (c.charAt(0)==' ') c = c.substring(1,c.length);
			if (c.indexOf(nameEQ) == 0) return c.substring(nameEQ.length,c.length);
	}
	return null;
}

function createCookie(name,value,expires)
{
	cookieContent = name + "=" + value + ";path=/;" +
					((expires) ? "; expires=" + expires.toGMTString() : "");
	
	document.cookie = cookieContent;
}

