<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

require dirname(__FILE__).'/../inc/admin/prepend.php';

if ($puntal->user['g_id'] != PUN_ADMIN)
	adminPage::fatalErrorPage(__('You do not have permission to access this page.'));

/************************************************************************/

define('STYLE_LOG_LEVEL_3', 'color: #FF0000; font-weight: bold;');
define('STYLE_LOG_LEVEL_2', 'color: #FF9900; font-weight: bold;');
define('STYLE_LOG_LEVEL_1', 'color: #FFCC00; font-weight: bold;');
define('STYLE_LOG_LEVEL_0', 'color: #006600;');

/************************************************************************/

// Fonction d'affichage des lignes de logs
function logs_line($data,$i)
{
	$class = ($i%2 == 0) ? ' class="even"' : ' class="odd"';
	
	if ($data['code'] == 3)
		$style = ' style="'.STYLE_LOG_LEVEL_3.'"';
	elseif ($data['code'] == 2)
		$style = ' style="'.STYLE_LOG_LEVEL_2.'"';
	elseif ($data['code'] == 1)
		$style = ' style="'.STYLE_LOG_LEVEL_1.'"';
	else
		$style = ' style="'.STYLE_LOG_LEVEL_0.'"';
	
	return
	'<td'.$class.' width="20%"><a href="'.pt_forum_url.'profile.php?id='.$data['user_id'].'"><strong>'.$data['user_name'].'</strong></a></td>'.
	'<td'.$class.' width="10%"><a href="'.pt_forum_url.'admin_users.php?show_users='.$data['user_ip'].'">'.$data['user_ip'].'</a></td>'.
	'<td'.$class.' width="30%">'.$data['date'].'</td>'.
	'<td'.$class.' width="40%"><span'.$style.'>'.$data['log'].'</span></td>';

}

/************************************************************************/

// level ?
$exists_levels = array('3', '2', '1', '0');

$level = (isset($_GET['level']) && in_array($_GET['level'], $exists_levels)) ? $_GET['level'] : '';
$where_sql = ($level != '') ? " WHERE code='".$level."'" : '';

// suppression
if (isset($_GET['delete']))
{
	if ($_GET['delete'] == 'all')
		$result = $con->execute('DELETE FROM '.DB_PREFIX.'pt_log') or $puntal->err->fatalError($con->error());
	
	elseif (in_array($_GET['delete'], $exists_levels))
		$result = $con->execute('DELETE FROM '.DB_PREFIX.'pt_log WHERE code='.$_GET['delete']) or $puntal->err->fatalError($con->error());
	
	
	header('Location: logs.php');
	exit;
}

// multipages
require PT_INC_PATH.'/classes/multipage.php';

$nb_per_page = 10;

$result = $con->select("SELECT count(user_id) AS nb_logs FROM ".DB_PREFIX."pt_log".$where_sql) or $puntal->err->fatalError($con->error());
$nb_logs = $result->f('nb_logs');

$max_pages = ceil($nb_logs/$nb_per_page);
$env = (!empty($_GET['env']) && $_GET['env'] <= $max_pages) ? $_GET['env'] : 1;

$rs = $con->select('SELECT * FROM '.DB_PREFIX.'pt_log'.$where_sql.' ORDER BY date DESC LIMIT '.(($env-1)*$nb_per_page).','.$nb_per_page) or $puntal->err->fatalError($con->error());

$lum = new multipage($env, 'logs_line', $rs->getData(), $nb_logs, $nb_per_page);

$lum->setOption('html_block', '<table class="logs" cellpadding="0" cellspacing="0"><tbody>%s</tbody></table>');

$lum->setOption('html_row','<tr>%s</tr>');
$lum->setOption('html_cell','%s');

$lum->setOption('html_links','<p>'.__('Pages:').' %s</p>');
$lum->setOption('html_cur_page','<strong>%s</strong>');

$lum->setOption('html_prev','&lt; '.__('Previous'));
$lum->setOption('html_next',__('Next').' &gt;');
$lum->setOption('html_prev_grp','...');
$lum->setOption('html_next_grp','...');

$lum->setOption('html_empty','<p><strong>'.__('No log').'</strong></p>');

// debut de page
adminPage::open(__('Administration logs'));
?>

<h2 class="first"><img src="style/img/ico_logs.png" alt="" class="icon" /> <?php echo __('Administration logs'); ?></h2>
	<p>
	<a href="logs.php">
	<?php if ($level == '') echo '<strong>'.__('Display all logs').'</strong>';
		else echo __('Display all logs'); ?></a> | 
	
	<a href="logs.php?level=0">
	<?php if ($level == '0') printf('<strong>'.__('Display logs level %s').'</strong>', 0);
		else printf(__('Display logs level %s'), 0); ?></a> | 
	
	<a href="logs.php?level=1">
	<?php if ($level == '1') printf('<strong>'.__('Display logs level %s').'</strong>', 1);
		else printf(__('Display logs level %s'), 1); ?></a> | 
	
	<a href="logs.php?level=2">
	<?php if ($level == '2') printf('<strong>'.__('Display logs level %s').'</strong>', 2);
		else printf(__('Display logs level %s'), 2); ?></a> | 
	
	<a href="logs.php?level=3">
	<?php if ($level == '3') printf('<strong>'.__('Display logs level %s').'</strong>', 3);
		else printf(__('Display logs level %s'), 3); ?></a>
	</p>
	
	<?php
	echo $lum->getLinks();
	echo $lum->getPage();
	echo $lum->getLinks();
	?>
	
	<h3><img src="style/img/ico_logs_delete.png" alt="" class="icon" /> <?php echo __('Delete logs') ?></h3>
	<ul>
		<li><a href="logs.php?delete=all" onclick="return window.confirm('<?php echo __('Are you sure you want to delete these logs?') ?>')"><?php echo __('Delete all logs') ?></a></li>
		<li><a href="logs.php?delete=0" onclick="return window.confirm('<?php echo __('Are you sure you want to delete these logs?') ?>')"><?php printf(__('Delete logs level %s'), 0) ?></a></li>
		<li><a href="logs.php?delete=1" onclick="return window.confirm('<?php echo __('Are you sure you want to delete these logs?') ?>')"><?php printf(__('Delete logs level %s'), 1) ?></a></li>
		<li><a href="logs.php?delete=2" onclick="return window.confirm('<?php echo __('Are you sure you want to delete these logs?') ?>')"><?php printf(__('Delete logs level %s'), 2) ?></a></li>
		<li><a href="logs.php?delete=3" onclick="return window.confirm('<?php echo __('Are you sure you want to delete these logs?') ?>')"><?php printf(__('Delete logs level %s'), 3) ?></a></li>
	</ul>

<?php adminPage::close(); ?>