<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

require dirname(__FILE__).'/../inc/admin/prepend.php';

if (!checkPerm('manage_modules'))
	adminPage::fatalErrorPage(__('You do not have permission to access this page.'));


# Modification de la configuration
if (!empty($_POST['form_sent']) && $puntal->checkToken()) {

	
	$pt_settings->setNamespace('puntal');
	
	$res = true;
	$res &= $pt_settings->put('pt_ptb_img_pack',trim($_POST['pt_ptb_img_pack']) );	
	$res &= $pt_settings->put('pt_ptb_nb_smilies',intval(trim($_POST['pt_ptb_nb_smilies'])) );
	$res &= $pt_settings->put('pt_ptb_smilies_pop_up_width',intval(trim($_POST['pt_ptb_smilies_pop_up_width'])) );
	$res &= $pt_settings->put('pt_ptb_smilies_pop_up_height',intval(trim($_POST['pt_ptb_smilies_pop_up_height'])) );
	$res &= $pt_settings->put('pt_ptb_bt_left',intval(trim($_POST['pt_ptb_bt_left'])) );
	$res &= $pt_settings->put('pt_ptb_bt_right',intval(trim($_POST['pt_ptb_bt_right'])) );
	$res &= $pt_settings->put('pt_ptb_bt_center',intval(trim($_POST['pt_ptb_bt_center'])) );
	$res &= $pt_settings->put('pt_ptb_bt_justify',intval(trim($_POST['pt_ptb_bt_justify'])) );
	$res &= $pt_settings->put('pt_ptb_bt_min',intval(trim($_POST['pt_ptb_bt_min'])) );
	$res &= $pt_settings->put('pt_ptb_bt_plus',intval(trim($_POST['pt_ptb_bt_plus'])) );
	$res &= $pt_settings->put('pt_ptb_bt_sub',intval(trim($_POST['pt_ptb_bt_sub'])) );
	$res &= $pt_settings->put('pt_ptb_bt_sup',intval(trim($_POST['pt_ptb_bt_sup'])) );
	$res &= $pt_settings->put('pt_ptb_bt_b',intval(trim($_POST['pt_ptb_bt_b'])) );
	$res &= $pt_settings->put('pt_ptb_bt_i',intval(trim($_POST['pt_ptb_bt_i'])) );
	$res &= $pt_settings->put('pt_ptb_bt_u',intval(trim($_POST['pt_ptb_bt_u'])) );
	$res &= $pt_settings->put('pt_ptb_bt_s',intval(trim($_POST['pt_ptb_bt_s'])) );
	$res &= $pt_settings->put('pt_ptb_bt_q',intval(trim($_POST['pt_ptb_bt_q'])) );
	$res &= $pt_settings->put('pt_ptb_bt_c',intval(trim($_POST['pt_ptb_bt_c'])) );
	$res &= $pt_settings->put('pt_ptb_bt_acr',intval(trim($_POST['pt_ptb_bt_acr'])) );
	$res &= $pt_settings->put('pt_ptb_bt_col',intval(trim($_POST['pt_ptb_bt_col'])) );
	$res &= $pt_settings->put('pt_ptb_bt_bq',intval(trim($_POST['pt_ptb_bt_bq'])) );
	$res &= $pt_settings->put('pt_ptb_bt_pre',intval(trim($_POST['pt_ptb_bt_pre'])) );
	$res &= $pt_settings->put('pt_ptb_bt_hr',intval(trim($_POST['pt_ptb_bt_hr'])) );
	$res &= $pt_settings->put('pt_ptb_bt_link',intval(trim($_POST['pt_ptb_bt_link'])) );
	$res &= $pt_settings->put('pt_ptb_bt_img',intval(trim($_POST['pt_ptb_bt_img'])) );
	$res &= $pt_settings->put('pt_ptb_bt_email',intval(trim($_POST['pt_ptb_bt_email'])) );
	$res &= $pt_settings->put('pt_ptb_bt_nospam',intval(trim($_POST['pt_ptb_bt_nospam'])) );
	$res &= $pt_settings->put('pt_ptb_bt_smilies',intval(trim($_POST['pt_ptb_bt_smilies'])) );
	
	$pt_settings->setNamespace('');
		
	if ($res)
	{
		logIt('Edit Puntoolbar configuration', 2);
		header('Location: puntoolbar.php?updated=1');
		exit;
	}
		
}
# message de confirmation
if (!empty($_GET['updated']))
	$common_message = __('Configuration updated');
	
# Set token
$puntal->setToken();

#Affichage 
adminPage::open(__('Puntoolbar'));
?>
<div class="block">
	<h2><span>PunToolBar</span></h2>
	<div class="box">
		<div class="inbox">
			<p><?php echo __('plugin_desc') ?></p>
		</div>
	</div>
</div>
<div class="blockform">
	<h2 class="block2"><span><?php echo __('configuration') ?></span></h2>
	<div class="box">
	<form method="post" action="puntoolbar.php">
		<p class="clearb"><?php echo form::hidden('form_sent',1)."\n".
		form::hidden(array('ptkn'),$puntal->getToken()); ?>
		<input class="submit" type="submit" value=" <?php echo __('Save') ?> " /></p>
			<div class="inform">
				<fieldset>
				<legend><?php echo __('Images'); ?></legend>
				<div class="infldset">
					<table class="aligntop" cellspacing="0">				
						<th scope="row"><?php echo __('Images Pack') ?></th>
						<td><select name="pt_ptb_img_pack">
<?php
		$packs = array();
		$d = dir(PT_THEMES_PATH.'/img/puntoolbar');
		while (($entry = $d->read()) !== false)
		{
			 if ($entry != '.' && $entry != '..' && is_dir(PT_THEMES_PATH.'/img/puntoolbar/'.$entry))
				$packs[] = $entry;
		}
		$d->close();
		
		@natsort($packs);

		while (list(, $temp) = @each($packs))
		{
			if (pt_ptb_img_pack == $temp)
				echo "\t\t\t\t\t\t\t\t\t\t\t".'<option value="'.$temp.'" selected="selected">'.$temp.'</option>'."\n";
			else
				echo "\t\t\t\t\t\t\t\t\t\t\t".'<option value="'.$temp.'">'.$temp.'</option>'."\n";
		}
?>
								</select>
						</td>
						</th>
					</table>				
				</div>
				</fieldset>
				<fieldset>
					<legend><?php echo __('smilies_settings') ?></legend>
					<div class="infldset">
						<table class="aligntop" cellspacing="0">
							<tr>
								<th scope="row"><?php echo __('nb_smilies'); ?></th>
								<td>
								<input type="text" name="pt_ptb_nb_smilies" size="3" maxlength="3" value="<?php echo pt_ptb_nb_smilies ?>" />
									<span><?php echo __('nb_smilies_info') ?></span>
								</td>
							</tr>
							<tr>
								<th scope="row"><?php echo __('smilies_width') ?></th>
								<td>
									<input type="text" name="pt_ptb_smilies_pop_up_width" size="5" maxlength="5" value="<?php echo pt_ptb_smilies_pop_up_width ?>" />
									<span><?php echo __('smilies_width_info') ?></span>
								</td>
							</tr>
							<tr>
								<th scope="row"><?php echo __('smilies_height') ?></th>
								<td>
									<input type="text" name="pt_ptb_smilies_pop_up_height" size="5" maxlength="5" value="<?php echo pt_ptb_smilies_pop_up_height ?>" />
									<span><?php echo __('smilies_height_info') ?></span>
								</td>
							</tr>
						</table>
					</div>
				</fieldset>
			</div>
			<div class="inform">
				<fieldset>
					<legend><?php echo __('butons_settings') ?></legend>
					<div class="infldset">
						<table class="aligntop" cellspacing="0">
							<tr>
								<th scope="row"><img src="<?php echo PT_THEMES_URL ?>img/puntoolbar/<?php echo pt_ptb_img_pack; ?>/bt_size_plus.png" alt="<?php echo __('btSizePlus') ?>" /></th>
									<td>
										<input type="radio" name="pt_ptb_bt_plus" value="1"<?php if (pt_ptb_bt_plus == '1') echo ' checked="checked"' ?> />&#160;<strong><?php echo __('Yes') ?></strong>&#160;&#160;&#160;<input type="radio" name="pt_ptb_bt_plus" value="0"<?php if (pt_ptb_bt_plus == '0') echo ' checked="checked"' ?> />&#160;<strong><?php echo __('No') ?></strong>
										<span><?php echo __('btSizePlus') ?></span>
									</td>
							</tr>
							<tr>
								<th scope="row"><img src="<?php echo PT_THEMES_URL ?>img/puntoolbar/<?php echo pt_ptb_img_pack; ?>/bt_size_minus.png" alt="<?php echo __('btSizeMinus') ?>" /></th>
									<td>
										<input type="radio" name="pt_ptb_bt_min" value="1"<?php if (pt_ptb_bt_min == '1') echo ' checked="checked"' ?> />&#160;<strong><?php echo __('Yes') ?></strong>&#160;&#160;&#160;<input type="radio" name="pt_ptb_bt_min" value="0"<?php if (pt_ptb_bt_min == '0') echo ' checked="checked"' ?> />&#160;<strong><?php echo __('No') ?></strong>
										<span><?php echo __('btSizeMinus') ?></span>
									</td>
							</tr>
							<tr>
								<th scope="row"><img src="<?php echo PT_THEMES_URL ?>img/puntoolbar/<?php echo pt_ptb_img_pack; ?>/bt_sup.png" alt="<?php echo __('btSup') ?>" /></th>
									<td>
										<input type="radio" name="pt_ptb_bt_sup" value="1"<?php if (pt_ptb_bt_sup == '1') echo ' checked="checked"' ?> />&#160;<strong><?php echo __('Yes') ?></strong>&#160;&#160;&#160;<input type="radio" name="pt_ptb_bt_sup" value="0"<?php if (pt_ptb_bt_sup == '0') echo ' checked="checked"' ?> />&#160;<strong><?php echo __('No') ?></strong>
										<span><?php echo __('btSup') ?></span>
									</td>
							</tr>
							<tr>
								<th scope="row"><img src="<?php echo PT_THEMES_URL ?>img/puntoolbar/<?php echo pt_ptb_img_pack; ?>/bt_sub.png" alt="<?php echo __('btSub') ?>" /></th>
									<td>
										<input type="radio" name="pt_ptb_bt_sub" value="1"<?php if (pt_ptb_bt_sub == '1') echo ' checked="checked"' ?> />&#160;<strong><?php echo __('Yes') ?></strong>&#160;&#160;&#160;<input type="radio" name="pt_ptb_bt_sub" value="0"<?php if (pt_ptb_bt_sub == '0') echo ' checked="checked"' ?> />&#160;<strong><?php echo __('No') ?></strong>
										<span><?php echo __('btSub') ?></span>
									</td>
							</tr>
							<tr>
								<th scope="row"><img src="<?php echo PT_THEMES_URL ?>img/puntoolbar/<?php echo pt_ptb_img_pack; ?>/bt_align_right.png" alt="<?php echo __('btRight') ?>" /></th>
									<td>
										<input type="radio" name="pt_ptb_bt_right" value="1"<?php if (pt_ptb_bt_right == '1') echo ' checked="checked"' ?> />&#160;<strong><?php echo __('Yes') ?></strong>&#160;&#160;&#160;<input type="radio" name="pt_ptb_bt_right" value="0"<?php if (pt_ptb_bt_right == '0') echo ' checked="checked"' ?> />&#160;<strong><?php echo __('No') ?></strong>
										<span><?php echo __('btRight') ?></span>
									</td>
							</tr>
							<tr>
								<th scope="row"><img src="<?php echo PT_THEMES_URL ?>img/puntoolbar/<?php echo pt_ptb_img_pack; ?>/bt_align_left.png" alt="<?php echo __('btLeft') ?>" /></th>
									<td>
										<input type="radio" name="pt_ptb_bt_left" value="1"<?php if (pt_ptb_bt_left == '1') echo ' checked="checked"' ?> />&#160;<strong><?php echo __('Yes') ?></strong>&#160;&#160;&#160;<input type="radio" name="pt_ptb_bt_left" value="0"<?php if (pt_ptb_bt_left == '0') echo ' checked="checked"' ?> />&#160;<strong><?php echo __('No') ?></strong>
										<span><?php echo __('btLeft') ?></span>
									</td>
							</tr>
							<tr>
								<th scope="row"><img src="<?php echo PT_THEMES_URL ?>img/puntoolbar/<?php echo pt_ptb_img_pack; ?>/bt_align_center.png" alt="<?php echo __('btCenter') ?>" /></th>
									<td>
										<input type="radio" name="pt_ptb_bt_center" value="1"<?php if (pt_ptb_bt_center == '1') echo ' checked="checked"' ?> />&#160;<strong><?php echo __('Yes') ?></strong>&#160;&#160;&#160;<input type="radio" name="pt_ptb_bt_center" value="0"<?php if (pt_ptb_bt_center == '0') echo ' checked="checked"' ?> />&#160;<strong><?php echo __('No') ?></strong>
										<span><?php echo __('btCenter') ?></span>
									</td>
							</tr>
							<tr>
								<th scope="row"><img src="<?php echo PT_THEMES_URL ?>img/puntoolbar/<?php echo pt_ptb_img_pack; ?>/bt_align_justify.png" alt="<?php echo __('btJustify') ?>" /></th>
									<td>
										<input type="radio" name="pt_ptb_bt_justify" value="1"<?php if (pt_ptb_bt_justify == '1') echo ' checked="checked"' ?> />&#160;<strong><?php echo __('Yes') ?></strong>&#160;&#160;&#160;<input type="radio" name="pt_ptb_bt_justify" value="0"<?php if (pt_ptb_bt_justify == '0') echo ' checked="checked"' ?> />&#160;<strong><?php echo __('No') ?></strong>
										<span><?php echo __('btJustify') ?></span>
									</td>
							</tr>
						
							<tr>
								<th scope="row"><img src="<?php echo PT_THEMES_URL ?>img/puntoolbar/<?php echo pt_ptb_img_pack; ?>/bt_strong.png" alt="<?php echo __('btStrong') ?>" /></th>
									<td>
										<input type="radio" name="pt_ptb_bt_b" value="1"<?php if (pt_ptb_bt_b == '1') echo ' checked="checked"' ?> />&#160;<strong><?php echo __('Yes') ?></strong>&#160;&#160;&#160;<input type="radio" name="pt_ptb_bt_b" value="0"<?php if (pt_ptb_bt_b == '0') echo ' checked="checked"' ?> />&#160;<strong><?php echo __('No') ?></strong>
										<span><?php echo __('btStrong') ?></span>
									</td>
							</tr>
							<tr>
								<th scope="row"><img src="<?php echo PT_THEMES_URL ?>img/puntoolbar/<?php echo pt_ptb_img_pack; ?>/bt_em.png" alt="<?php echo __('btEm') ?>" /></th>
									<td>
										<input type="radio" name="pt_ptb_bt_i" value="1"<?php if (pt_ptb_bt_i== '1') echo ' checked="checked"' ?> />&#160;<strong><?php echo __('Yes') ?></strong>&#160;&#160;&#160;<input type="radio" name="pt_ptb_bt_i" value="0"<?php if (pt_ptb_bt_i== '0') echo ' checked="checked"' ?> />&#160;<strong><?php echo __('No') ?></strong>
										<span><?php echo __('btEm') ?></span>
									</td>
							</tr>
							<tr>
								<th scope="row"><img src="<?php echo PT_THEMES_URL ?>img/puntoolbar/<?php echo pt_ptb_img_pack; ?>/bt_ins.png" alt="<?php echo __('btIns') ?>" /></th>
									<td>
										<input type="radio" name="pt_ptb_bt_u" value="1"<?php if (pt_ptb_bt_u== '1') echo ' checked="checked"' ?> />&#160;<strong><?php echo __('Yes') ?></strong>&#160;&#160;&#160;<input type="radio" name="pt_ptb_bt_u" value="0"<?php if (pt_ptb_bt_u== '0') echo ' checked="checked"' ?> />&#160;<strong><?php echo __('No') ?></strong>
										<span><?php echo __('btIns') ?></span>
									</td>
							</tr>
							<tr>
								<th scope="row"><img src="<?php echo PT_THEMES_URL ?>img/puntoolbar/<?php echo pt_ptb_img_pack; ?>/bt_del.png" alt="<?php echo __('btDel')?>" /></th>
									<td>
										<input type="radio" name="pt_ptb_bt_s" value="1"<?php if (pt_ptb_bt_s== '1') echo ' checked="checked"' ?> />&#160;<strong><?php echo __('Yes') ?></strong>&#160;&#160;&#160;<input type="radio" name="pt_ptb_bt_s" value="0"<?php if (pt_ptb_bt_s== '0') echo ' checked="checked"' ?> />&#160;<strong><?php echo __('No') ?></strong>
										<span><?php echo __('btDel') ?></span>
									</td>
							</tr>
							<tr>
								<th scope="row"><img src="<?php echo PT_THEMES_URL ?>img/puntoolbar/<?php echo pt_ptb_img_pack; ?>/bt_quote.png" alt="<?php echo __('btQ') ?>" /></th>
									<td>
										<input type="radio" name="pt_ptb_bt_q" value="1"<?php if (pt_ptb_bt_q== '1') echo ' checked="checked"' ?> />&#160;<strong><?php echo __('Yes') ?></strong>&#160;&#160;&#160;<input type="radio" name="pt_ptb_bt_q" value="0"<?php if (pt_ptb_bt_q== '0') echo ' checked="checked"' ?> />&#160;<strong><?php echo __('No') ?></strong>
										<span><?php echo __('btQ') ?></span>
									</td>
							</tr>
							<tr>
								<th scope="row"><img src="<?php echo PT_THEMES_URL ?>img/puntoolbar/<?php echo pt_ptb_img_pack; ?>/bt_code.png" alt="<?php echo __('btCode') ?>" /></th>
									<td>
										<input type="radio" name="pt_ptb_bt_c" value="1"<?php if (pt_ptb_bt_c== '1') echo ' checked="checked"' ?> />&#160;<strong><?php echo __('Yes') ?></strong>&#160;&#160;&#160;<input type="radio" name="pt_ptb_bt_c" value="0"<?php if (pt_ptb_bt_c== '0') echo ' checked="checked"' ?> />&#160;<strong><?php echo __('No') ?></strong>
										<span><?php echo __('btCode') ?></span>
									</td>
							</tr>
							<tr>
								<th scope="row"><img src="<?php echo PT_THEMES_URL ?>img/puntoolbar/<?php echo pt_ptb_img_pack; ?>/bt_acronym.png" alt="<?php echo __('btAcronym') ?>" /></th>
									<td>
										<input type="radio" name="pt_ptb_bt_acr" value="1"<?php if (pt_ptb_bt_acr== '1') echo ' checked="checked"' ?> />&#160;<strong><?php echo __('Yes') ?></strong>&#160;&#160;&#160;<input type="radio" name="pt_ptb_bt_acr" value="0"<?php if (pt_ptb_bt_acr== '0') echo ' checked="checked"' ?> />&#160;<strong><?php echo __('No') ?></strong>
										<span><?php echo __('btAcronym') ?></span>
									</td>
							</tr>
							<tr>
								<th scope="row"><img src="<?php echo PT_THEMES_URL ?>img/puntoolbar/<?php echo pt_ptb_img_pack; ?>/bt_color.png" alt="<?php echo __('btColor') ?>" /></th>
									<td>
										<input type="radio" name="pt_ptb_bt_col" value="1"<?php if (pt_ptb_bt_col== '1') echo ' checked="checked"' ?> />&#160;<strong><?php echo __('Yes') ?></strong>&#160;&#160;&#160;<input type="radio" name="pt_ptb_bt_col" value="0"<?php if (pt_ptb_bt_col== '0') echo ' checked="checked"' ?> />&#160;<strong><?php echo __('No') ?></strong>
										<span><?php echo __('btColor') ?></span>
									</td>
							</tr>
							<tr>
								<th scope="row"><img src="<?php echo PT_THEMES_URL ?>img/puntoolbar/<?php echo pt_ptb_img_pack; ?>/bt_bquote.png" alt="<?php echo __('btBquote') ?>" /></th>
									<td>
										<input type="radio" name="pt_ptb_bt_bq" value="1"<?php if (pt_ptb_bt_bq== '1') echo ' checked="checked"' ?> />&#160;<strong><?php echo __('Yes') ?></strong>&#160;&#160;&#160;<input type="radio" name="pt_ptb_bt_bq" value="0"<?php if (pt_ptb_bt_bq== '0') echo ' checked="checked"' ?> />&#160;<strong><?php echo __('No') ?></strong>
										<span><?php echo __('btBquote') ?></span>
									</td>
							</tr>
							<tr>
								<th scope="row"><img src="<?php echo PT_THEMES_URL ?>img/puntoolbar/<?php echo pt_ptb_img_pack; ?>/bt_pre.png" alt="<?php echo __('btPre') ?>" /></th>
									<td>
										<input type="radio" name="pt_ptb_bt_pre" value="1"<?php if (pt_ptb_bt_pre== '1') echo ' checked="checked"' ?> />&#160;<strong><?php echo __('Yes') ?></strong>&#160;&#160;&#160;<input type="radio" name="pt_ptb_bt_pre" value="0"<?php if (pt_ptb_bt_pre== '0') echo ' checked="checked"' ?> />&#160;<strong><?php echo __('No') ?></strong>
										<span><?php echo __('btPre') ?></span>
									</td>
							</tr>
							<tr>
								<th scope="row"><img src="<?php echo PT_THEMES_URL ?>img/puntoolbar/<?php echo pt_ptb_img_pack; ?>/bt_hr.png" alt="<?php echo __('btHr') ?>" /></th>
									<td>
										<input type="radio" name="pt_ptb_bt_hr" value="1"<?php if (pt_ptb_bt_hr== '1') echo ' checked="checked"' ?> />&#160;<strong><?php echo __('Yes') ?></strong>&#160;&#160;&#160;<input type="radio" name="pt_ptb_bt_hr" value="0"<?php if (pt_ptb_bt_hr== '0') echo ' checked="checked"' ?> />&#160;<strong><?php echo __('No') ?></strong>
										<span><?php echo __('btHr') ?></span>
									</td>
							</tr>
							<tr>
								<th scope="row"><img src="<?php echo PT_THEMES_URL ?>img/puntoolbar/<?php echo pt_ptb_img_pack; ?>/bt_link.png" alt="<?php echo __('btLink') ?>" /></th>
									<td>
										<input type="radio" name="pt_ptb_bt_link" value="1"<?php if (pt_ptb_bt_link== '1') echo ' checked="checked"' ?> />&#160;<strong><?php echo __('Yes') ?></strong>&#160;&#160;&#160;<input type="radio" name="pt_ptb_bt_link" value="0"<?php if (pt_ptb_bt_link== '0') echo ' checked="checked"' ?> />&#160;<strong><?php echo __('No') ?></strong>
										<span><?php echo __('btLink') ?></span>
									</td>
							</tr>
							<tr>
								<th scope="row"><img src="<?php echo PT_THEMES_URL ?>img/puntoolbar/<?php echo pt_ptb_img_pack; ?>/bt_img_link.png" alt="<?php echo __('btImgLink') ?>" /></th>
									<td>
										<input type="radio" name="pt_ptb_bt_img" value="1"<?php if (pt_ptb_bt_img == '1') echo ' checked="checked"' ?> />&#160;<strong><?php echo __('Yes') ?></strong>&#160;&#160;&#160;<input type="radio" name="pt_ptb_bt_img" value="0"<?php if (pt_ptb_bt_img== '0') echo ' checked="checked"' ?> />&#160;<strong><?php echo __('No') ?></strong>
										<span><?php echo __('btImgLink') ?></span>
									</td>
							</tr>
							<tr>
								<th scope="row"><img src="<?php echo PT_THEMES_URL ?>img/puntoolbar/<?php echo pt_ptb_img_pack; ?>/bt_email.png" alt="<?php echo __('btEmail') ?>" /></th>
									<td>
										<input type="radio" name="pt_ptb_bt_email" value="1"<?php if (pt_ptb_bt_email == '1') echo ' checked="checked"' ?> />&#160;<strong><?php echo __('Yes') ?></strong>&#160;&#160;&#160;<input type="radio" name="pt_ptb_bt_email" value="0"<?php if (pt_ptb_bt_email== '0') echo ' checked="checked"' ?> />&#160;<strong><?php echo __('No') ?></strong>
										<span><?php echo __('btEmail') ?></span>
									</td>
							</tr>
							<tr>
								<th scope="row"><img src="<?php echo PT_THEMES_URL ?>img/puntoolbar/<?php echo pt_ptb_img_pack; ?>/bt_nospam.png" alt="<?php echo __('btNospam') ?>" /></th>
									<td>
										<input type="radio" name="pt_ptb_bt_nospam" value="1"<?php if (pt_ptb_bt_nospam == '1') echo ' checked="checked"' ?> />&#160;<strong><?php echo __('Yes') ?></strong>&#160;&#160;&#160;<input type="radio" name="pt_ptb_bt_nospam" value="0"<?php if (pt_ptb_bt_nospam== '0') echo ' checked="checked"' ?> />&#160;<strong><?php echo __('No') ?></strong>
										<span><?php echo __('btNospam') ?></span>
									</td>
							</tr>
							<tr>
								<th scope="row"><img src="<?php echo PT_THEMES_URL ?>img/puntoolbar/<?php echo pt_ptb_img_pack; ?>/bt_smilies.png" alt="<?php echo __('Smilies') ?>" /></th>
									<td>
										<input type="radio" name="pt_ptb_bt_smilies" value="1"<?php if (pt_ptb_bt_smilies == '1') echo ' checked="checked"' ?> />&#160;<strong><?php echo __('Yes') ?></strong>&#160;&#160;&#160;<input type="radio" name="pt_ptb_bt_smilies" value="0"<?php if (pt_ptb_bt_smilies == '0') echo ' checked="checked"' ?> />&#160;<strong><?php echo __('No') ?></strong>
										<span><?php echo __('Smilies') ?></span>
									</td>
							</tr>
						</table>
					</div>
				</fieldset>
			</div>
		<p class="clearb"><?php echo form::hidden('form_sent',1)."\n".
	form::hidden(array('ptkn'),$puntal->getToken()); ?>
	<input class="submit" type="submit" value=" <?php echo __('Save') ?> " /></p>
		</form>
	</div>
</div>
<?php
#Affichage 
adminPage::close();?>
