<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

require dirname(__FILE__).'/../inc/admin/prepend.php';

if (!checkPerm('puntal_config'))
	adminPage::fatalErrorPage(__('You do not have permission to access this page.'));

$p_theme = pt_theme;

# Modification de la configuration
if (!empty($_POST['form_sent']) && $puntal->checkToken())
{
	$p_theme = trim($_POST['p_theme']);
	
	$pt_settings->setNamespace('puntal');
	
	$res = true;
	$res &= $pt_settings->put('pt_theme',$p_theme);
	
	$pt_settings->setNamespace('');

	if ($res)
	{
		logIt('Edit theme configuration', 2);
		header('Location: themes.php?updated=1');
		exit;
	}
}

# message de confirmation
if (!empty($_GET['updated']))
	$common_message = __('Configuration updated');

# Set token
$puntal->setToken();

# Affichage
adminPage::open(__('Puntal themes'));
?>

<h2 class="first"><img src="style/img/ico_style.png" alt="" class="icon" /> <?php echo __('Puntal themes'); ?></h2>

<form method="post" action="themes.php">	
	<p><?php echo __('Choose the theme to use on your portal.'); ?></p>
	
	<div class="two-cols">
	<?php $themes_array = array();
	$d = dir(PT_THEMES_PATH);
	while (($entry = $d->read()) !== false)
	{
		if ($entry != '.' && $entry != '..' && $entry != '.svn' 
			&& is_dir(PT_THEMES_PATH.$entry) 
			&& file_exists(PT_THEMES_PATH.$entry.'/__infos.php'))
		{
			$theme_infos = array(
				'name' => '',
				'desc' => array(),
				'author' => '',
				'version' => '',
				'preview' => ''
			);			
			require PT_THEMES_PATH.$entry.'/__infos.php';
			$themes_array[$entry] = $entry;
			
			echo 
			"\n".'<div class="col"><h3>'.form::radio(array('p_theme',$entry),$entry,($p_theme==$entry), 'radio').
			'<label for="'.$entry.'">'.$theme_infos['name'].
			(!empty($theme_infos['version']) ? ' (v'.$theme_infos['version'].')' : '').
			'</label></h3>'."\n".
			'<p class="field">'."\n".
			(!empty($theme_infos['preview']) ? '<label for="'.$entry.'"><img src="'.PT_THEMES_URL.$entry.'/'.$theme_infos['preview'].'" alt="" /></label>' : '').
			'<span class="desc">'.__('by').' '.$theme_infos['author'].'</span></p>'.
			(!empty($theme_infos['desc'][$puntal->user['language']]) ? '<p>'.$theme_infos['desc'][$puntal->user['language']].'</p>' : (!empty($theme_infos['desc']['English']) ? '<p>'.$theme_infos['desc']['English'].'</p>' : '')).
			'</div>'."\n";

		}
	}
	$d->close(); ?>
	</div>
<p class="clearb"><?php echo form::hidden('form_sent',1)."\n".
form::hidden(array('ptkn'),$puntal->getToken()); ?>
<input class="submit" type="submit" value=" <?php echo __('Save') ?> " /></p>
		
</form>

<?php adminPage::close(); ?>
