<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

require dirname(__FILE__).'/../inc/admin/prepend.php';

# Manage tools perms
if (!checkPerm('manage_tools'))
	adminPage::fatalErrorPage(__('You do not have permission to access this page.'));

# Get a tool
if (isset($_REQUEST['t']) && in_array($_REQUEST['t'], $valide_tools))
{
	# Perm
	if (!checkPerm($_REQUEST['t']))
		adminPage::fatalErrorPage(__('You do not have permission to access this page.'));

	l10n::set(dirname(__FILE__).'/tools/'.$_REQUEST['t'].'/locales/'.$puntal->user['language'].'/main');
	require dirname(__FILE__).'/tools/'.$_REQUEST['t'].'/index.php';
}
# List of tools
else {
	
	# Load all tools locales
	foreach ($valide_tools as $t)
	{
		l10n::set(dirname(__FILE__).'/tools/'.$t.'/locales/'.$puntal->user['language'].'/main');
	}
	
	# Display list
	adminPage::open(__('Tools'));
	echo
	'<h2 class="first"><img src="style/img/ico_tools.png" alt="" class="icon" /> '.__('Tools').'</h2>'."\n".
	'<ul>';
	
	if (checkPerm('filemanager'))
		echo '<li><a href="tools.php?t=filemanager">'.__('Files manager').'</a></li>';
	
	if (checkPerm('languages_and_styles'))
		echo '<li><a href="tools.php?t=languages_and_styles">'.__('Users languages and styles').'</a></li>';
	
	echo '</ul>';

	adminPage::close();
}
?>