<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

$common_message = '';
$common_warning = '';
$common_error = '';

require dirname(__FILE__).'/../prepend.php';

# We don't want guest or no-rights group here !
if ($puntal->user['g_id'] != PUN_ADMIN && 
	($puntal->user['is_guest'] || empty($pt_perms[$puntal->user['g_id']])) )
{
	header('Location: '.pt_portal_url);
	exit;
}

# Get admin functions & libs
require dirname(__FILE__).'/functions.php';
require dirname(__FILE__).'/../libs/punbb.php';
require dirname(__FILE__).'/../libs/form.php';

# Loading locales
l10n::set(dirname(__FILE__).'/../../locales/'.$puntal->user['language'].'/admin');

# Store current page name and init globals
$current_page = basename($_SERVER['PHP_SELF']);

$module_id = '';
$block_id = '';

if (!empty($_REQUEST['id']))
{
	if ($current_page == 'module.php')
		$module_id = $_REQUEST['id'];
	
	elseif ($current_page == 'bloc.php')
		$block_id = $_REQUEST['id'];
	
	unset($_REQUEST['id']);
}

$action = !empty($_REQUEST['action']) ? intval($_REQUEST['action']) : 0;

# Menu admin
$menu = new adminMenu;
	
$menu->newMenu('admin',__('Admin menu'),0);
$menu->addItem('admin',__('Puntal administration'),'index.php',($current_page == 'index.php'));
$menu->addItem('admin',__('Puntal configuration'),'settings.php',($current_page == 'settings.php'),checkPerm('puntal_config'));
$menu->addItem('admin',__('Modules'),'modules.php',($current_page == 'modules.php'),checkPerm('manage_modules'));
$menu->addItem('admin',__('Puntal themes'),'themes.php',($current_page == 'themes.php'),checkPerm('puntal_config'));
$menu->addItem('admin',__('Puntoolbar'),'puntoolbar.php',($current_page == 'puntoolbar.php'));
$menu->addItem('admin',__('Smilies Manager'),'smilies.php',($current_page == 'smilies.php'));
$menu->addItem('admin',__('Permissions'),'permissions.php',($current_page == 'permissions.php'),($puntal->user['g_id'] == PUN_ADMIN));
$menu->addItem('admin',__('Administration logs'),'logs.php',($current_page == 'logs.php'),($puntal->user['g_id'] == PUN_ADMIN));
$menu->addItem('admin',__('Tools'),'tools.php',($current_page == 'tools.php'),checkPerm('manage_tools'));

# Menu blocks
$menu->newMenu('blocs',__('Blocks'),100000,true);
$menu->addItem('blocs',__('Blocks positions'),'blocs.php',($current_page == 'blocs.php'),checkPerm('manage_blocs'));


# Valids tools
$valide_tools = array(
	'languages_and_styles',
	'filemanager'
);

# Loading modules
$puntal->modules->loadModules(PT_MODULES_PATH,'admin',$puntal->user['language']);

?>