<?php
# ***** BEGIN LICENSE BLOCK *****
# This file is part of DotClear.
# Copyright (c) 2005 Olivier Meunier and contributors. All rights
# reserved.
#
# DotClear is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# DotClear is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with DotClear; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# ***** END LICENSE BLOCK *****

#
# Adapt  Puntal !
#

class modules
{
	var $path;
	var $ns;
	var $modules = array();
	
	var $id;
	var $mroot;
	
	function modules()
	{
		return;
	}
	
	function loadModules($path,$ns=null,$lang=null)
	{
		$this->path = explode(PATH_SEPARATOR,$path);
		$this->ns = $ns;
		
		foreach ($this->path as $root)
		{
			if (!is_dir($root) || !is_readable($root))
				continue;
			
			if (substr($root,-1) != '/') 
				$root .= '/';
			
			if (($d = @dir($root)) === false)
				continue;
			
			while (($entry = $d->read()) !== false)
			{
				$full_entry = $root.'/'.$entry;
				
				if ($entry != '.' && $entry != '..' && is_dir($full_entry)
				&& file_exists($full_entry.'/_define.php')
				&& !file_exists($full_entry.'/_disabled'))
				{
					$this->id = $entry;
					$this->mroot = $full_entry;
					require $full_entry.'/_define.php';
					$this->id = null;
					$this->mroot = null;
				}
			}
			$d->close();
		}
		
		# Sort plugins
		uasort($this->modules,array($this,'sortModules'));
		
		# Load translation, _prepend and ns_file
		foreach ($this->modules as $id => $m)
		{	
			$this->loadModuleL10N($id,$lang,'main');	
			
			if ($m['installed'])
			{
				if (file_exists($m['root'].'/_prepend.php'))
				{
					$r = require $m['root'].'/_prepend.php';
					
					# If _prepend.php file returns null (ie. it has a void return statement)
					if (is_null($r)) continue;
					
					unset($r);
				}			
				
				if ($ns == 'admin')
					$this->loadModuleL10N($id,$lang,'admin');			
				
				$this->loadNsFile($id,$ns);
			}
		}
	}
	
	function registerModule($name,$desc,$author,$version,$url='',$priority=1000,$page=true)
	{
		/*
		if ($this->ns == 'admin')
		{
			if ($permissions == '' && !$this->core->auth->isSuperAdmin())
				return;
			
			elseif (!$this->core->auth->check($permissions,$this->core->blog->id))
				return;
		}
		*/
		
		if ($this->id)
		{
			$this->modules[$this->id] = array(
			'id' => $this->id,
			'root' => $this->mroot,
			'installed' => defined('pt_mod_'.$this->id),
			'name' => $name,
			'desc' => $desc,
			'author' => $author,
			'version' => $version,
			'url' => $url,
			'priority' => $priority === null ? 1000 : (integer) $priority,
			'page_module' => $page
			);
		}
	}
	
	function loadModuleL10N($id,$lang,$file)
	{
		if (!$lang || !isset($this->modules[$id]))
			return;
		
		$lfile = $this->modules[$id]['root'].'/locales/%s/%s';
		
		if (l10n::set(sprintf($lfile,$lang,$file)) === false && $lang != 'English')
			l10n::set(sprintf($lfile,'English',$file));
	}
		
	function getModules($id=null)
	{
		if ($id && isset($this->modules[$id]))
			return $this->modules[$id];
		
		return $this->modules;
	}
		
	function getInstalledModules()
	{
		$tmp = array();
		foreach ($this->modules as $id=>$m)
		{
			if ($m['installed'])
				$tmp[$id] = $m;
		}
		return $tmp;
	}
	
	function moduleExists($id)
	{
		return isset($this->modules[$id]);
	}
	
	function isDefaultModule($id)
	{
		return (pt_default_module == $id);
	}
	
	function moduleInstalled($id)
	{
		return (isset($this->modules[$id]) && $this->modules[$id]['installed']);
	}
	
	function moduleRoot($id)
	{
		return isset($this->modules[$id]) ? $this->modules[$id]['root'] : null;
	}
	
	function loadNsFiles($ns=null)
	{
		foreach ($this->modules as $k => $v)
			$this->loadNsFile($k,$ns);
	}
	
	function loadNsFile($id,$ns=null)
	{
		switch ($ns)
		{
			case 'admin':
				$this->loadModuleFile($this->modules[$id]['root'].'/_admin.php');
				break;
			case 'public':
				$this->loadModuleFile($this->modules[$id]['root'].'/_public.php');
				break;
		}
	}
	
	function loadModuleFile($________)
	{
		if (!file_exists($________))
			return;
		
		foreach ($GLOBALS as $k => $v)
		{
			$$k =& $GLOBALS[$k];
			global $$k;
		}
		
		require $________;
	}
	
	function sortModules($a,$b)
	{
		if ($a['priority'] == $b['priority'])
			return strcasecmp($a['name'],$b['name']);
		
		return ($a['priority'] < $b['priority']) ? -1 : 1;
	}
}
?>