<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  Bas sur le fichier class.settings.php de DotClear
  Copyright (c) 2005 Olivier Meunier (http://www.dotclear.net/)
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

class settings
{
	var $con;
	var $table;
	var $ns;
	var $settings = array();
	
	function settings(&$con, $table)
	{
		$this->con = $con;
		$this->table = $table;
		$this->ns = '';
		
		$this->__getSettings();
	}
	
	function setNamespace($ns)
	{
		if (preg_match('/^[a-z_]+$/',$ns))
			$this->ns = $ns;
	}
	
	function __getSettings()
	{
		$cur_setting = $this->con->select('SELECT setting_id, setting_ns, setting_value, setting_type, setting_label FROM '.$this->table.' ORDER BY setting_ns, setting_id DESC ') or $GLOBALS['error']->fatalError($this->con->error());
		
		while ($cur_setting->fetch())
		{
			$id = trim($cur_setting->f('setting_id'));
			$value = $cur_setting->f('setting_value');
			$type = $cur_setting->f('setting_type');
			
			if ($type == 'float' || $type == 'double')
				$type = 'float';
			elseif ($type != 'boolean' && $type != 'integer')
				$type = 'string';
			
			settype($value,$type);
			
			$this->settings[$id] = array(
				'ns' => $cur_setting->f('setting_ns'),
				'value' => $value,
				'type' => $type,
				'label' => (string) $cur_setting->f('setting_label')
			);
		}
		return false;
	}
	
	function settingExists($id)
	{
		return isset($this->settings[$id]);
	}
	
	function export()
	{
		foreach ($this->settings as $k => $v)
		{
			if (!defined($k))
				define($k,$v['value']);
		}
	}
	
	function put($id,$value,$type=null,$label=null)
	{
		if ($this->ns == '')
			return false;
		
		if (!preg_match('/^pt_[a-zA-Z0-9_]+$/',$id))
			return false;
		
		if ($type == 'double')
			$type = 'float';
		elseif ($type === null)
		{
			if ($this->settingExists($id))
				$type = $this->settings[$id]['type'];
			else
				$type = 'string';
		}
		elseif ($type != 'boolean' && $type != 'integer' && $type != 'float')
			$type = 'string';
		
		if ($label == null && $this->settingExists($id))
			$label = $this->settings[$id]['label'];
		
		settype($value,$type);
		
		if ($this->settingExists($id) && $this->ns == $this->settings[$id]['ns'])
		{
			$strReq = 'UPDATE '.$this->table.' SET '.
					"setting_value = '".$this->con->escapeStr($value)."', ".
					"setting_type = '".$this->con->escapeStr($type)."', ".
					"setting_label = '".$this->con->escapeStr($label)."' ".
					"WHERE setting_id = '".$this->con->escapeStr($id)."' ";
		}
		else {
			$strReq = 'INSERT INTO '.$this->table.' '.
					'(setting_id,setting_ns,setting_value,'.
					'setting_type,setting_label) VALUES '."\n".' ('.
					"'".$this->con->escapeStr($id)."',".
					"'".$this->con->escapeStr($this->ns)."',".
					"'".$this->con->escapeStr($value)."',".
					"'".$this->con->escapeStr($type)."',".
					"'".$this->con->escapeStr($label)."'".
					') ';
		}
		
		$this->con->execute($strReq) or $GLOBALS['error']->fatalError($this->con->error());
		
		return true;
	}
	
	function drop($id)
	{
		$strReq = 'DELETE FROM '.$this->table.' '.
				"WHERE setting_id = '".$this->con->escapeStr($id)."' ";
				
		$this->con->execute($strReq) or $GLOBALS['error']->fatalError($this->con->error());
		
		return true;
	}
	
}
?>