<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

define('STEP',4);

require dirname(__FILE__).'/prepend.php';

$err = '';

if (file_exists(dirname(__FILE__).'/../inc/config.php'))
{
	require dirname(__FILE__).'/../inc/config.php';
	
	if ($db_type != 'mysql' && $db_type != 'mysqli')
	{
		$err = __('Puntal 2 only support MySQL. Its seem that you use another type of database which is not supported by Puntal 2. Sorry but you will not be able to install Puntal.');
	}
	else {
		# On tente une connexion
		$con = new connection($db_username,$db_password,$db_host,$db_name);
		if ($con->error())
		{
			$err = $con->error();
		}
		else {
			$ses->reg('db_host',$db_host);
			$ses->reg('db_username',$db_username);
			$ses->reg('db_password',$db_password);
			$ses->reg('db_name',$db_name);
			$ses->reg('db_prefix',$db_prefix);
			
			$ses->reg('step',5);
			header('Location: db-install.php');
			exit;
		}
	}
}
else {
	$err = __('Unable to find the configuration file. Please copy the <code>config.php</code> file of your PunBB forums in the directory <code>/inc</code> of Puntal.');
}

# Affichage
require dirname(__FILE__).'/header.php'; 

echo '<h2 class="first">'.__('Database installation').'</h2>';

if (!empty($err))
	echo '<p><img src="'.$img_chk_off.'" alt="error" class="icon" /> '.$err.'</p>';

?>
	<form action="db-check.php" method="post">
	<p><input type="submit" class="submit" value="<?php echo __('Next') ?> &#187;" /></p>
	</form>
<?php require dirname(__FILE__).'/footer.php'; ?>