<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

define('STEP',6);

require dirname(__FILE__).'/prepend.php';

l10n::set(dirname(__FILE__).'/../locales/'.$ses->f('lang').'/admin');

$error = new error;

# Tentons de deviner le rpertoire de Putnal
if (!empty($_SERVER['SCRIPT_NAME']))
	$guessed_path = str_replace('install', '', str_replace('\\', '/', dirname($_SERVER['SCRIPT_NAME'])));
elseif (!empty($_SERVER['REQUEST_URI']))
	$guessed_path = str_replace('install/settings.php', '', str_replace('\\', '/', $_SERVER['REQUEST_URI']));
else
	$guessed_path = '/';

# Valeurs par dfaut
$p_title = 'Puntal';
$p_desc = 'Mini portail pour PunBB';
$p_path = $guessed_path;
$p_url = $guessed_path.'index.php/';
$p_forum_url = '/forums/';
$p_url_scan = 'path_info';

# Si le formulaire a t envoy
if (!empty($_POST['config_sended']))
{
	require dirname(__FILE__).'/../inc/classes/checklist.php';
	$con = new connection($ses->f('db_username'),$ses->f('db_password'),$ses->f('db_host'),$ses->f('db_name'));
	$pt_settings = new settings($con, $ses->f('db_prefix').'pt_setting');

	$p_title = trim($_POST['p_title']);
	$p_desc = trim($_POST['p_desc']);
	$p_path = trim($_POST['p_path']);
	$p_url = trim($_POST['p_url']);
	$p_forum_url = trim($_POST['p_forum_url']);
	$p_url_scan = trim($_POST['p_url_scan']);
	
	# Titre portail requis
	if ($p_title == '')
		$error->setError(__('You must give a title for your portal.'));
	
	# Chemin portail requis
	if ($p_path == '')
		$error->setError(__('You must give an application path.'));
	# Correction chemin portail
	else {
		$p_path = preg_replace('|^/+|','',$p_path);
		$p_path = '/'.$p_path;		
	}
	
	# URL portail requise
	if ($p_url == '')
		$error->setError(__('You must give a portal <acronym title="Uniform Resource Locator">URL</acronym>.'));
	# Correction URL portail
	else {
		$p_url = preg_replace('|^/+|','',$p_url);
		$p_url = '/'.$p_url;
	}
	
	# URL forums requise
	if ($p_forum_url == '')
		$error->setError(__('You must give a forums <acronym title="Uniform Resource Locator">URL</acronym>.'));
	# Correction URL forums
	else {
		$p_forum_url = str_replace('index.php','',$p_forum_url);
		$p_forum_url = preg_replace('|/+$|','',$p_forum_url);
		$p_forum_url = preg_replace('|^/+|','',$p_forum_url);
		$p_forum_url = '/'.$p_forum_url.'/';
	}
	
	# Test du $_SERVER['DOCUMENT_ROOT']
	if (realpath($_SERVER['DOCUMENT_ROOT'].$p_path) != realpath(dirname(__FILE__).'/../'))
		$error->setError(sprintf(__('<code>$_SERVER[\'DOCUMENT_ROOT\']</code> or application path is not valid. If you are sure of application path that you gave please open the file puntal_config.php in order to put the good <code>$_SERVER[\'DOCUMENT_ROOT\']</code> you can try this <code>dirname(__FILE__).\'/../\'</code> or this <code>%s</code>'),realpath(dirname(__FILE__).'/../')));
	
	# Test de l'URL des forums
	elseif (!file_exists($_SERVER['DOCUMENT_ROOT'].$p_forum_url.'config.php'))
		$error->setError(__('The forums <acronym title="Uniform Resource Locator">URL</acronym> which you gave does not seem valid.'));
	
	# Si pas d'erreur...
	if (!$error->hasError())
	{		
		$params = array();
		
		$params[] = array(
			'name'		=>	'pt_version',
			'type'		=>	'string',
			'init'		=>	PT_VERSION
		);


		$params[] = array(
				'name'=>'pt_puntal_cache_ttl',
				'type'=>'integer',
				'init'=>60
		);
				
		$params[] = array(
			'name'		=>	'pt_portal_title',
			'type'		=>	'string',
			'init'		=>	$p_title
		);
		
		$params[] = array(
			'name'		=>	'pt_portal_desc',
			'type'		=>	'string',
			'init'		=>	$p_desc
		);
		
		$params[] = array(
			'name'		=>	'pt_announcement',
			'type'		=>	'boolean',
			'init'		=>	false
		);
		
		$params[] = array(
			'name'		=>	'pt_additional_navlinks',
			'type'		=>	'string',
			'init'		=>	'0 = <a href="'.$p_url.'">Portail</a>'
		);
		
		$params[] = array(
			'name'		=>	'pt_default_module',
			'type'		=>	'string',
			'init'		=>	'news'
		);
		
		$params[] = array(
			'name'		=>	'pt_admin_notes',
			'type'		=>	'string',
			'init'		=>	''
		);
		
		$params[] = array(
			'name'		=>	'pt_perms',
			'type'		=>	'string',
			'init'		=>	'a:2:{i:2;a:0:{}i:4;a:0:{}}'
		);
		
		$params[] = array(
			'name'		=>	'pt_theme',
			'type'		=>	'string',
			'init'		=>	'puntal'
		);
		
		$params[] = array(
			'name'		=>	'pt_portal_path',
			'type'		=>	'string',
			'init'		=>	$p_path
		);
		
		$params[] = array(
			'name'		=>	'pt_portal_url',
			'type'		=>	'string',
			'init'		=>	$p_url
		);
		
		$params[] = array(
			'name'		=>	'pt_forum_url',
			'type'		=>	'string',
			'init'		=>	$p_forum_url
		);
		
		$params[] = array(
			'name'		=>	'pt_url_scan',
			'type'		=>	'string',
			'init'		=>	$p_url_scan
		);
		
		$params[] = array(
			'name'		=>	'pt_date_format',
			'type'		=>	'string',
			'init'		=>	__('local_date_format')
		);
		
		$params[] = array(
			'name'		=>	'pt_time_format',
			'type'		=>	'string',
			'init'		=>	__('local_time_format')
		);
		
	
		$params[] = array(
			'name'		=>	'pt_auto_search_updates',
			'type'		=>	'boolean',
			'init'		=>	false
		);
		
		$params[] = array(
			'name'		=>	'pt_send_real_xml',
			'type'		=>	'boolean',
			'init'		=>	false
		);
		
		$params[] = array(
			'name'		=>	'pt_nav_sidebar',
			'type'		=>	'string',
			'init'		=>	'a:3:{i:0;s:12:"classic_menu";i:1;s:5:"login";i:2;s:12:"modules_list";}'
		);
		
		$params[] = array(
			'name'		=>	'pt_extra_sidebar',
			'type'		=>	'string',
			'init'		=>	'a:2:{i:0;s:11:"custom_menu";i:1;s:15:"custom_menu_bis";}'
		);
		#puntoolbar	
			
		$params[] = array(
				'name'=>'pt_ptb',
				'type'=>'integer',
				'init'=>1
		);
		$params[] = array(
				'name'=>'pt_ptb_img_pack',
				'type'=>'string',
				'init'=>'smooth'
		);
		
		$params[] = array(
				'name'=>'pt_ptb_nb_smilies',
				'type'=>'integer',
				'init'=>12
		);
		$params[] = array(
				'name'=>'pt_ptb_smilies_pop_up_width',
				'type'=>'integer',
				'init'=>120
		);
		$params[] = array(
				'name'=>'pt_ptb_smilies_pop_up_height',
				'type'=>'integer',
				'init'=>150
		);
		$params[] = array(
				'name'=>'pt_ptb_bt_b',
				'type'=>'integer',
				'init'=>1
		);
		$params[] = array(
				'name'=>'pt_ptb_bt_i',
				'type'=>'integer',
				'init'=>1
		);		
		$params[] = array(
				'name'=>'pt_ptb_bt_u',
				'type'=>'integer',
				'init'=>1
		);
		$params[] = array(
				'name'=>'pt_ptb_bt_s',
				'type'=>'integer',
				'init'=>1
		);		
		$params[] = array(
				'name'=>'pt_ptb_bt_q',
				'type'=>'integer',
				'init'=>1
		);		
		$params[] = array(
				'name'=>'pt_ptb_bt_c',
				'type'=>'integer',
				'init'=>1
		);		
		$params[] = array(
				'name'=>'pt_ptb_bt_acr',
				'type'=>'integer',
				'init'=>1
		);		
		$params[] = array(
				'name'=>'pt_ptb_bt_col',
				'type'=>'integer',
				'init'=>1
		);		
		$params[] = array(
				'name'=>'pt_ptb_bt_bq',
				'type'=>'integer',
				'init'=>1
		);				
		$params[] = array(
				'name'=>'pt_ptb_bt_pre',
				'type'=>'integer',
				'init'=>1
		);
		$params[] = array(
				'name'=>'pt_ptb_bt_hr',
				'type'=>'integer',
				'init'=>1
		);		
		$params[] = array(
				'name'=>'pt_ptb_bt_link',
				'type'=>'integer',
				'init'=>1
		);
		$params[] = array(
				'name'=>'pt_ptb_bt_img',
				'type'=>'integer',
				'init'=>1
		);		
		$params[] = array(
				'name'=>'pt_ptb_bt_email',
				'type'=>'integer',
				'init'=>1
		);
		$params[] = array(
				'name'=>'pt_ptb_bt_nospam',
				'type'=>'integer',
				'init'=>1
		);		
		$params[] = array(
				'name'=>'pt_ptb_bt_smilies',
				'type'=>'integer',
				'init'=>1
		);
		$params[] = array(
				'name'=>'pt_ptb_bt_plus',
				'type'=>'integer',
				'init'=>1
		);		
		$params[] = array(
				'name'=>'pt_ptb_bt_min',
				'type'=>'integer',
				'init'=>1
		);		
		$params[] = array(
				'name'=>'pt_ptb_bt_sup',
				'type'=>'integer',
				'init'=>1
		);		
		$params[] = array(
				'name'=>'pt_ptb_bt_sub',
				'type'=>'integer',
				'init'=>1
		);		
		
		$params[] = array(
				'name'=>'pt_ptb_bt_right',
				'type'=>'integer',
				'init'=>1
		);
		$params[] = array(
				'name'=>'pt_ptb_bt_left',
				'type'=>'integer',
				'init'=>1
		);
		$params[] = array(
				'name'=>'pt_ptb_bt_center',
				'type'=>'integer',
				'init'=>1
		);
		
		$params[] = array(
				'name'=>'pt_ptb_bt_justify',
				'type'=>'integer',
				'init'=>1
		);
		
		
		
												
		$params_check = new checkList();
		$pt_settings->setNamespace('puntal');
		foreach ($params as $param)
		{
			$params_check->addItem(
				sprintf(__('Add <em>%s</em> setting'),$param['name']),
				$pt_settings->put($param['name'], $param['init'], $param['type']),
				sprintf(__('Setting <em>%s</em> successfully added'),$param['name']),
				sprintf(__('Unable to add <em>%s</em> setting'),$param['name'])
				);
		}

		require_once PT_INC_PATH.'libs/punbb_parser.php';

		$num_smilies = count($smiley_text);
		for ($i = 0; $i < $num_smilies; ++$i) {
			$query = 'INSERT INTO '.$ses->f('db_prefix').'pt_smilies (image, text, disp_position)  VALUES(\''.$smiley_img[$i].'\', \''.$con->escapeStr($smiley_text[$i]).'\', '.$i.')';
			$con->execute($query) or die($con->error());
		}
				
		$pt_settings->setNamespace('');
			
		if ($params_check->checkAll())
			$ses->reg('step',7);
	}
}


# Affichage
require dirname(__FILE__).'/header.php'; 

echo '<h2 class="first">'.__('Settings').'</h2>';

if (!empty($_POST['config_sended']) && !$error->hasError())
{
	echo $params_check->getHTML($img_chk_on,$img_chk_off,$img_chk_wrn);
	
	if ($params_check->checkAll())
	{
	?>
		<form action="modules.php" method="post">
		<p><input type="submit" class="submit" value="<?php echo __('Next') ?> &#187;" /></p>
		</form>
	<?php
	}
}
else {

	if ($error->hasError()) 
	{
		foreach ($error->getError(false) as $err)
			echo '<p><img src="'.$img_chk_off.'" alt="error" class="icon" /> '.$err[0].'</p>';
	}
?>
	<form action="settings.php" method="post">
		
	<p class="field"><label for="p_title"><?php echo __('Portal title') ?></label>
	<input type="text" id="p_title" name="p_title" size="50" maxlength="255" value="<?php echo html::escapeHTML($p_title) ?>" />
	<span class="desc"><?php echo __('The title of the portal. This field <strong>cannot</strong> contain <acronym title="Hypertext Markup Language">HTML</acronym>.'); ?></span></p>

	<p class="field"><label for="p_desc"><?php echo __('Portal description') ?></label>
	<input type="text" id="p_desc" name="p_desc" size="50" maxlength="255" value="<?php echo html::escapeHTML($p_desc) ?>" />
	<span class="desc"><?php echo __('A short description of portal. This field can contain <acronym title="Hypertext Markup Language">HTML</acronym>.'); ?></span></p>
	
	<p class="field"><label for="p_path"><?php echo __('Application path') ?></label>
	<input type="text" id="p_path" name="p_path" size="50" maxlength="255"  value="<?php echo html::escapeHTML($p_path) ?>" />
	<span class="desc"><?php printf(__('The path of the Puntal directory from %s<br />If you put Puntal at the root of your website, give a simple <code>/</code><br />If you put Puntal in a directory, for example a directory at the root of your website named <code>puntal</code>, give <code>/puntal/</code>'), 'http://'.$_SERVER['HTTP_HOST']) ?></span></p>
	
	<p class="field"><label for="p_url"><?php echo __('Portal <acronym title="Uniform Resource Locator">URL</acronym>') ?></label>
	<input type="text" id="p_url" name="p_url" size="50" maxlength="255"  value="<?php echo html::escapeHTML($p_url) ?>" />
	<span class="desc"><?php printf(__('The <acronym title="Uniform Resource Locator">URL</acronym> of the portal from %s'), 'http://'.$_SERVER['HTTP_HOST']) ?></span></p>
	
	<p class="field"><label for="p_forum_url"><?php echo __('Forums <acronym title="Uniform Resource Locator">URL</acronym>') ?></label>
	<input type="text" id="p_forum_url" name="p_forum_url" size="50" maxlength="255"  value="<?php echo html::escapeHTML($p_forum_url) ?>" />
	<span class="desc"><?php printf(__('The <acronym title="Uniform Resource Locator">URL</acronym> of the forums from %s<br /><strong>Caution!</strong> Be sure to provide exact information, without what you will have errors.'), 'http://'.$_SERVER['HTTP_HOST']) ?></span></p>
	
	<p class="field"><label for="p_url_scan"><?php echo __('<acronym title="Uniform Resource Locator">URL</acronym>s type') ?></label>
	<select id="p_url_scan" name="p_url_scan">
		<option value="path_info"<?php if ($p_url_scan == 'path_info') echo ' selected="selected"'; ?>>Path info</option>
		<option value="query_string"<?php if ($p_url_scan == 'query_string') echo ' selected="selected"'; ?>>Query string</option>
	</select>
	<span class="desc"><?php echo __('The type of <acronym title="Uniform Resource Locator">URL</acronym>s defines the form of <acronym title="Uniform Resource Locator">URL</acronym>s (links) in your portal.') ?></span></p>
	<ul class="desc">
		<li><?php echo __('Query string: yours links will have the <code>http://yourwebsite/puntal/index.php?module/</code> form. This method will function on all the servers. The <acronym title="Uniform Resource Locator">URL</acronym> of the portal must have <code>/index.php?</code> form.') ?></li>
		<li><?php echo __('Path info: yours links will have the <code>http://yourwebsite/puntal/index.php/module/</code> form. This type allows a better referencing and sometimes to simplify <acronym title="Uniform Resource Locator">URL</acronym>s such as for example <code>http://yourwebsite/puntal/module/</code> But this type does not function everywhere. Do not forget either to change the <acronym title="Uniform Resource Locator">URL</acronym> of the portal by adding a / at the end. Thus, the <acronym title="Uniform Resource Locator">URL</acronym> of the portal must have <code>/index.php/</code> form.') ?></li>
	</ul>
	
	<p><input type="hidden" name="config_sended" value="1" />
	<input type="submit" class="submit" value="<?php echo __('Save') ?> &#187;" /></p>
	</form>

<?php
}
require dirname(__FILE__).'/footer.php'; ?>