<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

/**
install_articles<br/>

<strong>FR</strong> La fonction charge de l'installation du module articles.<br/>
<strong>EN</strong> the function in charge of the installation of the article module.
*/
function install_articles()
{
	/* Structure de la base de donnes
	----------------------------------------------------------*/
	$db_scheme = array();
	
	# Structure de la table 'pt_articles'
	$db_scheme[] = array(
		'action' 	=> 'add',
		'table' 	=> DB_PREFIX.'pt_articles',
		'query' 	=> 
		'CREATE TABLE '.DB_PREFIX."pt_articles (
		id 			INT(10) 		UNSIGNED NOT NULL AUTO_INCREMENT,
		title 		VARCHAR(255) 	NOT NULL,
		url 		VARCHAR(255) 	NOT NULL,
		content 	LONGTEXT,
		date 		DATE 			NOT NULL DEFAULT '1970-01-01',
		cat_id 		INT(10) 		DEFAULT NULL,
		status 		TINYINT(1) 		NOT NULL DEFAULT 1,
		tid 		INT(10) 		NOT NULL DEFAULT 0,
		pid 		INT(10) 		NOT NULL DEFAULT 0,
		PRIMARY KEY (id),
		UNIQUE KEY url (url),
		INDEX idx_articles_cat_id (cat_id)
		) TYPE=MyISAM;"
	);
	
	# Structure de la table 'pt_articles_cat'
	$db_scheme[] = array(
		'action' 	=> 'add',
		'table' 	=> DB_PREFIX.'pt_articles_cat',
		'query' 	=> 
		'CREATE TABLE '.DB_PREFIX."pt_articles_cat (
		cat_id 		INT(10) 		UNSIGNED NOT NULL AUTO_INCREMENT,
		cat_name 	VARCHAR(255) 	NOT NULL DEFAULT '',
		cat_url 	VARCHAR(255)	NOT NULL DEFAULT '',
		cat_desc 	TEXT,
		cat_ord 	INT(10) 		NOT NULL DEFAULT 0,
		PRIMARY KEY (cat_id),
		UNIQUE KEY cat_name (cat_name),
		UNIQUE KEY cat_url (cat_url)
		) TYPE=MyISAM;"
	);	

	# Structure de la table 'pt_articles_vote'
	$db_scheme[] = array(
		'action' 	=> 'add',
		'table' 	=> DB_PREFIX.'pt_articles_vote',
		'query' 	=> 
		'CREATE TABLE '.DB_PREFIX."pt_articles_vote (	
		`id_article` INT NOT NULL ,
		`id_user` INT NOT NULL ,
		level INT NOT NULL ,
		INDEX ( `id_article` ),
		INDEX ( `id_user` )
		) ENGINE = MYISAM ;"
	);
	
	/* Paramtres de configuration
	----------------------------------------------------------*/
	$params = array();
	
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_mod_articles_num_home',
		'type' 		=> 'integer',
		'init'		=> 10
	);
	
	$params[] = array(
		'action'	=> 'add',
		'name'	 	=> 'pt_mod_articles_groups',
		'type' 		=> 'string',
		'init' 		=> 'a:2:{i:0;i:2;i:1;i:4;}'
	);
	
	$params[] = array(
		'action'	=> 'add',
		'name'	 	=> 'pt_mod_articles_forum_id',
		'type' 		=> 'integer',
		'init' 		=> 0
	);

	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_mod_articles_mode',
		'type'		=> 'integer',
		'init'		=> 1
	);
		
	/* Installation du module
	----------------------------------------------------------*/
	$GLOBALS['install_module']->install($db_scheme,$params);
}


?>