<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;


require_once PT_INC_PATH.'libs/punbb_parser.php';

# Articles manager
require dirname(__FILE__).'/inc/articles.class.php';
$articles = new articlesManager($puntal);

# Template
require dirname(__FILE__).'/inc/tpl_functions.php';
$pt_template_file = '/articles/main.php';

# FR - Liste des catgories
# EN - List of categories
$cats = $articles->getCat();

# FR - Initialisations
# EN - Initializations

$allowed_groups = unserialize(pt_mod_articles_groups);
$allowed_to_submit = ($puntal->user['is_admin'] || in_array($puntal->user['g_id'], $allowed_groups)) ? true : false;

$articles_mode	= 'home';
$cat_id 		= '';
$p_title 		= '';
$p_cat 			= 0;
$p_content 		= '';

# FR - Titre des articles
# FR - Title of the articles
$pt_custom_title_page[] = __('Articles');

if (!empty($pt_args[1]))
{
	# FR - Affichage du flux RSS
	# EN - Display the RSS feeds
	if ($pt_args[1] == ARTICLES_RSS)
	{
		$articles_mode 		= 'rss';
		$pt_template_file 	= '/articles/rss.php';
		$article_list 		= $articles->getArticles('','',2,'P.date DESC','0,'.pt_mod_articles_num_home);
	}
	
	# FR - vote un article
	# EN - rate an article
	elseif (preg_match('!^([0-9]+)!',$pt_args[1],$match) and isset($pt_args[2]) and $pt_args[2] == ARTICLES_VOTE  and isset($pt_args[3]) and is_numeric($pt_args[3]))	 {
		$article_id = (integer) $pt_args[1];
		$level 		= (integer) $pt_args[3];
		$msg 		= $articles->setVote($article_id,$level);
		
		if ($msg == __('Rate submitted') and pt_mod_articles_mode == 0) {
			
			$articles_tpl = '';
			if (file_exists(PT_THEMES_PATH.pt_theme.'/articles/articles_static.tpl'))
				$tpl_file = PT_THEMES_PATH.pt_theme.'/articles/articles_static.tpl';
			else
				$tpl_file = PT_THEMES_PATH.PT_DEFAULT_THEME.'/articles/articles_static.tpl';
				
			$articles_tpl = file_get_contents($tpl_file) or $puntal->err->fatalError(__('unable_to_open_tpl'));
										
			$fh = @fopen(PT_CACHE_PATH.'/articles/articles-'.$article_id.'.html', 'wb');
			
			if (!$fh)
				$puntal->err->fatalError(__('unable_to_write_articles'));
			
			$article_link_forum = '';
			$article 		= $articles->getArticles($article_id);
			$article_title 	= html::escapeHTML($article->f('title'));
			$article_content = parse_message($article->f('content'),false);
			$article_date 	= $article->f('date');
	
			if (pt_mod_articles_forum_id > 0 and $article->f('tid') > 0 ) 
				$article_link_forum = '<p class="addLinkBottom"><a href="'. pt_forum_url .'post.php?tid='.$article->f('tid').'">'.__('Write a comment') .'</a></p>';
	
			$str = __('Vote to estimate this article') . '<br/>';
			$vote = $articles->getVote($article->f('id'));
			if 	($vote->f('ttl') > 0) {
				$ttl = $vote->f('ttl');
				$rate = $vote->f('ttl_level')/$vote->f('ttl');		
				$str .=  $ttl . ' ' . __('Ratings') . '<br/>';
				$str .= __('Rate :').$rate;
			}
	
			$one  = '<a href="'.pt_portal_url.'/articles/'.$article->f('id').'-'.$article->f('url').'/vote/1" title="'.__('Interesting').'">'.__('Interesting').'</a>';
			$two  = '<a href="'.pt_portal_url.'/articles/'.$article->f('id').'-'.$article->f('url').'/vote/2"  title="'.__('Very Interesting').'">'.__('Very Interesting').'</a>';
			$three= '<a href="'.pt_portal_url.'/articles/'.$article->f('id').'-'.$article->f('url').'/vote/3"  title="'.__('Good').'">'.__('Good').'</a>';				
			$four = '<a href="'.pt_portal_url.'/articles/'.$article->f('id').'-'.$article->f('url').'/vote/4"  title="'.__('Very Good').'">'.__('Very Good').'</a>';		
			$five = '<a href="'.pt_portal_url.'/articles/'.$article->f('id').'-'.$article->f('url').'/vote/5"  title="'.__('A Must Have').'">'.__('A Must Have').'</a>';		
								
			$search = array(
	            '<articleTitle>',
	            '<PublishedOn>',
	            '<articleDate>',
	            '<articleContent>',
	            '<articleVoteLabel>',
	            '<articleStar1>',
	            '<articleStar2>',
	            '<articleStar3>',
	            '<articleStar4>',
	            '<articleStar5>',
	            '<articleLinkForum>'
				);
				
			$replace = array(            
				$article_title,
				__('Published on'),
				dt::str(pt_date_format, strtotime($article_date)),
				$article_content,
				$str,
				$one,
				$two,
				$three,
				$four,
				$five,
				$article_link_forum
				);
	
			fwrite($fh, str_replace($search, $replace, $articles_tpl));
			fclose($fh);
			
		} 
		$puntal->redirect($puntal->url('articles'),$msg);		
	}
	
	# FR - Soumission d'un article
	# EN - Submition of an article
	else if ($pt_args[1] == ARTICLES_SUBMIT && $allowed_to_submit)
	{
		$articles_mode = 'submit';
		
		$pt_custom_title_page[] = __('Submit an article');
		
		$cats = $articles->getCat();
		if ($cats->isEmpty())
			$puntal->err->fatalNotice(__('The administrator did not define a category for the articles yet.'));
		
		if (!empty($_POST['form_sent']) && $puntal->checkToken())
		{
			$errors = array();
			$article_link_forum = '';
			
			$p_title 	= trim($_POST['p_title']);
			$p_cat 		= intval($_POST['p_cat']);
			$p_content 	= trim($_POST['p_content']);
				
			if (empty($p_title))
				$errors[] = __('You must give a title for the article.');
			
			if (empty($p_content))
				$errors[] = __('You must give a content for the article.');
			
			if (empty($errors))
			{
				$t_infos = array('tid'=>0,'pid'=>0);
				$status = 3;
				
				if ( $puntal->user['g_id'] == PUN_ADMIN or $punal->user['g_id'] == PUN_MOD ) {
					if (pt_mod_articles_forum_id > 0) {
						require_once PT_INC_PATH.'libs/punbb.php';
						$t_infos = punbb::newTopic(pt_mod_articles_forum_id,$p_title,$p_content,true,false,false,'','',true);
						$article_link_forum = '<p class="addLinkBottom"><a href="'. pt_forum_url .'post.php?tid='.$t_infos['tid'].'">'.__('Write a comment') .'</a></p>';																
					}
					$status = 2;
				}
				if ( ($article_id = $articles->setArticle($p_title,$p_cat,$p_content,date('Y-m-d'),$status,'','',$t_infos['tid'],$t_infos['pid'])) !== false) {										

					if (pt_mod_articles_mode == 0 and  ( $puntal->user['g_id'] == PUN_ADMIN or $punal->user['g_id'] == PUN_MOD )) {
						
						if (file_exists(PT_THEMES_PATH.pt_theme.'/articles/articles_static.tpl'))
							$tpl_file = PT_THEMES_PATH.pt_theme.'/articles/articles_static.tpl';
						else
							$tpl_file = PT_THEMES_PATH.PT_DEFAULT_THEME.'/articles/articles_static.tpl';
						
						$articles_tpl = file_get_contents($tpl_file) or $puntal->err->fatalError(__('unable_to_open_tpl'));
											
						$fh = @fopen(PT_CACHE_PATH.'/articles/articles-'.$article_id.'.html', 'wb');
			
						if (!$fh)
							$puntal->err->fatalError(__('unable_to_write_articles'));
			
						$article_title = html::escapeHTML($p_title);
					
						$article_content = parse_message($p_content,false);
						$article_date = date('Y-m-d');
										
						$search = array(
				            '<articleTitle>',
				            '<PublishedOn>',
				            '<articleDate>',
				            '<articleContent>',
				            '<articleLinkForum>'
							);
							
						$replace = array(            
							$article_title,
							__('Published on'),
							dt::str(pt_date_format, strtotime($article_date)),
							$article_content,
							$article_link_forum
							);
				
						fwrite($fh, str_replace($search, $replace, $articles_tpl));
						fclose($fh);
						
											
					}
					$puntal->redirect($puntal->url('articles'), __('Article submited. It is on standby of validation.'));										
				}					
			}
		} else 
			#Security Token Set !
			$puntal->setToken();
	}
	
	# FR - Affichage d'une catgorie (commence par une majuscule)
	# EN - Display the category (begin by a uppercase

	elseif (preg_match('!^([A-Z][A-Za-z0-9_-]*)!',$pt_args[1],$match))
	{
		$articles_mode = 'cat';
		$cat_id = $match[1];
		
		$article_list = $articles->getArticles('',$cat_id,2);
		$cat = $articles->getCat($cat_id);
	}

	# FR - Affichage d'un article (commence par un identifiant numrique)
	# EN - Display an article (begin by a numeric id)
	elseif (preg_match('!^([0-9]+)!',$pt_args[1],$match))
	{
		$articles_mode = 'article_static';
		$article_id = $match[1];
		
		if ( pt_mod_articles_mode == 1 ) {
	 		$articles_mode 			= 'article_dynamic';
	 		
			$article 				= $articles->getArticles($article_id);			
			$pt_custom_title_page[] = $article->f('title');			
			$cat_id 				= $article->f('cat_id');
			
			$article_list 			= $articles->getArticles('',$cat_id,2);
			$cat 					= $articles->getCat($cat_id);
			$vote 					= $articles->getVote($article_id);
			
			if ($article->f('tid') > 0)
			{
				require_once PT_INC_PATH.'libs/punbb.php';
				if (($comments = punbb::getTopicPosts($article->f('tid'),'',$article->f('pid'))) === false)
					$puntal->err->fatalError();
				require_once PT_INC_PATH.'libs/punbb_parser.php';
			}
		}
	}
}

# FR - Affichage index du module si aucun autre mode n'est activ
# EN - Display the index of the module if no other mode is activated
if ($articles_mode == 'home')
{
	$article_list = $articles->getArticles('',$cat_id,2,'P.date DESC','0,'.pt_mod_articles_num_home);
}

?>