<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

/**
	
	@brief publicBlocks module class
	
	<strong>FR</strong> La classe d'affichage des blocs publiques<br/>	
	<strong>EN</strong> The class that displays the publics blocks
*/
class publicBlocks
{
	/**
	active_topics<br/>
	
	<strong>FR</strong> Affiche le bloc des discussion actives<br/>
	<strong>EN</strong> Display the bloc of active topics
	*/	
	function active_topics()
	{
		if (pt_bloc_active_topics ) {
			
			global $puntal;
						
			$bloc = '';
		
			if (! file_exists(PT_CACHE_PATH.'blocks/active_topics.html') or
				 ( filemtime(PT_CACHE_PATH.'blocks/active_topics.html') + pt_puntal_cache_ttl < time())
				 )
			 {					
				$fh = @fopen(PT_CACHE_PATH.'blocks/active_topics.html', 'wb');
				if (!$fh)
					$puntal->err->fatalError(__('Unable to write active_topics.html cache file'));					
				
				$strQuery = 'SELECT t.id, t.subject FROM '.DB_PREFIX.'topics AS t INNER JOIN '.DB_PREFIX.'forums AS f ON f.id=t.forum_id LEFT JOIN '.DB_PREFIX.'forum_perms AS fp ON (fp.forum_id=f.id AND fp.group_id='.$puntal->user['g_id'].') WHERE (fp.read_forum IS NULL OR fp.read_forum=1) AND t.moved_to IS NULL'.((pt_bloc_active_topics_fid != '') ? ' AND f.id IN('.pt_bloc_active_topics_fid.')' : '').' ORDER BY t.last_post DESC LIMIT '.pt_bloc_active_topics_num;		
				$pt_active_topics = $puntal->con->select($strQuery) or $puntal->err->fatalError('Impossible de retrouver la liste des discussions', $puntal->con->error());
				
				if (!$pt_active_topics->isEmpty())
				{
					$bloc = startBlocStatic(__('Actives topics'), 'active_topics');
					$bloc .= "\t\t\t\t".'<ul>'."\n";
					
					while ($pt_active_topics->fetch())
					{
						if ($puntal->pun_config['o_censoring'] == '1')
							$pt_active_topics->setField('subject',$puntal->censor_words($pt_active_topics->f('subject')));
					
						if ((pt_bloc_active_topics_max_len > 0) && (strlen($pt_active_topics->f('subject')) > pt_bloc_active_topics_max_len))
							$bloc .= "\t\t\t\t\t".'<li><a href="'.pt_forum_url.'viewtopic.php?id='.$pt_active_topics->f('id').'&amp;action=new" title="'.html::escapeHTML($pt_active_topics->f('subject')).'">'.html::escapeHTML(trim(substr($pt_active_topics->f('subject'), 0, (pt_bloc_active_topics_max_len-5)))).' ...'.'</a></li>'."\n";
						else 
							$bloc .= "\t\t\t\t\t".'<li><a href="'.pt_forum_url.'viewtopic.php?id='.$pt_active_topics->f('id').'&amp;action=new">'.html::escapeHTML($pt_active_topics->f('subject')).'</a></li>'."\n";
					}
					
					$bloc .=  "\t\t\t\t".'</ul>'."\n";
					$bloc .= endBlocStatic();
				
				fwrite($fh, $bloc);				
				}
				include PT_CACHE_PATH.'blocks/active_topics.html';				
			} 
			else  
				include PT_CACHE_PATH.'blocks/active_topics.html';			
				
		}
	}
	
	
	/**
	classic_menu<br/>
	
	<strong>FR</strong> Affiche le bloc menu classique<br/>
	<strong>EN</strong> Display the bloc of classic menu
	*/		
	function classic_menu()
	{
		global $puntal;
		
		// Index and Userlist should always be displayed
		$pt_links[] = '<li id="navindex2"><a href="'.pt_forum_url.'index.php">'.__('Forums').'</a>';
		$pt_links[] = '<li id="navuserlist2"><a href="'.pt_forum_url.'userlist.php">'.__('User list').'</a>';
	
		if ($puntal->pun_config['o_rules'] == '1')
			$pt_links[] = '<li id="navrules2"><a href="'.pt_forum_url.'misc.php?action=rules">'.__('Rules').'</a>';
	
		if ($puntal->user['is_guest'])
		{
			if ($puntal->user['g_search'] == '1')
				$pt_links[] = '<li id="navsearch2"><a href="'.pt_forum_url.'search.php">'.__('Search').'</a>';
	
			$pt_links[] = '<li id="navregister2"><a href="'.pt_forum_url.'register.php">'.__('Register').'</a>';
			$pt_links[] = '<li id="navlogin2"><a href="'.pt_forum_url.'login.php">'.__('Login').'</a>';
		}
		else
		{
			if ($puntal->user['g_id'] > PUN_MOD)
			{
				if ($puntal->user['g_search'] == '1')
					$pt_links[] = '<li id="navsearch2"><a href="'.pt_forum_url.'search.php">'.__('Search').'</a>';
	
				$pt_links[] = '<li id="navprofile2"><a href="'.pt_forum_url.'profile.php?id='.$puntal->user['id'].'">'.__('Profile').'</a>';
				$pt_links[] = '<li id="navlogout2"><a href="'.pt_portal_url.'logout/">'.__('Logout').'</a>';
			}
			else
			{
				$pt_links[] = '<li id="navsearch2"><a href="'.pt_forum_url.'search.php">'.__('Search').'</a>';
				$pt_links[] = '<li id="navprofile2"><a href="'.pt_forum_url.'profile.php?id='.$puntal->user['id'].'">'.__('Profile').'</a>';
				$pt_links[] = '<li id="navadmin2"><a href="'.pt_portal_path.'admin/index.php">'.__('Puntal administration').'</a>';
				$pt_links[] = '<li id="navlogout2"><a href="'.pt_portal_url.'logout/">'.__('Logout').'</a>';
			}
		}
	
		// Are there any additional navlinks we should insert into the array before imploding it?
		if (pt_additional_navlinks != '')
		{
			if (preg_match_all('#([0-9]+)\s*=\s*(.*?)\n#s', pt_additional_navlinks."\n", $extra_links))
			{
				// Insert any additional links into the $pt_links array (at the correct index)
				for ($i = 0; $i < count($extra_links[1]); ++$i)
					array_splice($pt_links, $extra_links[1][$i], 0, array('<li id="navextra2'.($i + 1).'">'.$extra_links[2][$i]));
			}
		}
		
		startBloc(__('Menu'), 'classic_menu');
		echo "\t\t\t\t".'<ul>'."\n\t\t\t\t\t".implode(__('Link separator').'</li>'."\n\t\t\t\t\t", $pt_links).'</li>'."\t\t\t\t\n".'</ul>';
		endBloc();
	}
	
	

	/**
	custom_bloc<br/>
	
	<strong>FR</strong> Affiche le contenu du bloc personnalis<br/>
	<strong>EN</strong> Display the content of the custom bloc
	*/	
	function custom_bloc()
	{
		if (pt_bloc_custom_bloc ) {	
			startBloc(html::escapeHTML(pt_bloc_custom_bloc_title), 'custom_bloc');
			echo parse_message(pt_bloc_custom_bloc_content,false);				 
			endBloc();
		}
	}
	
	
	/**
	custom_bloc_bis<br/>
	
	<strong>FR</strong> Affiche le contenu du bloc personnalis 2<br/>
	<strong>EN</strong> Display the content of the custom bloc 2
	*/	
	function custom_bloc_bis()
	{
		if (pt_bloc_custom_bloc_bis ) {			
			startBloc(html::escapeHTML(pt_bloc_custom_bloc_bis_title), 'custom_bloc_bis');
			echo parse_message(pt_bloc_custom_bloc_bis_content,false);				 
			endBloc();
		}			
	}
	
	
	/**
	custom_menu<br/>
	
	<strong>FR</strong> Affiche le contenu du menu personnalis<br/>
	<strong>EN</strong> Display the content of the custom menu
	*/	
	function custom_menu()
	{
		if (pt_bloc_custom_menu ) {
			startBloc(html::escapeHTML(pt_bloc_custom_menu_title), 'custom_menu');
				
			echo "\t\t\t\t".'<ul>'."\n";
			$pt_custom_links = unserialize(pt_bloc_custom_menu_content);
			
			for ($i = 0; $i < count($pt_custom_links); ++$i)
				echo "\t\t\t\t\t".'<li id="navcustom1-'.($i+1).'">'.$pt_custom_links[$i].'</li>'."\n";
			
			echo "\t\t\t\t".'</ul>'."\n";
			endBloc();
		}
	}
	

	/**
	custom_menu_bis<br/>
	
	<strong>FR</strong> Affiche le contenu du menu personnalis 2<br/>
	<strong>EN</strong> Display the content of the custom menu 2
	*/		
	function custom_menu_bis()
	{
		if (pt_bloc_custom_menu ) {
			startBloc(html::escapeHTML(pt_bloc_custom_menu_bis_title), 'custom_menu_bis');
				
			echo "\t\t\t\t".'<ul>'."\n";
			$pt_custom_links = unserialize(pt_bloc_custom_menu_bis_content);
			
			for ($i = 0; $i < count($pt_custom_links); ++$i)
				echo "\t\t\t\t\t".'<li id="navcustom2-'.($i+1).'">'.$pt_custom_links[$i].'</li>'."\n";
			
			echo "\t\t\t\t".'</ul>'."\n";
			endBloc();
		}
	}
	
	

	/**
	edito<br/>
	
	<strong>FR</strong> Affiche le contenu du bloc edito<br/>
	<strong>EN</strong> Display the content of the bloc edito
	*/			
	function edito()
	{
		if (pt_bloc_edito ) {
			startBloc(html::escapeHTML(pt_bloc_edito_titre),'edito');
			echo parse_message(pt_bloc_edito_message,false);
			endBloc();
		}
	}
	

	/**
	lang_switcher<br/>
	
	<strong>FR</strong> Affiche le bloc commutateur de langue<br/>
	<strong>EN</strong> Display the bloc lang switcher
	*/			
	function lang_switcher()
	{
		global $puntal;
		
		if (!$puntal->user['is_guest'])
		{
			$pt_languages = array();
			
			$d = dir(PUN_ROOT.'lang');
			while (($entry = $d->read()) !== false)
			{
				if ($entry != '.' && $entry != '..' && is_dir(PUN_ROOT.'lang/'.$entry) && file_exists(PUN_ROOT.'lang/'.$entry.'/common.php'))
					$pt_languages[] = $entry;
			}
			$d->close();
			
			if (count($pt_languages) > 1)
			{
				natsort($pt_languages);
				
				startBloc(__('Languages'), 'lang_switcher');
		?>
						<form action="<?php echo pt_portal_url; ?>" method="post">
							<div class="inform">
								<input type="hidden" name="change_lang" value="1" />
								<input type="hidden" name="redirect_url" value="<?php echo $_SERVER['REQUEST_URI']; ?>" />
								<label for="language"><?php echo __('Choose your language'); ?></label><br />
								<select id="language" name="language">
		<?php 
			while (list(, $temp) = @each($pt_languages))
			{
				if ($puntal->user['language'] == $temp)
					echo "\t\t\t\t\t\t\t".'<option value="'.$temp.'" selected="selected">'.$temp.'</option>'."\n";
				else
					echo "\t\t\t\t\t\t\t".'<option value="'.$temp.'">'.$temp.'</option>'."\n";
			}
		?>
								</select>&#160;&#160;
								<input type="submit" name="submit" class="submit" value="<?php echo __('Change'); ?>" />
							</div>
						</form>		
		<?php
				endBloc();
			}
		}
	}
	
	
	/**
	login<br/>
	
	<strong>FR</strong> Affiche le bloc d'identification si l'utilisateur n'est pas identifi.<br/>
	<strong>EN</strong> Display the bloc login if the user is not logged
	*/				
	function login()
	{
		if ($GLOBALS['puntal']->user['is_guest'])
		{
			startBloc(__('Login'), 'login');
		?>
					<form method="post" action="<?php echo pt_portal_url ?>">
					<div class="inform">
						<input type="hidden" name="login" value="1" />
						<input type="hidden" name="redirect_url" value="<?php echo $_SERVER['REQUEST_URI'] ?>" />
						
						<p class="field"><label for="req_username"><?php echo __('Username') ?></label>
						<input type="text" name="req_username" id="req_username" size="13" maxlength="25" /></p>
						
						<p class="field"><label for="req_password"><?php echo __('Password') ?></label>
						<input type="password" name="req_password" id="req_password" size="13" maxlength="16" /></p>
						
						<p><input type="submit" class="submit" value="<?php echo __('Login') ?>" /></p>
					</div>
					</form>	
					<p><a href="<?php echo pt_forum_url; ?>register.php"><?php echo __('Not registered') ?></a><br />
					<a href="<?php echo pt_forum_url; ?>login.php?action=forget"><?php echo __('Forgotten pass') ?></a></p>
		<?php 
			endBloc();
		}
	}
	

	/**
	modules_list<br/>
	
	<strong>FR</strong> Affiche le bloc liste de modules<br/>
	<strong>EN</strong> Display the bloc module list
	*/				
	function modules_list()
	{
		if (pt_bloc_modules_list ) {		
			global $puntal;
		
			startBloc(html::escapeHTML(pt_bloc_modules_list_title), 'modules_list');
			
			echo "\t\t\t\t".'<ul>'."\n";
			foreach ($puntal->modules->getInstalledModules() as $module)
			{
				if (constant('pt_mod_'.$module['id']) && $module['page_module'])
				{
					if ($GLOBALS['pt_current_module'] == $module['id'])
						echo "\t\t\t\t\t".'<li class="active"><a href="'.$puntal->url($module['id']).'">'.__($module['name']).'</a></li>'."\n";
					else
						echo "\t\t\t\t\t".'<li><a href="'.$puntal->url($module['id']).'">'.__($module['name']).'</a></li>'."\n";
				}
			}
			echo "\n\t\t\t\t".'</ul>';
			
			endBloc();
		}
	}
	
	/**
	online<br/>
	
	<strong>FR</strong> Affiche le bloc utilisateurs en ligne<br/>
	<strong>EN</strong> Display the bloc of the online users
	*/		
	function online()
	{
		global $puntal;
		
		$num_guests = $num_users = 0;
		$users = array();
		
		$user_list = $puntal->con->select('SELECT user_id, ident FROM '.DB_PREFIX.'online WHERE idle=0 ORDER BY ident') or $puntal->err->fatalError('Impossible de retrouver la liste des utilisateurs en ligne', $puntal->con->error());
		
		while ($user_list->fetch())
		{
			if ($user_list->f('user_id') > 1)
			{
				$users[] = '<a href="'.pt_forum_url.'profile.php?id='.$user_list->f('user_id').'">'.html::escapeHTML($user_list->f('ident')).'</a>';
				++$num_users;
			}
			else
				++$num_guests;
		}
		
		startBloc(__('Currently online'), 'online');
		echo "\t\t\t\t".'<ul>'."\n";
		echo "\t\t\t\t\t".'<li>'.__('Guests online').' '.$num_guests.'</li>'."\n";
		echo "\t\t\t\t\t".'<li>'.__('Members online').' '.$num_users.'</li>'."\n";
		if ($num_users > 0)
			echo "\t\t\t\t\t".'<li>'.__('Currently online:').' '.implode(', ', $users).'</li>'."\n";
		echo "\t\t\t\t".'</ul>'."\n";
		endBloc();
	}


	/**
	online_today<br/>
	
	<strong>FR</strong> Affiche le bloc utilisateurs en ligne aujourd'hui<br/>
	<strong>EN</strong> Display the bloc of the online users of today
	*/		
	function online_today()
	{
		global $puntal;
		
		$bloc = '';
		if (! file_exists(PT_CACHE_PATH.'blocks/online_today.html') or
			 ( filemtime(PT_CACHE_PATH.'blocks/online_today.html') + pt_puntal_cache_ttl < time())
			 )
		 {					
								
			$fh = @fopen(PT_CACHE_PATH.'blocks/online_today.html', 'wb');
			if (!$fh)
				$puntal->err->fatalError(__('Unable to write online_today.html cache file'));					
	
			$bloc = startBlocStatic(__('Online today'), 'online_today');
		
			$pt_todaystamp = strtotime(date('Y-m-d'));
				
			$users = array();
			
			$strQuery = 'SELECT username, id, last_visit from '.DB_PREFIX.'users WHERE last_visit >= \''.$pt_todaystamp.'\' ORDER by last_visit DESC';			
			$user_list = $puntal->con->select($strQuery) or $puntal->err->fatalError('Impossible de retrouver la liste des utilisateurs en ligne aujourd\'hui', $puntal->con->error());
				
			if (!$user_list->isEmpty())
			{
				while ($user_list->fetch())
					$users[] .=  '<a href="'.pt_forum_url.'profile.php?id='.$user_list->f('id').'" title="'.__('Last visit of').' '.html::escapeHTML($user_list->f('username')).' : '.$puntal->format_time($user_list->f('last_visit')).'">'.html::escapeHTML($user_list->f('username')).'</a>';
			
				$bloc .= '<p>'.implode(', ', $users).'</p>';
			}
			else
				$bloc .=  '<p>'.__('None').'</p>';
			
			$bloc .= endBlocStatic();
			fwrite($fh, $bloc);				
			include PT_CACHE_PATH.'blocks/online_today.html';
		}
		else 
			include PT_CACHE_PATH.'blocks/online_today.html';			 
						
	}
	
	/**
	recent_topics<br/>
	
	<strong>FR</strong> Affiche le bloc discussions rcentes<br/>
	<strong>EN</strong> Display the bloc of the recent topics
	*/			
	function recent_topics()
	{
		if (pt_bloc_recent_topics ) {		
			global $puntal;
			
			$bloc = '';
			if (! file_exists(PT_CACHE_PATH.'blocks/recent_topics.html') or
				 ( filemtime(PT_CACHE_PATH.'blocks/recent_topics.html') + pt_puntal_cache_ttl < time())
				 )
			 {				
				$pt_recent_topics = $puntal->con->select('SELECT t.id, t.subject FROM '.DB_PREFIX.'topics AS t INNER JOIN '.DB_PREFIX.'forums AS f ON f.id=t.forum_id LEFT JOIN '.DB_PREFIX.'forum_perms AS fp ON (fp.forum_id=f.id AND fp.group_id='.$puntal->user['g_id'].') WHERE (fp.read_forum IS NULL OR fp.read_forum=1) AND t.moved_to IS NULL'.((pt_bloc_recent_topics_fid != '') ? ' AND f.id IN('.pt_bloc_recent_topics_fid.')' : '').' ORDER BY t.posted DESC LIMIT '.pt_bloc_recent_topics_num) or $puntal->err->fatalError('Impossible de retrouver la liste des discussions', $puntal->con->error());
				
				if (!$pt_recent_topics->isEmpty())
				{
					$fh = @fopen(PT_CACHE_PATH.'blocks/recent_topics.html', 'wb');
					if (!$fh)
						$puntal->err->fatalError(__('Unable to write recent_topics.html cache file'));
											
					$bloc = startBlocStatic(__('Recent topics'), 'recent_topics');
					
					$bloc .=  "\t\t\t\t".'<ul>'."\n";
							
					while ($pt_recent_topics->fetch())
					{
						if ($puntal->pun_config['o_censoring'] == '1')
							$pt_recent_topics->setField('subject',$puntal->censor_words($pt_recent_topics->f('subject')));
				
						if ((pt_bloc_recent_topics_max_len > 0) && (strlen($pt_recent_topics->f('subject')) > pt_bloc_recent_topics_max_len))
							$bloc .=  "\t\t\t\t\t".'<li><a href="'.pt_forum_url.'viewtopic.php?id='.$pt_recent_topics->f('id').'" title="'.html::escapeHTML($pt_recent_topics->f('subject')).'">'.html::escapeHTML(trim(substr($pt_recent_topics->f('subject'), 0, (pt_bloc_recent_topics_max_len-5)))).' ...'.'</a></li>'."\n";
						else 
							$bloc .=  "\t\t\t\t\t".'<li><a href="'.pt_forum_url.'viewtopic.php?id='.$pt_recent_topics->f('id').'">'.html::escapeHTML($pt_recent_topics->f('subject')).'</a></li>'."\n";
					}
					
					$bloc .=  "\t\t\t\t".'</ul>'."\n";
					
					$bloc .= endBlocStatic();
					
					fwrite($fh, $bloc);				
					include PT_CACHE_PATH.'blocks/recent_topics.html';
					
				}
			 } else 
			 	include PT_CACHE_PATH.'blocks/recent_topics.html';
		}
	}
			
	/**
	recent_topics<br/>
	
	<strong>FR</strong> Affiche le bloc de stats<br/>
	<strong>EN</strong> Display the bloc of stats
	*/				
	function stats()
	{
		global $puntal;
		
		$bloc = '';
		if (! file_exists(PT_CACHE_PATH.'blocks/stats.html') or
			 ( filemtime(PT_CACHE_PATH.'blocks/stats.html') + pt_puntal_cache_ttl < time())
			 )
		 {				
			$fh = @fopen(PT_CACHE_PATH.'blocks/stats.html', 'wb');
			if (!$fh)
				$puntal->err->fatalError(__('Unable to write stats.html cache file'));
					
			$pt_total_users = $puntal->con->select('SELECT COUNT(id)-1 AS total_user FROM '.DB_PREFIX.'users') or $puntal->err->fatalError('Impossible de retrouver le nombre total d\'utilisateurs', $puntal->con->error());
			
			$pt_last_user = $puntal->con->select('SELECT id, username FROM '.DB_PREFIX.'users ORDER BY registered DESC LIMIT 1') or $puntal->err->fatalError('Impossible de retrouver le dernier utilisateur inscrit', $puntal->con->error());
			
			$pt_total_posts = $puntal->con->select('SELECT SUM(num_topics) AS total_topics, SUM(num_posts) AS total_posts FROM '.DB_PREFIX.'forums') or $puntal->err->fatalError('Impossible de retrouver le total de discussions et de messages', $puntal->con->error());
			
			$bloc = startBlocStatic(__('Forums statistics'), 'stats');
			$bloc .= "\t\t\t\t".'<ul>'."\n";
			$bloc .=  "\t\t\t\t\t".'<li>'.__('Total numbers of members:').' '.$pt_total_users->f('total_user').'</li>'."\n";
			$bloc .=  "\t\t\t\t\t".'<li>'.__('Newest resgistered user:').' <a href="'.pt_forum_url.'profile.php?id='.$pt_last_user->f('id').'">'.html::escapeHTML($pt_last_user->f('username')).'</a></li>'."\n";
			$bloc .=  "\t\t\t\t\t".'<li>'.__('Total numbers of topics:').' '.$pt_total_posts->f('total_topics').'</li>'."\n";
			$bloc .=  "\t\t\t\t\t".'<li>'.__('Total numbers of posts:').' '.$pt_total_posts->f('total_posts').'</li>'."\n";
			$bloc .=  "\t\t\t\t".'</ul>'."\n";
			$bloc .= endBlocStatic();
			
			fwrite($fh, $bloc);
			include PT_CACHE_PATH.'blocks/stats.html';
		}
		else 
		 include PT_CACHE_PATH.'blocks/stats.html';
	}
	
			
	/**
	style_switcher<br/>
	
	<strong>FR</strong> Affiche le bloc commutateur de styles<br/>
	<strong>EN</strong> Display the bloc of style switcher
	*/				
	function style_switcher()
	{
		global $puntal;
		
		if (!$puntal->user['is_guest'])
		{ 
			$pt_styles = array();
			
			$d = dir(PUN_ROOT.'style');
			
			while (($entry = $d->read()) !== false)
			{
				if (substr($entry, strlen($entry)-4) == '.css')
					$pt_styles[] = substr($entry, 0, strlen($entry)-4);
			}
			$d->close();
			
			if (count($pt_styles) > 1)
			{
				natsort($pt_styles);
				
				startBloc(__('Styles'), 'style_switcher');
		?>
						<form action="<?php echo pt_portal_url ?>" method="post">
						<div class="inform">
							<input type="hidden" name="change_style" value="1" />
							<input type="hidden" name="redirect_url" value="<?php echo $_SERVER['REQUEST_URI'] ?>" />
							<label for="style"><?php echo __('Choose your favourite style') ?></label><br />
								<select id="style" name="style">
		<?php
			while (list(, $temp) = @each($pt_styles))
			{
				if ($puntal->user['style'] == $temp)
					echo "\t\t\t\t\t\t\t".'<option value="'.$temp.'" selected="selected">'.str_replace('_', ' ', $temp).'</option>'."\n";
				else
					echo "\t\t\t\t\t\t\t".'<option value="'.$temp.'">'.str_replace('_', ' ', $temp).'</option>'."\n";
			}
		?>
								</select>&#160;&#160;
							<input type="submit" name="submit" class="submit" value="<?php echo __('Change') ?>" />
						</div>
						</form>		
		<?php
				endBloc();
			}
		}
	}
	

	/**
	top_posters<br/>
	
	<strong>FR</strong> Affiche le bloc top des posteurs<br/>
	<strong>EN</strong> Display the bloc of the top posters
	*/					
	function top_posters()
	{
		if (pt_bloc_top_posters ) {		
			global $puntal;
			
			$bloc = '';
								
			if (! file_exists(PT_CACHE_PATH.'blocks/top_posters.html') or
				 ( filemtime(PT_CACHE_PATH.'blocks/top_posters.html') + pt_puntal_cache_ttl < time())
				 )
			 {
				$top_poster = $puntal->con->select('SELECT id, username, num_posts FROM '.DB_PREFIX.'users WHERE (num_posts>0) ORDER BY num_posts DESC LIMIT '.pt_bloc_top_posters_num) or $puntal->err->fatalError('Impossible de retrouver la liste des posteurs', $puntal->con->error());			 					
				$fh = @fopen(PT_CACHE_PATH.'blocks/top_posters.html', 'wb');
				if (!$fh)
					$puntal->err->fatalError(__('Unable to write top_posters.html cache file'));
			
				if (!$top_poster->isEmpty())
				{
					$bloc = startBlocStatic(sprintf(__('Top posters'), pt_bloc_top_posters_num), 'top_posters');
					$bloc .= "\t\t\t\t".'<ul>'."\n";
					
					while ($top_poster->fetch())
					{
						$bloc .= "\t\t\t\t\t".'<li><a href="'.pt_forum_url.'profile.php?id='.$top_poster->f('id').'">'.html::escapeHTML($top_poster->f('username')).'</a>'.((pt_bloc_top_posters_posts == 1) ? ' ('.$top_poster->f('num_posts').')' : '').'</li>'."\n";
					}
						
					$bloc .= "\t\t\t\t".'</ul>'."\n";
					$bloc .= endBlocStatic();
					
					fwrite($fh, $bloc);
					include PT_CACHE_PATH.'blocks/top_posters.html';
				}
			 }
			else 
		 		include PT_CACHE_PATH.'blocks/top_posters.html';
		}
	}
}

?>