<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

/*
	Original file by Olivier Meunier and contributors from 
	DotClear project. http://www.dotclear.net/
*/

if (!defined('PUNTAL')) exit;

# Mise hors ligne d'un commentaire
if (!empty($_GET['com_id']))
{
	$_GET['com_id'] = (integer)$_GET['com_id'];
	if (isset($_GET['cancel']))
	{
		if ($blog->statusComment((integer)$_GET['com_id']) !== false)
		{
			$redir = 'module.php?id=blog&action=6';
			$redir .= (!empty($_GET['env'])) ? '&env='.(integer)$_GET['env'] : '';
			header('Location: '.$redir);
			exit;
		}
	}
}

$nb_per_page = 30;
$nb_comments = $blog->getNbComments();

$max_pages = ceil($nb_comments/$nb_per_page);
$env = (!empty($_GET['env']) && (integer)$_GET['env'] <= $max_pages) ? (integer)$_GET['env'] : 1;

$comments = $blog->getComments('','DESC',(($env-1)*$nb_per_page).','.$nb_per_page);

# Ligne pour afficher un commentaire
function ligne_comment($data,$i)
{
	$comment_id = $data['comment_id'];
	$comment_dt = $data['comment_dt'];
	$comment_auteur = $data['comment_auteur'];
	$comment_email = $data['comment_email'];
	$comment_site = $data['comment_site'];
	$comment_content = $data['comment_content'];
	$comment_pub = $data['comment_pub'];
	$comment_ip = $data['comment_ip'];
	$comment_trackback = $data['comment_trackback'];
	$post_titre = $data['post_titre'];
	$post_id = $data['post_id'];
	$comment_date = dt::str(pt_date_format.' '.pt_time_format,strtotime($comment_dt));
	
	$cancel_url = htmlspecialchars($_SERVER['REQUEST_URI']);
	$cancel_url .= (strpos($cancel_url,'?') !== false) ? '&amp;' : '?';
	$cancel_url .= 'com_id='.$comment_id.'&amp;cancel=1';
	
	if ($comment_pub)
		$com_cancel = '<a href="'.$cancel_url.'" title="'.sprintf(__('Put %s offline'),__('comment').' #'.$comment_id).'"><img src="style/img/on.png" class="icon" alt="'.__('Online').'" /></a> ';
	else
		$com_cancel = '<a href="'.$cancel_url.'" title="'.sprintf(__('Put %s online'),__('comment').' #'.$comment_id).'"><img src="style/img/off.png" class="icon" alt="'.__('Offline').'" /></a> ';
	
	$str_tb = ($comment_trackback == 1) ? ' - <strong>trackback</strong>' : '';
	
	require_once PT_INC_PATH."libs/punbb_parser.php";
	$hide_smilies = 1;
	if (pt_blog_use_smilies) $hide_smilies = 0;
	
	$res = 
	"\t".'<div id="comment'.$comment_id.'">'."\n".
	"\t\t".'<h3 class="ligneTitre">'.$com_cancel.
	'<a href="module.php?id=blog&amp;action=2&amp;post_id='.$post_id.'#c'.$comment_id.'">'.
	$post_titre.'</a>'.$str_tb.'</h3>'."\n".
	"\t\t".'<p class="ligneInfo">'.$comment_date.' - '.$comment_auteur.'</p>'."\n".
	parse_message($comment_content,$hide_smilies)."\n".
	"\t".'</div>';
	
	return $res;
}

# Affichage
adminPage::open(__('Comments').' - '.__('Blog'));

echo '<h2 class="first"><img src="style/img/ico_comments.png" alt="" class="icon" /> '.__('Comments').'</h2>';
echo '<p>'.__('Comments listed from most recent to oldest').'</p>';
	
# Liste des commentaires sur plusieurs pages
require PT_INC_PATH.'/classes/multipage.php';

$lum = new multipage($env,'ligne_comment',$comments->getData(),$nb_comments,$nb_per_page);

$lum->setOption('html_block','%s');
$lum->setOption('html_row','%s');
$lum->setOption('html_cell','%s');

$lum->setOption('html_links','<p>'.__('Page(s):').' %s</p>');
$lum->setOption('html_cur_page','<strong>%s</strong>');

$lum->setOption('html_prev','&lt; '.__('Previous'));
$lum->setOption('html_next',__('Next').' &gt;');
$lum->setOption('html_prev_grp','...');
$lum->setOption('html_next_grp','...');

$lum->setOption('html_empty','<p><strong>'.__('No comment yet').'</strong></p>');

echo $lum->getLinks();
echo $lum->getPage();
echo $lum->getLinks();

adminPage::close();
?>