<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

/*
	Original file by Olivier Meunier and contributors from 
	DotClear project. http://www.dotclear.net/
*/

if (!defined('PUNTAL')) exit;

$q = (!empty($_GET['q'])) ? $_GET['q'] : '';
$cat_id = '';
$show_filters = false;
$status='';
if (!empty($_GET['cat_id']))
{
	$cat_id = $_GET['cat_id'];
	$show_filters = true;
}

# Les catgories du blog
$rsCat = $blog->getCat();

$arry_cat['&nbsp;'] = NULL;
while (!$rsCat->EOF())
{
	$arry_cat[$rsCat->f('cat_libelle').' ['.$rsCat->f('nb_post').']'] = $rsCat->f('cat_id');
	$rsCat->moveNext();
}

# Tableau des mois du blog
$arry_months = array();
foreach ($blog->getAllDates('m','','','',$cat_id) as $k => $v)
	$arry_months[dt::str('%B %Y',$k)] = date('Ym',$k);

# Determiner $y et $m les dates de la page
if (!empty($_GET['m']) && in_array($_GET['m'],$arry_months))
{
	$m = substr($_GET['m'],4);
	$y = substr($_GET['m'],0,4);
	$show_filters = true;
}
else {
	$my_dt = $blog->getEarlierDate($cat_id);
	$my_dt = (empty($my_dt)) ? time() : strtotime($my_dt);
	$m = $y = '';
}

# Les billets (et titre)
if ($q != '')
{
	$posts = $blog->searchPost($q);
	$nb_res = $posts->nbRow();
	
	if ($nb_res > 1)
	{
		$subtitle = sprintf(__('%1$d entries match your search of %2$s.'),
		$nb_res,'<em>'.html::escapeHTML($q).'</em>');
	}
	else {
		$subtitle = sprintf(__('%1$d entrie matches search of %2$s.'),
		$nb_res,'<em>'.html::escapeHTML($q).'</em>');
	}
}
elseif (isset($_GET['offline']))
{
	$blog->setPubMode(0);
	$posts = $blog->getLastNews(NULL,'','post_dt DESC');
	$subtitle = __('Offline entries.');
}
elseif (isset($_GET['selected']))
{
	$posts = $blog->getLastNews(NULL,'','post_dt DESC',true);
	$subtitle = __('Selected entries.');
}
elseif ($m == '' && $y == '')
{
	$posts = $blog->getLastNews(15,$cat_id,'post_dt DESC');
	$subtitle = sprintf(__('Last %d entries.'),15);
}
else
	$posts = $blog->getPostByDate($y,$m,'',$cat_id,'post_dt DESC');





# Modifications d'un lot d'articles
if (!empty($_POST['lot']) && !empty($_POST['selentries']) && is_array($_POST['selentries']) )
{
	# Mise en ligne
	if ($_POST['lot'] == 'online' && $puntal->checkToken())
	{
		foreach ($_POST['selentries'] as $v)
			$blog->statusPost($v);
		
		if (!$puntal->err->hasError())
		{
			logIt('Blog module : put online entries '.implode(', ', $_POST['selentries']), 2);
			header('Location: module.php?id=blog&action=1&onlined=1');
			exit;
		}
	}
	
	# Mise hors ligne
	if ($_POST['lot'] == 'offline' && $puntal->checkToken())
	{
		foreach ($_POST['selentries'] as $v)
			$blog->statusPost($v);
		
		if (!$puntal->err->hasError())
		{
			logIt('Blog module : put offline entries '.implode(', ', $_POST['selentries']), 2);
			header('Location: module.php?id=blog&action=1&offlined=1');
			exit;
		}
	}
	
	# Suppression
	if ($_POST['lot'] == 'delete' && $puntal->checkToken())
	{
		foreach ($_POST['selentries'] as $v)
			$blog->delPost($v);
		
		if (!$puntal->err->hasError())
		{
			logIt('Blog module : Delete entries '.implode(', ', $_POST['selentries']), 3);
			header('Location: module.php?id=blog&action=1&deleted=1');
			exit;
		}
	}

}

# Messages de confirmation
if (!empty($_GET['onlined']))
	$common_message = __('Entries put online');

if (!empty($_GET['offlined']))
	$common_message = __('Entries put offline');

if (!empty($_GET['deleted']))
	$common_message = __('Entries deleted');




# Set token
$puntal->setToken();


$head = '';
if (!$posts->isEmpty())
{
	$head =
	'<script type="text/javascript">'."\n".
	"var js_post_ids = new Array('".implode("','",$posts->getIDs('content'))."');\n".
	"</script>\n";
}
# JS
$head = 
'<script type="text/javascript">'."\n".
"//<![CDATA[\n".
"function submitBlogForm(F,msg)
{
	var inputs = F.elements;
	var blog_ids = new Array();
	var action;
	
	var i = 0;
	for (i=0; i<inputs.length; i++)
	{
		if (inputs[i].name == 'selentries[]') {
			blog_ids.push(inputs[i]);
		}
		
		if (inputs[i].name == 'lot') {
			action = inputs[i].value;
		}
	}
	
	var selectfields = 0;
	for (i=0; i<blog_ids.length; i++) {
		selectfields += blog_ids[i].checked;
	}
	
	if (selectfields == 0) {
		return false;
	}
	
	if (action == 'delete') {
		return window.confirm(msg);
	}
	
	return true;
}

$(function() {
	$('.checkboxes-helpers').each(function() {
		puntal.checkboxesHelpers(this);
	});
});

//]]>
</script>";
if (!$show_filters)
	$head .= adminPage::jsLoad('js/filter-controls.js');

adminPage::open(__('Entries').' - '.__('Blog'),$head); ?>

<h2 class="first"><img src="index.php?pf=blog/img/ico_entries_list.png" alt="" class="icon" /> <?php echo __('List of entries') ?></h2>

<?php # Filtres
if (!$show_filters)
	echo '<p><a id="filter-control" class="form-control" href="#">'.__('Filters').'</a></p>';
?>	

<form action="module.php" method="get" id="filters-form">
	<fieldset>
		<legend><?php echo __('Filters') ?></legend>
		<div class="three-cols">
			<p class="col">
				<label for="m"><?php echo __('Month') ?></label>
				<?php echo form::combo('m',array_merge(array(''=>''),$arry_months),$y.$m) ?>
			</p>
			<p class="col">
				<label for="cat_id"><?php echo __('Category') ?></label>
				<?php echo form::combo('cat_id',$arry_cat,$cat_id) ?>
			</p>
			<p class="col">
				<?php echo 
				form::hidden(array('id'),'blog')."\n".
				form::hidden(array('action'),1); ?>
				<input class="submit" type="submit" value="<?php echo __('Display') ?>" />
			</p>
			<div class="clearer"></div>
		</div>
	</fieldset>
</form>

<?php
# Affichage des mois suivants et prcdents
if (!empty($arry_months) && $m != '' && $y != '')
{
	$m_invert = array_flip($arry_months);
	$m_next = $puntal->getNextPrev($m_invert,$y.$m,'prev');
	$m_prev = $puntal->getNextPrev($m_invert,$y.$m,'next');
	
	echo '<p>';
	if ($m_next)
	{
		echo '<a href="module.php?id=blog&action=1&m='.key($m_next).'&amp;cat_id='.$cat_id.'">&#171; '.
		current($m_next).'</a> - ';
	}
	
	echo '<strong>'.$m_invert[$y.$m].'</strong>';
	if ($m_prev)
	{
		echo ' - <a href="module.php?id=blog&action=1&m='.key($m_prev).'&amp;cat_id='.$cat_id.'">'.
		current($m_prev).' &#187;</a>';
	}
	echo '</p>';
}

if (!empty($subtitle))
	echo '<p>'.$subtitle.'</p>';


# Affichage des billets
if ($posts->isEmpty()) :
	echo '<p>'.__('No entry.').'</p>';

else : ?>

<?php 
# Formulaire pour propritaire du billet,  un admin ou  un modo

if ($puntal->user['is_admod'] || $data['user_id'] == $puntal->user['id']) : ?>
	<form class="clearb" action="module.php" method="post" id="form-blog-list" onsubmit="return submitBlogForm(this,'<?php echo html::escapeJS(__('Are you sure you want to delete the selected Entries?'))?>');">
<?php endif;?>	
	<table>
		<thead>
			<tr>
				<th colspan="2" class="nowrap center" scope="col"><?php echo __('Entries') ?></th>
				<th class="nowrap left" scope="col"><?php echo __('Comments') ?></th>
				<th class="nowrap left" scope="col"><?php echo __('Trackbacks') ?></th>
				<th class="nowrap left" scope="col"><?php echo __('Date') ?></th>
				<th colspan="2" class="nowrap center" scope="col"><?php echo __('Status') ?></th>
			</tr>
		</thead>
		<tbody>
<?php # boucle sur les billets
	while(!$posts->EOF())
	{
		$cur_title = html::escapeHTML($posts->f('post_titre'));
		$cur_url = 'module.php?id=blog&amp;action=2&amp;post_id='.$posts->f('post_id');
		
		# Liens pour l'dition et mise hors ligne accesibles uniquement au
		# propritaire du billet,  un admin ou  un modo
		if ($puntal->user['is_admod'] || $data['user_id'] == $puntal->user['id'])
		{
			# statut
			if ($posts->f('post_pub') == 0)
				$cur_status = '<a href="'.$cur_url.'&amp;cancel=1" title="'.sprintf(__('Put %s online'),$cur_title).'"><img src="style/img/off.png" class="icon" alt="'.__('Offline').'" /></a>';
			else
				$cur_status = '<a href="'.$cur_url.'&amp;cancel=1" title="'.sprintf(__('Put %s offline'),$cur_title).'"><img src="style/img/on.png" class="icon" alt="'.__('Online').'" /></a>';
		}
		else {
			# statut
			if ($posts->f('post_pub') == 0)
				$cur_status = '<img src="style/img/off.png" class="icon" alt="'.__('Offline').'" />';
			else
				$cur_status = '<img src="style/img/on.png" class="icon" alt="'.__('Online').'" />';
		}
		
		# selected ?
		if ($posts->f('post_selected') == 1)
			$cur_selected = '&nbsp;<img src="style/img/ico_rosette.png" class="icon" alt="'.__('This entry is selected').'" />';
		else
			$cur_selected = '&nbsp;';
		
		# Nombre de commentaires et trackbacks		
		$nb_comments = $posts->getNbComments();
		$nb_trackbacks = $posts->getNbTrackbacks();
		
		if ($nb_comments > 1)
			$str_comments = sprintf(__('%d comments'),$nb_comments);
		else
			$str_comments = sprintf(__('%d comment'),$nb_comments);
		
		if ($nb_trackbacks > 1)
			$str_trackbacks = sprintf(__('%d trackbacks'),$nb_trackbacks);
		else
			$str_trackbacks = sprintf(__('%d trackback'),$nb_trackbacks);
		
		echo
		"\t\t".'<tr class="line" id="c_'.$posts->f('post_id').'">'."\n".
		"\t\t\t".'<td scope="row">'.form::checkbox(array('selentries[]'),$posts->f('post_id'),0,'checkbox').'</td>'."\n".		
		"\t\t\t".'<td class="maximal"><h3 class="table-title"><a href="'.$cur_url.'">'.$cur_title.'</a></h3><p>'.sprintf(__('by %s - in %s'),html::escapeHTML($posts->f('username')),html::escapeHTML($posts->f('cat_libelle'))).'</p></td>'."\n".
		"\t\t\t".'<td class="nowrap left"><a href="'.$cur_url.'#comments">'.$str_comments.'</a></td>'."\n\n".
		"\t\t\t".'<td class="nowrap left"><a href="'.$cur_url.'#trackbacks">'.$str_trackbacks.'</a></td>'."\n\n".
		"\t\t\t".'<td class="nowrap left">'.dt::str(pt_date_format.' '.pt_time_format,$posts->getTS()).'</td>'."\n\n".
		"\t\t\t".'<td class="nowrap center">'.$cur_status.'</td>'."\n\n".
		"\t\t\t".'<td class="nowrap center">'.$cur_selected.'</td>'."\n\n".
		"\t\t".'</tr>'."\n\n";
		
		$posts->moveNext();
	}
?>

		</tbody>
	</table>
<?php 
# Formulaire pour propritaire du billet,  un admin ou  un modo
if ($puntal->user['is_admod'] || $data['user_id'] == $puntal->user['id']) : ?>
	<div class="two-cols">
		<p class="col checkboxes-helpers"></p>
		<p class="col right">
		<?php echo
			form::hidden(array('id'),'blog')."\n".
			form::hidden(array('action'),1)."\n".
			form::hidden(array('status'),$status)."\n".
			form::hidden(array('ptkn'),$puntal->getToken()); 
			?>		
		<label for="lot"><?php echo __('For the selected Entries:') ?></label> 
		<?php echo form::combo('lot', array(__('Online')=>'online',__('Offline')=>'offline',__('Delete')=>'delete')); ?>
		<input class="submit" type="submit" value="<?php echo __('ok') ?>" />
	</div>
	</form>
<?php endif; ?>	
<?php endif; ?>


<form action="module.php">
	<p class="field"><label for="q" style="display:inline;"><?php echo __('Search') ?></label>
	<?php echo form::field('q',20,'',html::escapeHTML($q))."\n".
	form::hidden(array('id'),'blog')."\n".
	form::hidden(array('action'),1); ?>
	<input class="submit" type="submit" value="<?php echo __('Search') ?>" /></p>
</form>

<ul>
	<li><a href="module.php?id=blog&amp;action=1&amp;offline=1"><?php echo __('View all offline entries') ?></a></li>
	<li><a href="module.php?id=blog&amp;action=1&amp;selected=1"><?php echo __('View all selected entries') ?></a></li>
</ul>
	

<?php adminPage::close(); ?>