<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

/*
	Original file by Olivier Meunier and contributors from 
	DotClear project. http://www.dotclear.net/
*/

require dirname(__FILE__).'/classes/class.blog.php';
require dirname(__FILE__).'/classes/class.xblog.php';
require dirname(__FILE__).'/classes/class.xblogpost.php';
require dirname(__FILE__).'/classes/class.xblogcomment.php';

$type = in_array(BLOG_COMMENTS, $pt_args) ? 'co' : 'blog';
$cat = (in_array(BLOG_CAT, $pt_args) && !empty($pt_args[3])) ? $pt_args[3] : '';
$post_id = (in_array(BLOG_ENTRY, $pt_args) && !empty($pt_args[3])) ? $pt_args[3] : '';

$lang = (!empty($_GET['lang'])) ? $_GET['lang'] : '';


# Cration de l'objet de type weblog avec uniquement les billets publis
$blog = new xblog($puntal,1,__('lang_iso_code'));
$blog->rs_blogpost = 'xblogpost';
$blog->rs_blogcomment = 'xblogcomment';

$blog->setURL('post',$puntal->url('blog').dc_format_post_url);

# Si type = co on fait un fil des commentaires
if ($type == 'co')
{
	if ($post_id != '')
		$comments = $blog->getComments($post_id,'DESC');
	else
		$comments = $blog->getComments('','DESC',20);
	
	$title = pt_portal_title.' - '.__('Blog').' - '.__('Comments');
	$ts = time();
	$items = $seq = '';
}
else
{
	# Dernires nouvelles
	$blog_entries = $blog->getLastNews(10,$cat,'post_dt DESC',false,$lang);
	
	$ts = strtotime($blog->getEarlierDate());
	$title = pt_portal_title.' - '.__('Blog');
}

header('Content-Type: application/atom+xml; charset='.__('lang_encoding'));
echo '<?xml version="1.0" encoding="'.__('lang_encoding').'" ?>'."\n";
?>
<feed xmlns="http://www.w3.org/2005/Atom"
	  xmlns:sy="http://purl.org/rss/1.0/modules/syndication/"
	  xml:lang="<?php echo __('lang_iso_code'); ?>">
  <title><?php echo $blog->toXML($title); ?></title>
  <link rel="alternate" type="text/html" href="<?php echo puntal::getHost().$puntal->url('blog'); ?>"/>
  <link rel="self" href="<?php echo puntal::getPageURL(); ?>"/>
<?php if (pt_portal_desc != '') : ?>
  <subtitle type="text"><?php echo html::escapeHTML(strip_tags(pt_portal_desc)); ?></subtitle>
<?php endif; ?>
  <id><?php echo $blog->getAtomID($puntal->url('blog')); ?></id>

  <updated><?php echo dt::iso8601($ts); ?></updated>
  <generator version="<?php echo pt_mod_blog_version; ?>" uri="http://www.puntal.fr/">Puntal blog module based on DotClear 1.2</generator>

  <sy:updatePeriod>daily</sy:updatePeriod>
  <sy:updateFrequency>1</sy:updateFrequency>
  <sy:updateBase><?php echo dt::iso8601($ts); ?></sy:updateBase>

<?php
if ($type == 'co')
{
	while(!$comments->EOF())
	{
		echo $comments->getAtomEntry(pt_mod_blog_short_feeds);
		$comments->moveNext();
	}
}
else {
	while(!$blog_entries->EOF())
	{
		echo $blog_entries->getAtomEntry(pt_mod_blog_short_feeds);
		$blog_entries->moveNext();
	}
}

?>
</feed>