<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

/*
	Original file by Olivier Meunier and contributors from 
	DotClear project. http://www.dotclear.net/
*/

require dirname(__FILE__).'/classes/class.blog.php';
require dirname(__FILE__).'/classes/class.xblog.php';
require dirname(__FILE__).'/classes/class.xblogpost.php';
require dirname(__FILE__).'/classes/class.xblogcomment.php';

$type = in_array(BLOG_COMMENTS, $pt_args) ? 'co' : 'blog';
$cat = (in_array(BLOG_CAT, $pt_args) && !empty($pt_args[3])) ? $pt_args[3] : '';
$post_id = (in_array(BLOG_ENTRY, $pt_args) && !empty($pt_args[3])) ? $pt_args[3] : '';

$lang = (!empty($_GET['lang'])) ? $_GET['lang'] : '';


# Cration de l'objet de type weblog avec uniquement les billets publis
$blog = new xblog($puntal,1,__('lang_iso_code'));
$blog->rs_blogpost = 'xblogpost';
$blog->rs_blogcomment = 'xblogcomment';

$blog->setURL('post',$puntal->url('blog').dc_format_post_url);

# Si type = co on fait un fil des commentaires
if ($type == 'co')
{
	if ($post_id != '')
		$comments = $blog->getComments($post_id,'DESC');
	else
		$comments = $blog->getComments('','DESC',20);
	
	$title = pt_portal_title.' - '.__('Blog').' - '.__('Comments');
	$ts = time();
	$items = $seq = '';
	
	if (!$comments->isEmpty())
	{
		$ts = $comments->getTS();
		
		while(!$comments->EOF())
		{
			$seq .= $comments->getRSSSeq();
			$items .= $comments->getRSSItem(pt_mod_blog_short_feeds);
			
			$comments->moveNext();
		}
	}
}
else {
	# Dernires nouvelles
	$blog_entries = $blog->getLastNews(10,$cat,'post_dt DESC',false,$lang);
	
	$ts = strtotime($blog->getEarlierDate());
	$title = pt_portal_title.' - '.__('Blog');
	
	$items = $seq = '';
	while(!$blog_entries->EOF())
	{
		$items .= $blog_entries->getRSSItem(pt_mod_blog_short_feeds);
		$seq .= $blog_entries->getRSSSeq();
		
		$blog_entries->moveNext();
	}
}

# Fermeture de connexion
$con->close();

header('Content-Type: application/rss+xml; charset='.__('lang_encoding'));
echo '<?xml version="1.0" encoding="'.__('lang_encoding').'" ?>'."\n";
?>
<rdf:RDF
  xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
  xmlns:dc="http://purl.org/dc/elements/1.1/"
  xmlns:sy="http://purl.org/rss/1.0/modules/syndication/"
  xmlns:admin="http://webns.net/mvcb/"
  xmlns:content="http://purl.org/rss/1.0/modules/content/"
  xmlns="http://purl.org/rss/1.0/">

<channel rdf:about="<?php echo puntal::getHost().$puntal->url('blog'); ?>">
  <title><?php echo $blog->toXML($title); ?></title>
  <description><![CDATA[<?php echo strip_tags(pt_portal_desc) ?>]]></description>
  <link><?php echo puntal::getHost().$puntal->url('blog'); ?></link>
  <dc:language><?php echo __('lang_iso_code'); ?></dc:language>
  <dc:creator></dc:creator>
  <dc:rights></dc:rights>
  <dc:date><?php echo dt::iso8601($ts); ?></dc:date>
  <admin:generatorAgent rdf:resource="http://www.dotclear.net/" />
  
  <sy:updatePeriod>daily</sy:updatePeriod>
  <sy:updateFrequency>1</sy:updateFrequency>
  <sy:updateBase><?php echo dt::iso8601($ts); ?></sy:updateBase>
  
  <items>
  <rdf:Seq>
  <?php echo $seq; ?>
  </rdf:Seq>
  </items>
</channel>

<?php echo $items; ?>

</rdf:RDF>
