<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

/*
	Original file by Olivier Meunier and contributors from 
	DotClear project. http://www.dotclear.net/
*/

# required files
require dirname(__FILE__).'/classes/class.blog.php';

# Si on est l, alors on a un _POST
# Connexion et cration du blog
header('Content-Type: text/xml');
echo '<?xml version="1.0" encoding="'.__('lang_encoding').'"?>'."\n";
echo '<response>'."\n";

$content = '';

if (empty($pt_args[2]))
{
	$content = '<error>1</error>'."\n".
	'<message>No ID.</message>';
}
else {
	$id = $pt_args[2];
	
	$blog = new weblogue($puntal,1,__('lang_iso_code'));	
	
	$blog->setURL('post',$puntal->url('blog').dc_format_post_url);
	
	$post = $blog->getPostByID($id);
	
	if ($post->isEmpty())
	{
		$content = '<error>1</error>'."\n".
		'<message>No post for this ID.</message>';
	}
	elseif (!pt_mod_blog_allow_trackbacks || !$post->f('post_open_tb')
	|| (pt_mod_blog_comments_ttl!=0 && time()-(pt_mod_blog_comments_ttl*86400) > $post->getTS()))
	{
		$content = '<error>1</error>'."\n".
		'<message>Trackbacks are not allowed for this post or weblog.</message>';
	}
	elseif (isset($_REQUEST['__info']))
	{
		$content =
		'<error>0</error>'."\n".
		'<engine>Puntal blog module based on DotClear 1.2</engine>'."\n".
		'<version>'.pt_mod_blog_version.'</version>'."\n".
		'<encoding>'.__('lang_iso_code').'</encoding>'."\n";
	}
	elseif (!empty($_REQUEST['__mode']) && $_REQUEST['__mode'] == 'rss')
	{
		$tb_url = puntal::getHost().$GLOBALS['puntal']->url('blog_trackback').$id;
		
		if ($post->f('post_chapo') != '')
			$post_excerpt = $post->f('post_chapo');
		else
			$post_excerpt = $post->f('post_content');
		
		$post_excerpt = puntal::cutString(strip_tags($post_excerpt),255);
		
		$content =
		'<error>0</error>'."\n".
		'<rss version="0.91"><channel>'."\n".
		'<title>'.pt_portal_title.' - '.__('Blog').' - '.__('Trackback').'</title>'."\n".
		'<link>'.$tb_url.'</link>'."\n".
		'<description>TrackBack item for this blog</description>'."\n".
		'<language>'.__('lang_iso_code').'</language>'."\n".
		'<item>'."\n".
		'<title>'.$blog->toXML($post->f('post_titre'),0).'</title>'."\n".
		'<link>'.puntal::getHost().$post->getPermURL().'</link>'."\n".
		'<description>'.$post_excerpt.'</description>'."\n".
		'</item>'."\n".
		'</channel>'."\n".
		'</rss>';
	}
	elseif (empty($_REQUEST['url']))
	{
		$content =
		'<error>1</error>'."\n".
		'<message>URL parameter is requiered.</message>';
	}
	else {
		$url = $_REQUEST['url'];
		$title = (!empty($_REQUEST['title'])) ? $_REQUEST['title'] : $url;
		$excerpt = (!empty($_REQUEST['excerpt'])) ? $_REQUEST['excerpt'] : '';
		$blog_name = (!empty($_REQUEST['blog_name'])) ? $_REQUEST['blog_name'] : '';
		
		$title = strip_tags(trim($title));
		$excerpt = strip_tags($excerpt);
		$blog_name = strip_tags($blog_name);
		
		if ($title == '')
			$title = $url;
		
		if (strlen($excerpt) > 255)
			$excerpt = puntal::cutString($excerpt,252).'...';
		
		$is_utf8 = puntal::isUTF8($title) || puntal::isUTF8($excerpt) || puntal::isUTF8($blog_name);
		
		if (strtolower(__('lang_iso_code')) != 'utf-8' && $is_utf8)
		{
			$title = utf8_decode($title);
			$excerpt = utf8_decode($excerpt);
			$blog_name = utf8_decode($blog_name);
		}
		elseif (strtolower(__('lang_iso_code')) == 'utf-8' && !$is_utf8)
		{
			$title = utf8_encode($title);
			$excerpt = utf8_encode($excerpt);
			$blog_name = utf8_encode($blog_name);
		}
		
		$comment = 
		'<!-- TB -->'."\n".
		'<p><strong>'.$title.'</strong></p>'."\n".
		'<p>'.$excerpt.'</p>';
		
		if ($blog->addComment($id,$blog_name,'',$url,$comment,true) !== false)
			$content = '<error>0</error>';
		else {
			$err = $untal->err->getError(false);
			$content =
			'<error>1</error>'."\n".
			'<message>'.$err[0][1].'</message>';
		}
	}		
}

echo $content."\n";
echo '</response>';

?>