<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

require_once PT_INC_PATH."libs/punbb_parser.php";

if (!empty($pt_args[1]))
{
	if ($pt_args[1] == BLOG_TRACKBACK)
	{
		require dirname(__FILE__).'/inc/tb.php';
		exit;
	}
	elseif ($pt_args[1] == BLOG_RSS)
	{
		require dirname(__FILE__).'/inc/rss.php';
		exit;
	}
	elseif ($pt_args[1] == BLOG_ATOM)
	{
		require dirname(__FILE__).'/inc/atom.php';
		exit;
	}
	else {
		$args = str_replace(BLOG_URL.'/','',implode("/", $pt_args));
		
		if ($args != '')
		{
			if (preg_match('!^([0-9]{4}/[0-9]{2})(/|\z)!',$args,$match))
			{
				$_GET['d'] = $match[1];
				
				if (preg_match('!^([0-9]{4}/[0-9]{2}/[0-9]{2})(/|\z)!',$args,$match))
				{
					$_GET['d'] = $match[1];
					
					if(preg_match('!^[0-9]{4}/[0-9]{2}/[0-9]{2}/([0-9]+)!',$args,$match))
						$_GET['p'] = $match[1];
				}
			}
			elseif(preg_match('!^([A-Z][A-Za-z0-9_-]*)([^/]*)?(/|\z)!',$args,$match))
			{
				$_GET['cat'] = $match[1];
				
				if (preg_match('!^[A-Z][A-Za-z0-9_-]*([^/]*?)/([0-9]{4}/[0-9]{2})!',$args,$match))
				{
					$_GET['d'] = $match[2];
					
					if (preg_match('!^[A-Z][A-Za-z0-9_-]*([^/]*)?/([0-9]{4}/[0-9]{2}/[0-9]{2})!',$args,$match))
						$_GET['d'] = $match[2];
				}
			}
		}
	}
}

if (!empty($_GET['p']))
	$mode = 'post';
elseif (!empty($_GET['d']) && strlen($_GET['d']) == 10)
	$mode = 'day';
elseif (!empty($_GET['d']) && strlen($_GET['d']) == 7)
	$mode = 'month';
elseif (!empty($_GET['cat']))
	$mode = 'cat';
else
	$mode = 'home';

$year = $month = $day = NULL;
$post_id = (!empty($_GET['p'])) ? $_GET['p'] : NULL;
$cat_id = (!empty($_GET['cat'])) ? $_GET['cat'] : NULL;
$lang = (!empty($_GET['l'])) ? $_GET['l'] : NULL;

if (!empty($_GET['d']))
{
	$year = substr($_GET['d'],0,4);
	
	if (strlen($_GET['d']) >= 7)
	{
		$month = substr($_GET['d'],5,2);
		
		if (strlen($_GET['d']) == 10)
			$day = substr($_GET['d'],8,2);
	}
}

$err_msg = $form_err = $form_msg = '';

# Variables pour le formulaire
$c_nom = $c_mail = $c_content = '';
$c_site = 'http://';
$preview = false;

if (!empty($_COOKIE['comment_info']))
{
	if (($c_cookie = @unserialize($_COOKIE['comment_info'])) !== false)
	{
		if (isset($c_cookie['c_nom']))
		{
			$c_nom 	= $c_cookie['c_nom'];
			$c_mail = $c_cookie['c_mail'];
			$c_site = $c_cookie['c_site'];
		}
	}
}

# required files
require dirname(__FILE__).'/inc/classes/class.blog.php';
require dirname(__FILE__).'/inc/classes/class.xblog.php';
require dirname(__FILE__).'/inc/classes/class.xblogpost.php';
require dirname(__FILE__).'/inc/classes/class.xblogcomment.php';

# Template
require dirname(__FILE__).'/inc/tpl_functions.php';
$pt_template_file = '/blog/main.php';

# blog
$blog = new xblog($puntal,1,__('lang_iso_code'));
$blog->rs_blogpost 		= 'xblogpost';
$blog->rs_blogcomment 	= 'xblogcomment';

if ( pt_blog_use_smilies ) $blog->setUseSmilies(true);

$blog->setLang($lang);
$blog->setURL('post',$puntal->url('blog').dc_format_post_url);
$blog->setURL('cat',$puntal->url('blog').dc_format_cat_url);
$blog->setURL('archive',$puntal->url('blog').dc_format_archive_url);
$blog->setURL('day',$puntal->url('blog').dc_format_day_url);

#appel du fichier definissant les questions 
include dirname(__FILE__).'/captcha_questions.php';
$captcha_index = rand(0,count($captcha_questions)-1);

# Catgories
$rs_cat = $blog->getCat();

# Mois pour les archives
$arry_months = $blog->getAllDates('m','','','',$cat_id);

# Les langues du blog
$rs_lang = $blog->getPostLanguages();

if (isset($blog_entries))
{
	if ($blog_entries->isEmpty())
		$err_msg = '<p>'.__('No entry.').'</p>';
}

elseif ($mode == 'home' || ($mode == 'cat' && $cat_id) || $mode == 'year')
{
	$blog_entries = $blog->getLastNews(pt_mod_blog_nb_post_per_page,$cat_id,'post_dt DESC');
	
	if ($blog_entries->isEmpty())
		$err_msg = '<p>'.__('No entry.').'</p>';
}

elseif($mode == 'day')
{
	$blog_entries = $blog->getPostByDate($year,$month,$day,$cat_id,'post_dt DESC');
	
	if ($blog_entries->isEmpty())
		$err_msg = '<p>'.__('No entry.').'</p>';
}

elseif ($mode == 'month')
{
	$blog_entries = $blog->getPostByDate($year,$month,'',$cat_id,'post_dt DESC');
	
	if ($blog_entries->isEmpty())
		$err_msg = '<p>'.__('No entry.').'</p>';
}

elseif ($mode == 'post' && $post_id)
{
	$p_question='';
	$p_answer='';
	$blog_entries = $blog->getPostByID($post_id);
	
	if ($blog_entries->isEmpty())
		$err_msg = '<p>'.__('No entry.').'</p>';
	
	else {
		# Ajout d'un commentaire
				
		if (!empty($_POST['redir']) && $blog_entries->openComment() && $puntal->checkToken())
		{
		// Check the captcha
			$hide_smilies = 1;
			if (pt_blog_use_smilies) $hide_smilies = 0;		
    		$p_question = trim($_POST['captcha_q']);
    		$p_answer 	= trim($_POST['captcha']);

    		$questions_array = array();
    		
    		foreach ($captcha_questions as $k => $v)
	        	$questions_array[md5($k)] = $v;
	        		
	    	if (empty($questions_array[$p_question]) || $questions_array[$p_question] != $p_answer)  
				$form_msg = __('Vous vous tes tromp  la question ou vous n\'etes peut-tre pas un humain ...');
			else {						
				$c_nom 	= trim($_POST['c_nom']);
				$c_mail = trim($_POST['c_mail']);
				$c_site = trim($_POST['c_site']);
			
			if (trim($_POST['c_content']) == '')
				$in_content = $c_content = '';
			
			else {
				$c_content 	= $_POST['c_content'];
				$in_content = parse_message($c_content,$hide_smilies);				
				//$in_content = '<p>'.nl2br($blog->parseContent(html::escapeHTML($c_content))).'</p>';
			}
			
			if (!empty($_POST['preview']))
				$preview = true;
			
			else {
				
				if ($blog->addComment($post_id,$c_nom,$c_mail,$c_site,$in_content,0,$puntal->pun_config['o_server_timezone'],pt_mod_blog_comments_pub) === false)
				{
					$form_err = $puntal->err->getError(1,0);
				}
				else {
					if (!empty($_POST['c_remember']) || !empty($_COOKIE['comment_info']))
					{
						$c_cookie = array(
							'c_nom' => $c_nom,
							'c_mail' => $c_mail,
							'c_site' => $c_site
						);
						$c_cookie = serialize($c_cookie);
						setcookie('comment_info',$c_cookie,(time()+60*60*24*90),'/');
					}
					
					$redir = $_POST['redir'].(strpos($_POST['redir'],'?') ? '&' : '?').'cos=1';
					header('Location: '.$redir);
					exit;
				}
				}
	    	}
		}
		
		# Message si modration
		if (!empty($_GET['cos']) && pt_mod_blog_comments_pub == 0)
			$form_msg = __('Your comment has been sent successfully. It will be online soon.');
		
		#Security Token Set !
		$puntal->setToken();
		
		$comments = $blog->getComments($post_id);
		$trackbacks = $comments->extractTrackbacks();
		
		$rs_prev = $blog->getNextID($blog_entries->getTS(),-1);
		$rs_next = $blog->getNextID($blog_entries->getTS(),1);
	}
}

?>