<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

/*
	Actions possibles du module
	1 : list
	2 : add
	3 : edit
	4 : config
*/

# Menu bugtracker
if (pt_mod_bugtracker && checkPerm('mod_bugtracker'))
{
	$menu->newMenu('bugtracker',__('Bugtracker'));
	
	$on_bugtracker = ($module_id == 'bugtracker') ? true : false;
	
	$menu->addItem('bugtracker',
				__('Bugs list'),
				'module.php?id=bugtracker&amp;action=1',
				($on_bugtracker && $action == 1)
	);
	
	$menu->addItem('bugtracker',
				__('Add'),
				'module.php?id=bugtracker&amp;action=2',
				($on_bugtracker && $action == 2)
	);
	
	$menu->addItem('bugtracker',
				__('Configuration'),
				'module.php?id=bugtracker&amp;action=4',
				($on_bugtracker && $action == 4)
	);
    
    $puntal->addBehavior('adminIndexHTML', array('bugTrackerBehavior','getNewBugs'));
}

class bugTrackerBehavior
{
    function getNewBugs()
	{
		global $puntal;
		
        $rs = $puntal->con->select('SELECT count(bug_id) as total FROM '.DB_PREFIX.'pt_bugs WHERE bug_status=1') or $puntal->err->fatalError($puntal->con->error());
        
        if ($rs->f('total') > 0) 
		{
            echo '<div class="warningbox"><h2>'.__('Bugtracker').'</h2>'.
			'<p><a href="module.php?id=bugtracker&amp;action=1&amp;status=1">'.
			sprintf(__('There are %s new bug(s) to analyze.'), $rs->f('total')).
			'</a></p></div>';
		}
    }
}
?>