<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

$bug_title 		= '';
$bug_desc 		= '';
$bug_severity 	= '';
$bug_status 	= '';
$bug_percent 	= '';
$bug_version 	= '';
$bug_component 	= '';

/* Modification du bug */
if (!empty($_POST['add_bug']) && $puntal->checkToken())
{
	$bug_title 		= trim($_POST['bug_title']);
	$bug_desc 		= trim($_POST['bug_desc']);
	$bug_severity 	= intval($_POST['bug_severity']);
	$bug_status 	= intval($_POST['bug_status']);
	$bug_percent 	= intval($_POST['bug_percent']);
	$bug_version 	= trim($_POST['bug_version']);
	$bug_component	= trim($_POST['bug_component']);
	
	if ($bug_title == '')
		$puntal->err->setError(__('You must give a bug title.'));
	
	if ($bug_desc == '')
		$puntal->err->setError(__('You must give a bug description.'));

	
	$t_infos = array('tid' => 0, 'pid' => 0);

	if (!$puntal->err->hasError() && pt_mod_bugtracker_forum_id > 0)
	{
		$t_infos = punbb::newTopic(pt_mod_bugtracker_forum_id,'['.__('stat_'.$bug_status).'] '. $bug_component.' '.$bug_title,$bug_desc,true,false,false,'','',true);
	}

	if (!$puntal->err->hasError())
	{
		if ($bugtracker->setBug($bug_title,$bug_desc,$bug_severity,$bug_status,$bug_percent,$bug_version,$t_infos['tid'],$t_infos['pid'],0,$bug_component))
		{
			logIt('Bugtracker module : add bug '.$bug_title, 1);
			header('Location: module.php?id=bugtracker&action=1&added=1');
			exit;
		}
	}
}
		
# Message de confirmation
if (!empty($_GET['added']))
	$common_message = __('Bug added');

$severity_array = array();
for ($i=1; $i<6; $i++)
	$severity_array[__('sev_'.$i)] = $i;
	
$status_array = array();
for ($i=1; $i<9; $i++)
	$status_array[__('stat_'.$i)] = $i;
	
$progress_array = array();
for ($i=0; $i<11; $i++)
	$progress_array[($i*10).'%'] = $i*10;
	
$version_array = array();
$version_array['&nbsp;'] = '';
foreach (unserialize(pt_mod_bugtracker_versions) as $v)
	$version_array[$v] = $v;


$bug_component_array = array();
$bug_component_array['&nbsp;'] = '';
$bug_component_array[__('all')] = __('all');

foreach ($puntal->modules->getInstalledModules() as $module) {
	if (constant('pt_mod_'.$module['id']) && $module['page_module'])
	{
	$bug_component_array[$module['name']]=$module['name'];
	}
}
$bug_component_array[__('other')] = __('other');

# Set token
$puntal->setToken();

# Javascript
$head='';
adminPage::open(__('Add a bug').' - '.__('Bugtracker'),$head);
?>

<h2 class="first"><img src="index.php?pf=bugtracker/img/ico_bugtracker_edit.png" alt="" class="icon" /> <?php echo __('Add a bug') ?></h2>

<form method="post" action="module.php">
	<fieldset>
		<legend><?php echo __('New bug'); ?></legend>
							
		<p class="field"><label><?php echo __('Bug title') ?></label>
		<?php echo form::field('bug_title', 80, 80, html::escapeHTML($bug_title), 'longinput') ?></p>

		<div class="three-cols">
			<p class="col field">
				<label><?php echo __('Components') ?></label>
				<?php echo form::combo('bug_component', $bug_component_array, $bug_component) ?>
			</p>
			<p class="col field">
				<label><?php echo __('Severity') ?></label>
				<?php echo form::combo('bug_severity', $severity_array, $bug_severity) ?>
			</p>
			<p class="col field">
				<label><?php echo __('Status') ?></label>
				<?php echo form::combo('bug_status', $status_array, $bug_status) ?>
			</p>
		</div>
		<div class="two-cols">
			<p class="col field">
				<label><?php echo __('Progress') ?></label>
				<?php echo form::combo('bug_percent', $progress_array, $bug_percent) ?>
			</p>
			<p class="col field">
				<label><?php echo __('Version') ?></label>
				<?php echo form::combo('bug_version', $version_array, $bug_version) ?>
			</p>
		</div>
		
		<p class="field"><label for="bug_desc"><?php echo __('Bug description') ?></label></p>
		<p class="area"><?php echo form::textarea('bug_desc', 55, 5, html::escapeHTML($bug_desc)) ?></p>
		<?php 
		require_once PT_INC_PATH.'libs/puntoolbar_smilies.php'; 
		$ptb = new puntoolbarSmilies($puntal);
		echo $ptb->generatePtb('bug_desc');
		?>		
	</fieldset>
	
	<p><?php echo form::hidden('add_bug','1')."\n".
	form::hidden('id','bugtracker')."\n".
	form::hidden('action',2)."\n".
	form::hidden(array('ptkn'),$puntal->getToken()); ?>
	<input class="submit" type="submit" value="<?php echo __('Add'); ?>" /></p>

</form>

<?php adminPage::close() ?>