<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

$bug_id = !empty($_REQUEST['bid']) ? intval($_REQUEST['bid']) : NULL;

if (is_null($bug_id))
	adminPage::fatalErrorPage(__('Bad request. The link you followed is incorrect or outdated.'));

# Initialisations
$bug 			= $bugtracker->getBug($bug_id);
$bug_title 		= $bug->f('bug_title');
$bug_desc 		= $bug->f('bug_desc');
$bug_severity 	= $bug->f('bug_severity');
$bug_status 	= $bug->f('bug_status');
$bug_percent 	= $bug->f('bug_percent');
$bug_version 	= $bug->f('bug_version');
$bug_tid 		= $bug->f('bug_tid');
$bug_pid 		= $bug->f('bug_pid');
$bug_component	= $bug->f('bug_component');

$neo_comment = '';

# vrification de la validit du message et recration le cas chant
if (pt_mod_bugtracker_forum_id > 0 && $bug_tid > 0 && $bug_pid > 0 && !punbb::checkPostTopic($bug_pid, $bug_tid))
{
	$t_infos = array('tid' => 0, 'pid' => 0);
	$t_infos = punbb::newTopic(pt_mod_bugtracker_forum_id,'['.__('stat_'.$bug_status).'] '.$bug_title,$bug_desc,true,false,false,'','',true);

	if (!$puntal->err->hasError())
	{
		if ($bugtracker->setBug($bug_title,$bug_desc,$bug_severity,$bug_status,$bug_percent,$bug_version,$t_infos['tid'],$t_infos['pid'],$bug_id))
		{
			logIt('Bugtracker module : edit bug '.$bug_title, 1);
			header('Location: module.php?id=bugtracker&action=3&bid='.$bug_id.'&regenerated_topic=1');
			exit;
		}
	}
}

# Ajout d'un commentaire au bug
if (!empty($_POST['add_comment']) && $bug_tid > 0 && $bug_pid > 0 && $puntal->checkToken())
{
	$neo_comment = trim($_POST['neo_comment']);
	
	if ($neo_comment == '')
		$puntal->err->setError(__('You must give a comment'));
	
	elseif (punbb::newPost($bug_tid,$neo_comment))
	{
		header('Location: module.php?id=bugtracker&action=3&bid='.$bug_id.'&commented=1');
		exit;
	}
}

# Formulaire envoy, modification du bug
if (!empty($_POST['edit_bug']) && $puntal->checkToken())
{
	$bug_title 		= trim($_POST['bug_title']);
	$bug_desc 		= trim($_POST['bug_desc']);
	$bug_severity 	= intval($_POST['bug_severity']);
	$bug_status 	= intval($_POST['bug_status']);
	$bug_percent	= intval($_POST['bug_percent']);
	$bug_version 	= trim($_POST['bug_version']);
	$bug_component	= trim($_POST['bug_component']);
		
	if ($bug_title == '')
		$puntal->err->setError(__('You must give a bug title.'));
	
	if ($bug_desc == '')
		$puntal->err->setError(__('You must give a bug description.'));

	if (!$puntal->err->hasError() && $bug_tid > 0 && $bug_pid > 0)
	{
		punbb::editPost($bug_pid,$bug_desc,'['.__('stat_'.$bug_status).'] '.$bug_title);
	}

	if (!$puntal->err->hasError())
	{
		if ($bugtracker->setBug($bug_title,$bug_desc,$bug_severity,$bug_status,$bug_percent,$bug_version,$bug_tid,$bug_pid,$bug_id,$bug_component))
		{
			logIt('Bugtracker module : edit bug '.$bug_title, 1);
			header('Location: module.php?id=bugtracker&action=3&bid='.$bug_id.'&edited=1');
			exit;
		}
	}
}

# Le ncessaire de toilette
$severity_array = array();
for ($i=1; $i<6; $i++)
	$severity_array[__('sev_'.$i)] = $i;
	
$status_array = array();
for ($i=1; $i<9; $i++)
	$status_array[__('stat_'.$i)] = $i;
	
$progress_array = array();
for ($i=0; $i<11; $i++)
	$progress_array[($i*10).'%'] = $i*10;
	
$version_array = array('&nbsp;'=>'');
foreach (unserialize(pt_mod_bugtracker_versions) as $v)
	$version_array[$v] = $v;
	
$bug_component_array = array();
$bug_component_array['&nbsp;'] = '';
$bug_component_array[__('all')] = __('all');

foreach ($puntal->modules->getInstalledModules() as $module) {
	if (constant('pt_mod_'.$module['id']) && $module['page_module'])
	{
	$bug_component_array[$module['name']]=$module['name'];
	}
}
$bug_component_array[__('other')] = __('other');

if ($bug_tid > 0 && $bug_pid > 0)
{
	if (($comments = punbb::getTopicPosts($bug_tid,'',$bug_pid)) === false)
		$puntal->err->fatalError();
	
	require PT_INC_PATH.'libs/punbb_parser.php';
}

# Set token
$puntal->setToken();

# Messages de confirmation
if (!empty($_GET['commented']))
	$common_message = __('Comment added');

if (!empty($_GET['edited']))
	$common_message = __('Bug edited.');

if (!empty($_GET['regenerated_topic']))
	$common_message = __('Bug topic was regenerated because it was deleted.');

# Javascript
$head ="";


# Affichage
adminPage::open(__('Edit a bug').' - '.__('Bugtracker'),$head);

require_once PT_INC_PATH.'libs/puntoolbar_smilies.php'; 
$ptb = new puntoolbarSmilies($puntal);

?>

<h2 class="first"><img src="index.php?pf=bugtracker/img/ico_bugtracker_edit.png" alt="" class="icon" /> <?php echo __('Edit a bug') ?></h2>

<form method="post" action="module.php">
	<fieldset>
		<legend><?php echo __('Edit a bug'); ?></legend>
							
		<p class="field"><label><?php echo __('Bug title') ?></label>
		<?php echo form::field('bug_title', 80, 80, html::escapeHTML($bug_title), 'longinput') ?></p>
		
		<div class="three-cols">
			<p class="col field">
				<label><?php echo __('Components') ?></label>
				<?php echo form::combo('bug_component', $bug_component_array, $bug_component) ?>
			</p>		
			<p class="col field">
				<label><?php echo __('Severity') ?></label>
				<?php echo form::combo('bug_severity', $severity_array, $bug_severity) ?>
			</p>
			<p class="col field">
				<label><?php echo __('Status') ?></label>
				<?php echo form::combo('bug_status', $status_array, $bug_status) ?>
			</p>
		</div>
		<div class="two-cols">
			<p class="col field">
				<label><?php echo __('Progress') ?></label>
				<?php echo form::combo('bug_percent', $progress_array, $bug_percent) ?>
			</p>
			<p class="col field">
				<label><?php echo __('Version') ?></label>
				<?php echo form::combo('bug_version', $version_array, $bug_version) ?>
			</p>
		</div>
		
		<p class="field"><label for="bug_desc"><?php echo __('Bug description') ?></label></p>
		<p class="area"><?php echo form::textarea('bug_desc', 55, 5, html::escapeHTML($bug_desc)) ?></p>
		<?php
		//generate Puntoolbar 
		echo $ptb->generatePtb('bug_desc',false);
		?>		
	</fieldset>
	
	<p><?php echo form::hidden('edit_bug','1')."\n".
	form::hidden(array('id'),'bugtracker')."\n".
	form::hidden(array('action'),3)."\n".
	form::hidden(array('bid'),$bug_id)."\n".
	form::hidden(array('ptkn'),$puntal->getToken()); ?>
	<input class="submit" type="submit" value="<?php echo __('Edit'); ?>" /></p>

</form>

<?php # Si il y a une discussion pour ce bug
if ($bug_tid > 0 && $bug_pid > 0) : ?>

<h2><img src="style/img/ico_comments.png" alt="" class="icon" /> <?php echo __('Comments') ?></h2>
	
	<?php # Et si il y a des commentaires on les affiches
	if (!$comments->isEmpty()) : ?>
		<?php # Boucle sur les commentaires
		while ($comments->fetch()) : 
		$cid = $comments->f('id');
		$comment_author = html::escapeHTML($comments->f('username'));
		?>
	<div class="comment">
	
		<h3 class="comment_info"><?php echo __('Comment by').' <a href="'.pt_forum_url.'profile.php?id='.$comments->f('poster_id').'" title="'.__('See profile of').' '.$comment_author.'">'.$comment_author.'</a> - <a href="'.pt_forum_url.'viewtopic.php?pid='.$cid.'#p'.$cid.'">'.$puntal->format_time($comments->f('posted')); ?></a></h3>
		
		<?php echo parse_message($comments->f('message'), $comments->f('hide_smilies')); ?>
		
	</div>
		<?php endwhile; ?>
	<?php # Pas de commentaire
	else : ?>
	<p><strong><?php echo __('No comment') ?></strong></p>
	<?php endif; ?>
	
	<h3><img src="style/img/ico_comment_add.png" alt="" class="icon" /> <label for="neo_comment"><?php echo __('Write a comment') ?></label></h3>
	<form method="post" action="module.php">
		
		<p class="area"><?php echo form::textarea('neo_comment', 55, 5, html::escapeHTML($neo_comment)) ?></p>
		<?php
		//generate Puntoolbar 
		echo $ptb->generatePtb('neo_comment',false);
		?>		
	
		<p><?php echo form::hidden('add_comment','1')."\n".
		form::hidden(array('id'),'bugtracker')."\n".
		form::hidden(array('action'),3)."\n".
		form::hidden(array('bid'),$bug_id)."\n".
		form::hidden(array('ptkn'),$puntal->getToken()); ?>
		<input class="submit" type="submit" value="<?php echo __('Add'); ?>" /></p>
	</form>

<?php endif; ?>

<?php adminPage::close() ?>