<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;



function update_bugtracker()
{
	global $puntal;
	
	$res = true;
	
	# mise  jour 0.6
	if (compare_version(pt_mod_bugtracker_version,'0.6') == '-1')
		$res &= bugtracker_up_to_0_6();

	# mise  jour 1.0
	if (compare_version(pt_mod_bugtracker_version,'1.0') == '-1')
		$res &= bugtracker_up_to_1_0();
			
	return $res;
}

/**
@function bugtracker_up_to_0_6

Mise  jour du module  la version 0.6
*/
function bugtracker_up_to_0_6()
{
	/* Structure de la base de donnes
	----------------------------------------------------------*/
	$db_scheme = array();
	
	/* Paramtres de configuration
	----------------------------------------------------------*/
	$params = array();

	
	/* Installation du module
	----------------------------------------------------------*/
	$GLOBALS['install_module']->update($db_scheme,$params);
}

/**
@function bugtracker_up_to_1_0

Mise  jour du module  la version 1.0
*/
function bugtracker_up_to_1_0()
{
	/* Structure de la base de donnes
	----------------------------------------------------------*/
	$db_scheme = array();
	$db_scheme[] = array(
		'action' 	=> 'update',
		'table' 	=> DB_PREFIX.'pt_bugs',
		'query' 	=> 
		'ALTER TABLE '.DB_PREFIX.'pt_bugs 
		ADD bug_component VARCHAR( 80 ) NOT NULL'
	);	
	/* Paramtres de configuration
	----------------------------------------------------------*/
	$params = array();

	
	/* Installation du module
	----------------------------------------------------------*/
	$GLOBALS['install_module']->update($db_scheme,$params);
}

?>