<?php
/***********************************************************************

  Copyright (C) 2005-2006 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

/*
 * 2: config
 * 3: cat
 * 4: cats
 */
 
if (pt_mod_calendar && checkPerm('mod_calendar'))
{
	$menu->newMenu('calendar',__('Calendar'));
	
	$on_calendar = ($module_id == 'calendar') ? true : false;

	$menu->addItem('calendar',
				__('Configuration'),
				'module.php?id=calendar&amp;action=2',
				($on_calendar && $action == 2)
	);
	$menu->addItem('calendar',
				__('Categories'),
				'module.php?id=calendar&amp;action=4',
				($on_calendar && $action == 4)
	);	
	
}


class calendarAdminBlocks
{
	/**
	calendar<br/>
	
	<strong>FR</strong> Gestion du bloc calendrier<br/>
	<strong>EN</strong> Management of the Calendar bloc
	*/
	function calendar()
	{
		global $puntal, $pt_settings;
		
		$p_events_number 	= pt_bloc_calendar_events_number;
		$p_events_days 		= pt_bloc_calendar_events_days;
		
		# FR - Formulaire envoy
		# EN - Submitted Form
		if (!empty($_POST['form_sent']))
		{
			$p_events_number 	= intval(trim($_POST['p_events_number']));
			$p_events_days 		= intval(trim($_POST['p_events_days']));
			
			$pt_settings->setNamespace('mod_calendar');
			
			$res = $pt_settings->put('pt_bloc_calendar_events_number', $p_events_number);
			$res = $pt_settings->put('pt_bloc_calendar_events_days', $p_events_days);
			
			$pt_settings->setNamespace('');
		
			if ($res)
			{
				logIt("Config calendar block", 1);
				header('Location: bloc.php?id=calendar&updated=1');
				exit;
			}
		}
		
		# FR - Messages de confirmation
		# EN - Confirmation Messages
		if (!empty($_GET['updated']))
			$GLOBALS['common_message'] = __('Configuration updated');
		
		# FR - Affichage
		# EN - Display
		adminPage::open(sprintf(__('Settings of the "%s" block'), __('bloc_calendar')));
?>
	<h2 class="first"><img src="style/img/ico_date.png" alt="" class="icon" /> <?php printf(__('Settings of the "%s" block'), __('bloc_calendar')); ?></h2>
	
	<form method="post" action="bloc.php">		
		<fieldset>
			<legend><?php echo __('bloc_calendar') ?></legend>
			
			<p class="field"><label for="p_events_number"><?php echo __('Events number') ?></label>
			<?php echo form::field('p_events_number', 2, 3, html::escapeHTML($p_events_number)) ?>
			<span class="desc"><?php echo __('Number of events to display.') ?></span></p>
			
			<p class="field"><label for="p_events_days"><?php echo __('Days number') ?></label>
			<?php echo form::field('p_events_days', 2, 3, html::escapeHTML($p_events_days)) ?>
			<span class="desc"><?php echo __('Display events of X nearest days.') ?></span></p>
		</fieldset>
		
		<p><?php echo 
		form::hidden('form_sent', '1')."\n".
		form::hidden('id', 'calendar'); ?>
		<input class="submit" type="submit" value="<?php echo __('Save') ?>" /></p>
	</form>

<?php
		adminPage::close();
	}
}

?>