<?php
/***********************************************************************

  Copyright (C) 2005 Vincent Garnier (vin100@forx.fr)
  
  This file is part of Puntal.

  Puntal is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  PunBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

// Soyons sr que personne ne lance ce script "directement"
if (!defined('PUNTAL')) exit;


if ($calendar->getPermission($allowed_groups) == true) {

// Load the post.php language file
require PUN_ROOT.'lang/'.$puntal->user['language'].'/post.php';

// Start with a clean state
$cal_errors = array();

if (isset($_POST['form_sent']) && $puntal->checkToken())
{	
	if (isset ( $_POST['preview'] ) and ( checkdate($_POST['event_mois'], $_POST['event_jour'], $_POST['event_annee'])) )
	{
		$pt_mois 	= $_POST['event_mois'];
		$pt_jour 	= $_POST['event_jour']; 
		$pt_annee 	= $_POST['event_annee'];
	}
	
	$calendar_cat = '';
	$calendar_cat_id = '';
	if ($calendar->existingCats() > 0 ) {
		$calendar_cat_id = '';
		$calendar_cat_id = pun_trim($_POST['req_cal_category']);
		
		$calendar_my_cat = $calendar->getCat($calendar_cat_id);
		
		if ($calendar_cat_id != '') 
			$calendar_cat = "[".$calendar_my_cat->f('cat_name')."] ";
	}
			
	$hide_smilies 	= isset($_POST['hide_smilies']) ? 1 : 0;
	$subscribe 		= isset($_POST['subscribe']) ? 1 : 0;

	$new_tid = 0;
	$new_pid = 0;
	
	// Make sure form_user is correct
	if (($puntal->user['is_guest'] && $_POST['form_user'] != 'Invit') || (!$puntal->user['is_guest'] && $_POST['form_user'] != $puntal->user['username']))
		$cal_errors[] =   $lang_common['Bad request']  ;
	
	// vrification de la date		
	if (!checkdate($_POST['event_mois'], $_POST['event_jour'], $_POST['event_annee'])) 
		$cal_errors[] =  __('Wrong Date');
	
	// vrification du sujet/titre
	$subject = $calendar_cat . pun_trim($_POST['req_subject']);
	

	if ($subject == '') 
		$cal_errors[] = $puntal->err->setError($lang_post['No subject'] ) ;
	else if (pun_strlen($subject) > 50)
		$cal_errors[] = $puntal->err->setError($lang_post['Too long subject'] );
	else if ($puntal->pun_config['p_subject_all_caps'] == '0' && strtoupper($subject) == $subject && $puntal->user['g_id'] > PUN_MOD)
		$subject = ucwords(strtolower($subject));

	// vrification du message
	$content = pun_trim($_POST['req_message']);

	if ($content == '') 
		$cal_errors[] = $puntal->err->setError($lang_post['No message'] ) ;


	if ( count($cal_errors) > 0 )  {
		foreach ($puntal->err->getError(false) as $err)
			$errors[] = implode('<br />',$err);
	}
	else { 
	// If the user is logged in we get the username and e-mail from $puntal->user
	if (!$puntal->user['is_guest'])
	{
		$username 	= $puntal->user['username'];
		$email 		= $puntal->user['email'];
	}
	// Otherwise it should be in $_POST
	else
	{
		$username 	= trim($_POST['req_username']);
		$email 		= strtolower(trim(($puntal->pun_config['p_force_guest_email'] == '1') ? $_POST['req_email'] : $_POST['email']));

		// Load the register.php/profile.php language files
		require PUN_ROOT.'lang/'.$puntal->user['language'].'/prof_reg.php';
		require PUN_ROOT.'lang/'.$puntal->user['language'].'/register.php';

		// It's a guest, so we have to validate the username
		if (strlen($username) < 2)
			$cal_errors[] = $lang_prof_reg['Username too short'];
		else if (!strcasecmp($username, 'invit') || !strcasecmp($username, $lang_common['Guest']))
			$cal_errors[] = $lang_prof_reg['Username guest'];
		else if (preg_match('/[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}/', $username))
			$cal_errors[] = $lang_prof_reg['Username IP'];

		if ((strpos($username, '[') !== false || strpos($username, ']') !== false) && strpos($username, '\'') !== false && strpos($username, '"') !== false)
			$cal_errors[] = $lang_prof_reg['Username reserved chars'];
		if (preg_match('#\[b\]|\[/b\]|\[u\]|\[/u\]|\[i\]|\[/i\]|\[color|\[/color\]|\[quote\]|\[quote=|\[/quote\]|\[code\]|\[/code\]|\[img\]|\[/img\]|\[url|\[/url\]|\[email|\[/email\]#i', $username))
			$cal_errors[] = $lang_prof_reg['Username BBCode'];

		// Check username for any censored words
		$temp = $puntal->censor_words($username);
		if ($temp != $username)
			$cal_errors[] = $lang_register['Username censor'];

		// Check that the username (or a too similar username) is not already registered
		$result = $puntal->con->select('SELECT username FROM '.DB_PREFIX.'users WHERE username=\''.$puntal->con->escapeStr($username).'\' OR username=\''.$puntal->con->escapeStr(preg_replace('/[^\w]/', '', $username)).'\'') or $puntal->err->fatalError($puntal->con->error());
		if (!$result->isEmpty())
		{
			$busy = $result->f('username');
			$cal_errors[] = $lang_register['Username dupe 1'].' '.html::escapeHTML($busy).'. '.$lang_register['Username dupe 2'];
		}

		if ($puntal->pun_config['p_force_guest_email'] == '1' || $email != '')
		{
			require PT_INC_PATH.'libs/email.php';
			if (!is_valid_email($email))
				$cal_errors[] = $lang_common['Invalid e-mail'];
		}
	}

	// Clean up message from POST
	$message = $puntal->linebreaks(pun_trim($_POST['req_message']));

	if ($message == '')
		$cal_errors[] = $lang_post['No message'];
	else if (strlen($message) > 65535)
		$cal_errors[] = $lang_post['Too long message'];
	else if ($puntal->pun_config['p_message_all_caps'] == '0' && strtoupper($message) == $message && $puntal->user['g_id'] > PUN_MOD)
		$message = ucwords(strtolower($message));

	// Validate BBCode syntax
	if ($puntal->pun_config['p_message_bbcode'] == '1' && strpos($message, '[') !== false && strpos($message, ']') !== false)
	{
		$message = preparse_bbcode($message, $cal_errors);
	}
	
	// Did everything go according to plan?
	if (empty($cal_errors) && !isset($_POST['preview']))
	{
		// If we have to post new topic
		$forum_id = 0;		
			
		if (pt_mod_calendar_cat_forum != '') {
			if (isset ($_POST['req_category']) and is_numeric ($_POST['req_category'])) 
				$forum_id = (integer) $_POST['req_category'];			
		}
		
		if (pt_mod_calendar_forum_id > 0 and $forum_id == 0) 
			$forum_id = pt_mod_calendar_forum_id;
		
		if ($forum_id > 0)
		{
	
			$now = time();

			// Create the topic
			$new_tid = $calendar->setTopic($username,$subject,$now,$forum_id,0,0);
				
			if (!$puntal->user['is_guest'])
			{
				// To subscribe or not to subscribe, that ...
				if ($puntal->pun_config['o_subscriptions'] == '1' && (isset($_POST['subscribe']) && $_POST['subscribe'] == '1'))
					$puntal->con->execute('INSERT INTO '.DB_PREFIX.'subscriptions (user_id, topic_id) VALUES('.$puntal->user['id'].' ,'.$new_tid.')') or $puntal->err->fatalError($puntal->con->error());
	
				// Create the post ("topic post")
				$new_pid = $calendar->setPosts($username,$message,$hide_smilies,$now,$new_tid,'');
				
			}
			else
			{
				// Create the post ("topic post")
				$email_sql = ($puntal->pun_config['p_force_guest_email'] == '1' || $email != '') ? '\''.$email.'\'' : 'NULL';
				$new_pid = $calendar->setPosts($username,$message,$hide_smilies,$now,$new_tid,$email_sql);
				
			}
			
			// Update the topic with last_post_id			
			$calendar->setTopic('','','','',$new_pid,$new_tid);
	
			punbb::updateSearchIndex('post', $new_pid, $message, $subject);
	
			punbb::updateForum($forum_id);

			// If the posting user is logged in, increment his/her post count
			if (!$puntal->user['is_guest'])
			{
				//$low_prio = ($db_type == 'mysql') ? 'LOW_PRIORITY ' : '';
				$low_prio = '';
				//$low_prio = 'LOW PRIORITY ';
				$strUpd = "UPDATE ".$low_prio.DB_PREFIX."users SET num_posts=num_posts+1, last_post='".$now."' WHERE id='".$puntal->user['id']."'";
				$puntal->con->execute($strUpd) or $puntal->err->fatalError($puntal->con->error());
			}
		}
		if (!$puntal->user['is_guest'])
		{
			$result = $puntal->con->execute("INSERT INTO ".DB_PREFIX."pt_calendar ( date, title, content, user_id, user_name, tid, pid, cat_id ) VALUES ( '".strtotime($_POST['event_annee'].'-'.$_POST['event_mois'].'-'.$_POST['event_jour'])."', '".$puntal->con->escapeStr($subject)."', '".$puntal->con->escapeStr($message)."', '".$puntal->user['id']."', '".$puntal->con->escapeStr($username)."', '".$new_tid."', '".$new_pid."','".$calendar_cat_id."') ") or $puntal->err->fatalError($puntal->con->error());
		} 
		else  {
			$email_sql = ($puntal->pun_config['p_force_guest_email'] == '1' || $email != '') ? '\''.$email.'\'' : 'NULL';
			$result = $puntal->con->execute("INSERT INTO ".DB_PREFIX."pt_calendar ( date, title, content, user_name, tid, pid ) VALUES ( '".strtotime($_POST['event_annee'].'-'.$_POST['event_mois'].'-'.$_POST['event_jour'])."', '".$puntal->con->escapeStr($subject)."', '".$puntal->con->escapeStr($message)."', '".$puntal->con->escapeStr($username)."', '".$new_tid."', '".$new_pid."', '".$calendar_cat_id."') ") or $puntal->err->fatalError($puntal->con->error());
		}
		
		$puntal->redirect(pt_portal_url.CAL_URL, __('Event Added'));
	}
}
} else $puntal->setToken();
}

?>