<?php
/***********************************************************************

  Copyright (C) 2005-2006 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;


# FR - Initialisation des variables de configuration  
# EN - Initialization of the configuration variables 
$forum_id = pt_mod_calendar_forum_id;
$p_groups = unserialize(pt_mod_calendar_groups);

if (pt_mod_calendar_cat_forum != '')
	$p_cat_forum_array 	= unserialize(pt_mod_calendar_cat_forum);
else
	$p_cat_forum_array = array(); 

# FR - Formulaire envoy
# EN - Submitted Form
if (!empty($_POST['form_sent']) && $puntal->checkToken() ) 
{
	# Rcupration et nettoyage des donnes du formulaire.
	$forum_id = intval(trim($_POST['forum_id']));
	$p_groups = (!empty($_POST['p_groups']) ? array_map('intval',array_map('trim',$_POST['p_groups'])) : array());

	
	if (empty($p_groups)) 
		$common_error = __('You have to choose at least one group');
	else {
		# Ici on se place dans l'espace de nommage du module
		$pt_settings->setNamespace('mod_calendar');    
		
		# On change les valeurs de nos paramtres de configuration
		$res = true;
		$res &= $pt_settings->put('pt_mod_calendar_forum_id', (integer) $forum_id );
		$res &= $pt_settings->put('pt_mod_calendar_groups', serialize($p_groups));	
	
		$pt_settings->setNamespace('');
		
		# Si tout c'est bien pass...
		if ($res)
		{
			# On enregistre un log
			logIt('Calendar module : edit config', 1);
			
			# Et on redirige
			header('Location: module.php?id=calendar&action=2&updated=1');
			exit;
		}
		# Sinon on fixe un message d'erreur
		else
			$puntal->setError(__('Unable to update the Puntal configuration'));
	}
}
elseif (  !empty($_POST['config_calendar_forum']) && $puntal->checkToken() ) {
	
	$forum_id = array_map('trim', $_POST['forum_cat']);
	$p_cat_forum_array = array();
	
	for ($i=0;$i<count($forum_id);$i++) {
		if ($forum_id[$i] != '') 
			$p_cat_forum_array[$i] = $forum_id[$i]; 
	}
		
	# Ici on se place dans l'espace de nommage du module
	$pt_settings->setNamespace('mod_calendar');    
	
	# On change les valeurs de nos paramtres de configuration
	$res = true;
	$res &= $pt_settings->put('pt_mod_calendar_cat_forum', serialize($p_cat_forum_array));
			$pt_settings->setNamespace('');
	
	# Si tout c'est bien pass...
	if ($res)
	{
		# On enregistre un log
		logIt('Calendar module : edit config', 1);
		
		# Et on redirige
		header('Location: module.php?id=calendar&action=2&updated=1');
		exit;
	}
	# Sinon on fixe un message d'erreur
	else
		$puntal->setError(__('Unable to update the Puntal configuration'));	
	
}
elseif (  !empty($_POST['add_calendar_forum'])  && $puntal->checkToken() ) {
	
	$forum_id = trim( $_POST['forum_cat']);
	if (is_numeric($forum_id)) 
		array_push($p_cat_forum_array , $forum_id);
	else 
		$puntal->setError(__('Unable to update the Puntal configuration'));
		
	# Ici on se place dans l'espace de nommage du module
	$pt_settings->setNamespace('mod_calendar');    
	
	# On change les valeurs de nos paramtres de configuration
	$res = true;
	$res &= $pt_settings->put('pt_mod_calendar_cat_forum', serialize($p_cat_forum_array));
			$pt_settings->setNamespace('');
	
	# Si tout c'est bien pass...
	if ($res)
	{
		# On enregistre un log
		logIt('Calendar module : edit config', 1);
		
		# Et on redirige
		header('Location: module.php?id=calendar&action=2&updated=1');
		exit;
	}
	# Sinon on fixe un message d'erreur
	else
		$puntal->setError(__('Unable to update the Puntal configuration'));	
	
}

$n_category = '';
$n_forum = '';

# Set token
$puntal->setToken();


# FR - Messages de confirmation
# EN - Confirmation Messages
if (!empty($_GET['updated']) and $common_error == '')
	$common_message = __('Configuration updated');
	
# FR - Liste des forums
# EN - List of forums
$forums_array = array();
$forums_array['&nbsp;'] = '';

$forums = punbb::getForums();
while ($forums->fetch())
	$forums_array[html::escapeHTML($forums->f('cat_name'))][html::escapeHTML($forums->f('forum_name'))] = $forums->f('fid');

# Liste des groupes
$groups = punbb::getGroups();

/* Affichage de la page
----------------------------------------------------------*/
adminPage::open(__('Calendar configuration'),	
'<script type="text/javascript">'."\n".
"//<![CDATA[\n".
"$(function() {
	$('.checkboxes-helpers').each(function() {
		puntal.checkboxesHelpers(this);
	});
});".
"//]]>\n".
"</script>"."\n");
?>

<h2 class="first"><img src="index.php?pf=calendar/img/ico_calendar_config.png" alt="" class="icon" /> <?php echo __('Calendar configuration') ?></h2>

<form action="module.php" method="post">

	<p class="field"><label for="forum_id"><?php echo __('Forum') ?></label>
	<?php echo form::combo('forum_id', $forums_array, $forum_id) ?>
	<span class="desc"><?php echo __('The default forum in which a new topic will be started for each new event <strong>without category</strong>. Leave it blank to not start topic, the comments will then not be possible.') ?></span></p>

	<p><span class="fakelabel"><?php echo __('Allowed groups') ?></span>
	<span class="desc"><?php echo __('The groups which can add event to the calendar.') ?></span></p>
	<ul class="checklist">
<?php
while ($groups->fetch()) 
{
	if ($groups->f('g_id') != PUN_ADMIN)
		echo '<li><label>'.form::checkbox(array('p_groups[]'),$groups->f('g_id'),in_array($groups->f('g_id'),$p_groups),'checkbox').html::escapeHTML($groups->f('g_title')).'</label></li>';
}
?>
	</ul>
	<p><span class="desc checkboxes-helpers"></span></p>
	
	<p><?php echo 
	form::hidden(array('id'),'calendar')."\n".
	form::hidden(array('action'),2)."\n".
	form::hidden(array('form_sent'),'1')."\n" .
	form::hidden(array('ptkn'),$puntal->getToken()); ?>
	<input class="submit" type="submit" value="<?php echo __('Save') ?>" /></p>
	
</form>
<h3><?php echo __('Management of the Event Categories'); ?></h3>
<?php echo __('If you need you can also create a category for your event, and also choose a dedicated forum in which post will go when an event will be done.<br/>If you don\'t need to use category but need a dedicated forum, then use the above options'); ?>
<?php if (count($p_cat_forum_array) > 0)  { ?>
<form action="module.php" method="post">	
	<fieldset>
		<legend><?php echo __('List of Categories and Forums') ?></legend>
		<div class="two-cols">
		<?php echo __('Here you can modify the categories/forums you previously define') ;?>
				
<?php
		
		for ($i=0; $i<count($p_cat_forum_array); ++$i)
		{
			$forum_value[$i] = 	$p_cat_forum_array[$i];
			
			echo 		
			'<p class="field col"><label>'. __('Forum') .'<br/>'."\n".
			form::combo('forum_cat['.$i.']', $forums_array, $forum_value[$i]) . '</label>'."\n".
			'<span class="desc">'. __('Leave it blank to not start topic, the comments will then not be possible.') .'</span>'."\n".
			'</p><br/>';
		}
?>			
		</div>
		</fieldset>
		<p><?php echo 
			form::hidden('config_calendar_forum','1')."\n".
			form::hidden(array('id'),'calendar')."\n".
			form::hidden(array('action'),2)."\n".			
			form::hidden(array('ptkn'),$puntal->getToken()); ?>
			
			<input class="submit" type="submit" value="<?php echo __('Save') ?>" /></p>
</form>
<?php } ?>		
<form action="module.php" method="post">	
	
	<fieldset>
		<legend><?php echo __('Add a Category and Forum for your events'); ?></legend>
		<div class="two-cols">
		
			<p class="field col"><label><?php echo __('Forum') ?><br />
			<?php echo form::combo('forum_cat', $forums_array, '') ?></label>
			<span class="desc"><?php echo __('Leave it blank to not start topic, the comments will then not be possible.') ?></span>
			</p>
		</div>
	</fieldset>
			
	<p><?php echo 
	form::hidden('add_calendar_forum','1')."\n".
	form::hidden(array('id'),'calendar')."\n".
	form::hidden(array('action'),2)."\n".			
	form::hidden(array('ptkn'),$puntal->getToken()); ?>
	<input class="submit" type="submit" value="<?php echo __('Add'); ?>" /></p>
</form>
	
<?php adminPage::close() ?>

