<?php
/***********************************************************************

  Copyright (C) 2005 Vincent Garnier (vin100@forx.fr)
  
  This file is part of Puntal.

  Puntal is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  PunBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

class calendarManager { 

	var $pt_cal_text ;
	var $pt;
	
	function calendarManager (&$puntal) {
	
		$this->pt 	= $puntal;
		$this->c 	= DB_PREFIX.'pt_calendar';
		$this->cc 	= DB_PREFIX.'pt_calendar_cat';
		
		global $GLOBALS;
		//Tableau de dfinition de textes pour le calendrier
		$this->pt_cal_text = array(
			'name'	=>	$GLOBALS['__l10n']['Calendar'],
			'month' => array(
				$GLOBALS['__l10n']['January'],
				$GLOBALS['__l10n']['February'],
				$GLOBALS['__l10n']['March'],
				$GLOBALS['__l10n']['April'],
				$GLOBALS['__l10n']['May'],
				$GLOBALS['__l10n']['June'],
				$GLOBALS['__l10n']['July'],
				$GLOBALS['__l10n']['August'],
				$GLOBALS['__l10n']['September'],
				$GLOBALS['__l10n']['October'],
				$GLOBALS['__l10n']['November'],
				$GLOBALS['__l10n']['December'],
			),
			
			'day' => array(
				$GLOBALS['__l10n']['Monday'],
				$GLOBALS['__l10n']['Tuesday'],
				$GLOBALS['__l10n']['Wednesday'],
				$GLOBALS['__l10n']['Thursday'],
				$GLOBALS['__l10n']['Friday'],
				$GLOBALS['__l10n']['Saturday'],
				$GLOBALS['__l10n']['Sunday']
			)
		);

	}
	
	
	/**
	@function getCalEventMonth
	
	@param 	integer	annee
	@param 	integer	mois
	
	retourne les evenements de l'anne et mois choisies
	*/			
	function getCalEventMonth($annee, $mois)
	{
		$strQuery = "SELECT date FROM ".DB_PREFIX."pt_calendar WHERE date>='".strtotime($annee.'-'.$mois.'-01')."' AND date<='".strtotime($annee.'-'.$mois.'-31')."'";
		$rs = $this->pt->con->select($strQuery)  or $this->pt->err->fatalError(printf(__('Impossible de trouver les evenements de %s/%s'),$mois,$annee));
		return $rs;
	}
	
	/**
	@function getCalEvent
	
	@param 	integer	annee
	@param 	integer	mois
	@param 	integer	jour
	
	retourne les evenements du jour choisi
	*/				
	function getCalEvent($annee,$mois,$jour) {
	
		if (pt_mod_calendar_forum_id > 0 ) 
			$strQuery = "SELECT c.id, title, content, user_id, tid, hide_smilies FROM ".DB_PREFIX."pt_calendar AS c LEFT JOIN  ".DB_PREFIX."posts AS p ON c.pid = p.id WHERE date = '".strtotime($annee.'-'.$mois.'-'.$jour)."'";
		else 
			$strQuery = "SELECT id, title, content, user_id, tid, '' as hide_smilies FROM ".DB_PREFIX."pt_calendar WHERE date = '".strtotime($annee.'-'.$mois.'-'.$jour)."'";		

		$rs = $this->pt->con->select($strQuery)  or $this->pt->err->fatalError(printf(__('Impossible de trouver les evenements de %s-%s-%s'),$jour,$mois,$annee));
		return $rs;
	}

	/**
	@function getDayEvent
	
	@param 	string	ts_day
	
	retourne le titre de l'evenement choisi
	*/	
	function getDayEvent ($ts_day) 
	{
		
		$rs = $this->pt->con->select("SELECT title FROM ".DB_PREFIX."pt_calendar WHERE date = '".$ts_day."'") 
				or $this->pt->err->fatalError(printf(__('Impossible de trouver les evenements de %s'),$ts_day));
		return $rs;
	}
	
	/**
	@function getPermission
	
	@param 	array		allowed_groups
	
	permet de vrifier si l'utilisateur a droit de modifier/suppirmer/ajouter des evenements
	*/		
	function getPermission ($allowed_groups) {
	
		$cur_posting = '';
		$return = true;
		
		// est-ce que l'utilisateur est autoris ?
		if  ( $this->pt->user['is_admin'] == false and ! in_array($this->pt->user['g_id'], $allowed_groups)) {
			 $this->pt->err->fatalError( __('No permission') ) ;
			 return false;
		}
		
		return $return;				
		
	}

	/**
	@function searchEntry
	
	Recherche d'un evenement selon des mots cl et renvoie un recordset.
	
	@param	string	w			Mots cl
           @param       string          limit                           Limitation du nombre de resultats affichs
	@return	recordset
	*/
	function searchEntry($w,$limit='')
	{
		$strip = array('+',')','(',',','\'');
		$w = strtolower($w);
		$w = str_replace($strip,' ',$w);
		$w = preg_replace('/( )+/',' ',$w);
		
		$reqPlus = '';
		foreach(explode(' ',$w) as $v)
		{
			$reqPlus .= 
			' AND ( LOWER(title) LIKE \'%'.$this->pt->con->escapeStr($v).'%\' OR '.
			'LOWER(content) LIKE \'%'.$this->pt->con->escapeStr($v).'%\') ';
		}
		
		$sql = 
		'SELECT * FROM '.DB_PREFIX.'pt_calendar WHERE 1=1 '.$reqPlus. 'ORDER BY date DESC';
        
        if ($limit != '')
			$sql = $sql.' LIMIT '.$limit;

		$rs = $this->pt->con->select($sql) or $this->pt->err->fatalError($this->pt->con->error());
		
		return $rs;
	}   


	function setTopic ($username='',$subject='',$now='',$forum_id='',$new_pid, $new_tid) {
		if ($new_pid == 0) {
			$insSQL =
			 	'INSERT INTO '.DB_PREFIX.'topics '.
				'(poster, subject, posted, last_post, last_poster, forum_id) '.
				'VALUES(\''.$this->pt->con->escapeStr($username).'\', 
						\'' .$this->pt->con->escapeStr($subject).'\', 
						\''.$now.'\',  
						\''.$now.'\', 
						\''.$this->pt->con->escapeStr($username).'\',
						\''.$forum_id.'\')';
			$this->pt->con->execute($insSQL) or $this->pt->err->fatalError($this->pt->con->error());
			return $this->pt->con->getLastID();
		}
		else {
			$this->pt->con->execute('UPDATE '.DB_PREFIX.'topics SET last_post_id='.$new_pid.' WHERE id='.$new_tid) or $this->pt->err->fatalError($this->pt->con->error());
		}	
	}
	
	function setPosts ($username,$message,$hide_smilies,$now,$new_tid,$email_sql='') {
		if ($email_sql == '')
			$insSQL = 'INSERT INTO '.DB_PREFIX.'posts (poster, poster_id, poster_ip, message, hide_smilies, posted, topic_id)'.
			' VALUES(\''.$this->pt->con->escapeStr($username).'\', '.$this->pt->user['id'].', \''.$_SERVER['REMOTE_ADDR'].'\', \''.$this->pt->con->escapeStr($message).'\', \''.$hide_smilies.'\', '.$now.', '.$new_tid.')';
		else 
			$insSQL = 'INSERT INTO '.DB_PREFIX.'posts (poster, poster_ip, poster_email, message, hide_smilies, posted, topic_id)'.
			' VALUES(\''.$this->pt->con->escapeStr($username).'\', \''.$_SERVER['REMOTE_ADDR'].'\', '.$email_sql.', \''.$this->pt->con->escapeStr($message).'\', \''.$hide_smilies.'\', '.$now.', '.$new_tid.')';

		$this->pt->con->execute($insSQL) or $this->pt->err->fatalError($this->pt->con->error());		
		return $this->pt->con->getLastID();	
	}



	/**
	getCat<br/>

	
	<strong>FR</strong> Selectionne une ou plusieurs categories.<br/>
	La parametre <strong>cat_id</strong> peut tre un entier ou une chaine.<br/>
	S'il s'agit d'un entier, la comparaison sera fait sur la colonne <strong>cat_id</strong>.<br/>
	S'il s'agit d'une chaine, la comparaison sera faite sur la colonne <strong>cat_url</strong>.<br/>
	
	Si le parametre <strong>cat_id</strong> est <em>vide</em>, toutes les categories seront
	renvoyees dans le recordset (fonctionnement par defaut).<br/>
	
	La methode renvoie <strong>false</strong> en cas d'erreur.<br/>

	<strong>EN</strong>Select one or more categories.<br/> 
	The parameter <strong>cat_id</strong> can be an integer or a string.
	If it's an integer, then it will be compare with the column <strong>cat_id</strong>. <br/>
	If it's a string, then it will be compare with the column <strong>cat_url</strong>.<br/>
	
	If the parameter <strong>cat_id</strong> is <em>empty</em>, 
	all the categories will be returned in the recordset (by default).<br/>
	
	the function return <strong>false</strong> in case of error.<br/>
		
	@param	cat_id	<strong>mixed</strong>	Category ID
	@param	order_by <strong>string</strong>	Field use to sort the results.
	@return	recordset
	*/
	function getCat($cat_id='',$order_by='cat_ord')
	{
		$reqPlus = '';
		
		if ($cat_id != '')
		{
			if (preg_match('/^[0-9]+$/',$cat_id))
				$reqPlus .= 'AND C.cat_id='.(integer) $cat_id.' ';
			else
				$reqPlus .= 'AND C.cat_url=\''.$this->pt->con->escapeStr($cat_id).'\' ';
		}
		
		$strReq = 
		'SELECT C.cat_id, cat_name, cat_url, cat_desc, '.
		'cat_ord, count(P.id) AS nb_calendar '.
		'FROM '.$this->cc.' C '.
		'LEFT JOIN '.$this->c.' P ON C.cat_id = P.cat_id '.
		'WHERE 1 '.
		$reqPlus.
		'GROUP BY C.cat_id '.
		'ORDER BY '.$this->pt->con->escapeStr($order_by);
		
		$rs = $this->pt->con->select($strReq) or $this->pt->err->fatalError($this->pt->con->error());

		return $rs;
	}

	/**
	existingCats<br/>
	
	<strong>FR</strong> Vrifie l'existance d'une catgorie de calendrier.
	<strong>EN</strong> Check the existence of one category of the calendar 
	@return	recordset
	*/
	function existingCats()
	{
	
		$strReq = 'SELECT count(C.cat_id) as ttl_cat FROM '.$this->cc.' as C'; 
		
		$rs = $this->pt->con->select($strReq) or $this->pt->err->fatalError($this->pt->con->error());
		$rs->getData('0');
		return $rs->f('ttl_cat');
	}

	/**
	checkCat<br/>
	
	<strong>FR</strong> Verifie l'existence de la categorie. Retourne true ou false<br/>
	<strong>EN</strong> Check if the category exists. Return True or False.
		
	@param	cat_id <strong>integer</strong>		Category ID	
	@return	boolean
	*/
	function checkCat($cat_id)
	{
		$strReq = 
		'SELECT count(cat_id) FROM '.$this->cc.' '.
		'WHERE cat_id='.(integer) $cat_id.' ';
		
		$rs = $this->pt->con->select($strReq);
		
		if ($rs == false || $rs->field(0) == '0')
			return false;
		else
			return true;
	}	
	
}
?>
