<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

$GLOBALS['puntal']->blocks->registerBlock('directory_menu',
	array('dirPublicBlocks','directory_menu'));

	
# Signalisation liens  valider
$GLOBALS['puntal']->addBehavior('adminIndexHTML', array('directoryBehavior','getValidateLinks'));
	
# Recherche sur l'annuaire
$GLOBALS['puntal']->addBehavior('searchPerform', array('directoryBehavior','performSearch'));
	
# Rsultats de recherche
$GLOBALS['puntal']->addBehavior('searchResults', array('directoryBehavior','searchResults'));

# Affiche le nombre de Rsultats de recherche
$GLOBALS['puntal']->addBehavior('searchResultsTtl', array('directoryBehavior','searchResultsTtl'));

class directoryBehavior
{
	function getValidateLinks()
	{
		global $puntal;
		
		$rs = $puntal->con->select('SELECT COUNT(entry_id) AS num_link FROM '.DB_PREFIX.'pt_dir_entrie WHERE entry_state=0') or $puntal->err->fatalError($puntal->con->error());
		
		if ($rs->f('num_link') > 0)
		{
			echo '<div class="warningbox"><h2>'.__('Directory').'</h2>'.
			'<p><a href="module.php?id=directory&amp;action=1&amp;status=0">'.
			sprintf(__('There are %s website(s) on standby of validation.'), $rs->f('num_link')).
			'</a></p></div>';
		}
	}
	
	function performSearch()
	{
		global $puntal;
		
		if (file_exists(PT_THEMES_PATH.pt_theme.'/directory/directory.css'))
			$GLOBALS['extra_header'] .= '<link rel="stylesheet" type="text/css" href="'.PT_THEMES_URL.pt_theme.'/directory/dir.css'.'" />';
		else
			$GLOBALS['extra_header'] .= '<link rel="stylesheet" type="text/css" href="'.PT_THEMES_URL.PT_DEFAULT_THEME.'/directory/dir.css'.'" />';
		
		require dirname(__FILE__).'/inc/dir.class.php';
		$dir = new dirManager($puntal);
		
		$rs_cats = $dir->getCat('','cat_ord', false);
		$arryDirCat = array();
		$dir->getListCat($rs_cats,$arryDirCat,'',$rs_cats->int_index,'0','');
		$GLOBALS['arryDirCat'] = array_flip($arryDirCat);
		
		#la recherche est-elle vide ?
		if (strlen(trim($_GET['q'])) > 2 )		  		
			$GLOBALS['liens'] = $dir->searchEntry($_GET['q'], pt_mod_search_num_per_page );
	}
	
	
	function searchResults()
	{
		global $liens;
		
		#on teste que $liens existe ET qu'il n'est pas vide 
		if ($liens and !$liens->isEmpty())
		{
			require dirname(__FILE__).'/inc/tpl_functions.php';
			
			if (file_exists(PT_THEMES_PATH.pt_theme.'/directory/search_results.php'))
				require PT_THEMES_PATH.pt_theme.'/directory/search_results.php';
			else
				require PT_THEMES_PATH.PT_DEFAULT_THEME.'/directory/search_results.php';
		}
	}
	
	function searchResultsTtl() {
		global $liens;
		
		if ($liens and !$liens->isEmpty()) {		
			$GLOBALS['search_ttl'] += $liens->nbRow();
			return $GLOBALS['search_ttl'];			
		}		
	}		
	
}

?>