<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

/**
@function install_directory

La fonction charge de l'installation du module directory.
*/
function install_directory()
{
	/* Structure de la base de donnes
	----------------------------------------------------------*/
	$db_scheme = array();
	
	# Structure de la table 'pt_dir_categorie'
	$db_scheme[] = array(
		'action' 	=> 'add',
		'table' 	=> DB_PREFIX.'pt_dir_categorie',
		'query' 	=> 
		'CREATE TABLE '.DB_PREFIX."pt_dir_categorie (
		cat_id 				INT(11) 		NOT NULL auto_increment,
		cat_name 			VARCHAR(255) 	NOT NULL,
		cat_name_url 		VARCHAR(255) 	NOT NULL,
		cat_desc 			TEXT,
		cat_root 			VARCHAR(255) 	NOT NULL DEFAULT '',
		cat_enable 			TINYINT(1) 		NOT NULL DEFAULT 1,
		cat_ord 			INT(11) 		DEFAULT NULL,
		PRIMARY KEY (cat_id),
		UNIQUE KEY cat_name_url (cat_name_url),
		UNIQUE KEY cat_name (cat_name)
		) TYPE=MyISAM;"
	);

	# Structure de la table 'pt_dir_entrie'
	$db_scheme[] = array(
		'action' 	=> 'add',
		'table' 	=> DB_PREFIX.'pt_dir_entrie',
		'query' 	=> 
		'CREATE TABLE '.DB_PREFIX."pt_dir_entrie (
		entry_id 			INT(11) 		NOT NULL auto_increment,
		entry_name 			VARCHAR(255) 	NOT NULL,
		entry_url 			VARCHAR(255) 	NOT NULL,
		entry_dt 			DATETIME 		DEFAULT NULL,
		entry_lang 			VARCHAR(5) 		DEFAULT NULL,
		entry_description 	TEXT,
		entry_state 		TINYINT(1) 		NOT NULL DEFAULT 0,
		entry_category 		INT(11) 		NOT NULL DEFAULT 0,
		entry_pr 			TINYINT(2) 		NOT NULL DEFAULT 0,
		entry_clik 			INT(11) 		NOT NULL DEFAULT 0,
		entry_selected 		TINYINT(1) 		NOT NULL DEFAULT 0,
		PRIMARY KEY (entry_id)
		) TYPE=MyISAM;"
	);
		
	/* Paramtres de configuration
	----------------------------------------------------------*/
	$params = array();
	
	$params[] = array(
		'action'	=> 'add',
		'name'	 	=> 'pt_mod_directory_groups',
		'type' 		=> 'string',
		'init' 		=> 'a:2:{i:0;i:2;i:1;i:4;}'
	);
	
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_mod_directory_google_pr',
		'type' 		=> 'boolean',
		'init'		=> true
	);	
	
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_mod_directory_google_pr_method',
		'type' 		=> 'boolean',
		'init'		=> false
	);	
	
	$params[] = array(
		'action'	=> 'add',
		'name'	 	=> 'pt_mod_directory_google_pr_ttl',
		'type' 		=> 'integer',
		'init' 		=> 24
	);
	
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_mod_directory_nb_entry_pr',
		'type' 		=> 'integer',
		'init' 		=> 10
	);
	
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_mod_directory_tc',
		'type' 		=> 'boolean',
		'init' 		=> true
	);
	
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_mod_directory_nb_entry_tc',
		'type' 		=> 'integer',
		'init' 		=> 10
	);
	
	$params[] = array(
		'action'	=> 'add',
		'name' 		=> 'pt_mod_directory_nb_entry_new',
		'type' 		=> 'integer',
		'init' 		=> 10
	);
	
	/* Rpertoire cache pour le page rank google
	----------------------------------------------------------*/
	$dirs = array();
	$dirs[] = PT_CACHE_PATH.'directory_google_pr';
	
	
	/* Installation du module
	----------------------------------------------------------*/
	$GLOBALS['install_module']->install($db_scheme,$params,$dirs);
}


?>