<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

require_once PT_INC_PATH."libs/punbb_parser.php";

# Annuaire
require dirname(__FILE__).'/inc/dir.class.php';
$dir = new dirManager($puntal);

# Template
require dirname(__FILE__).'/inc/tpl_functions.php';
$pt_template_file = '/directory/main.php';

# Initialisations
$allowed_groups = unserialize(pt_mod_directory_groups);
$dir_mode = 'home';

# Titre page
$pt_custom_title_page[] = __('Directory');

# Liste des catgories de l'annuaire
$rs_cats = $dir->getCat('','cat_ord', false);

/**
	Parcours des arguments pour dfinir le mode
*/
if (!empty($pt_args[1]))
{
	if ($pt_args[1] == DIR_URL_TOPCLICK || 
		$pt_args[1] == DIR_URL_TOPRANK || 
		$pt_args[1] == DIR_URL_NOVELTIES || 
		$pt_args[1] == DIR_URL_SUBMIT)
	{
		$dir_mode = 'page';
		$dir_page = $pt_args[1];
	}
	elseif ($pt_args[1] == DIR_URL_SHOW && preg_match('!^([0-9]+)!',$pt_args[2],$match))
	{
		$dir_mode = 'goto';
		$link_id = $match[1];
	}
	elseif (preg_match('!^([A-Z][A-Za-z0-9_-]*)([^/]*)?(/|\z)!',$pt_args[1],$match))
	{
		$dir_mode = 'cat';
		$dir_cat_id = $match[1];
	}
}

/**
	Action en fonction du mode
*/

# Affichage de l'accueil
if ($dir_mode == 'home')
{
	# on n'affiche que les categories dont on a mis les sites au status "En ligne"
	$cats = $dir->getCat('','cat_ord','',3);
}

# Voir un site
elseif ($dir_mode == 'goto')
{
	$lien = $dir->getLink($link_id);
	$dir->addLinkClik($lien->f('entry_id'));
	header('HTTP/1.1 301 Moved Permanently');
	header('Location: '.$lien->f('entry_url'));
	exit;
}

# Affichage d'une catgorie
elseif ($dir_mode == 'cat' && $dir_cat_id)
{
	$cat = $dir->getCat($dir_cat_id,'cat_ord');
	$cats = $dir->getCat('','cat_ord',$dir_cat_id);
	$liens = $dir->getLink('',$cat->f('cat_id'),'3');
	$dir->updPr($liens);
	
	$pt_custom_title_page[] = $cat->f('cat_name');
}

# Affichage d'une page de l'annuaire
elseif ($dir_mode == 'page')
{
	# Affichage des nouveauts
	if ($dir_page == DIR_URL_NOVELTIES)
	{
		$dir_mode = 'novelties';
		$arryDirCat = array();
		$dir->getListCat($rs_cats,$arryDirCat,'',$rs_cats->int_index,'0','');
		$arryDirCat = array_flip($arryDirCat);
		
		$liens = $dir->getLink('','','3','entry_dt','DESC',pt_mod_directory_nb_entry_new);
		
		$dir->updPr($liens);
					
		$pt_custom_title_page[] = __('Novelties');
	}
	
	# Affichage du toprank
	elseif ($dir_page == DIR_URL_TOPRANK && pt_mod_directory_google_pr)
	{
		$dir_mode = 'toprank';
		$arryDirCat = array();
		$dir->getListCat($rs_cats,$arryDirCat,'',$rs_cats->int_index,'0','');
		$arryDirCat = array_flip($arryDirCat);
		
		$liens = $dir->getLink('','','3','entry_pr','DESC',pt_mod_directory_nb_entry_pr);
		
		$dir->updPr($liens);
		
		$pt_custom_title_page[] = __('Top Google Page Rank');
	}
	
	# Affichage du top cliques
	elseif ($dir_page == DIR_URL_TOPCLICK && pt_mod_directory_tc)
	{
		$dir_mode = 'topclick';
		$arryDirCat = array();
		$dir->getListCat($rs_cats,$arryDirCat,'',$rs_cats->int_index,'0','');
		$arryDirCat = array_flip($arryDirCat);
		
		$liens = $dir->getLink('','','3','entry_clik','DESC',pt_mod_directory_nb_entry_tc);
		
		$dir->updPr($liens);
		
		$pt_custom_title_page[] = __('Top clicks');
	}
	
	# Affichage du formulaire d'ajout de site
	elseif ($dir_page == DIR_URL_SUBMIT && ($puntal->user['is_admin'] || in_array($puntal->user['g_id'], $allowed_groups)))
	{
		$dir_mode = 'submit';

		$l_titre = '';
		$l_cat = '';
		$l_href = 'http://';
		$l_desc = '';
		$l_lang = '';

		$arryDirCat = array();
		$dir->getListCat($rs_cats,$arryDirCat,'',$rs_cats->int_index);
		
		$pt_custom_title_page[] = __('Submit a website');
		
		# Le formulaire d'ajout a t envoy
		if (!empty($_POST['form_sent']) && $puntal->checkToken())
		{
			$l_titre = !empty($_POST['l_titre']) ? trim($_POST['l_titre']) : $l_titre;
			$l_href = !empty($_POST['l_href']) ? trim($_POST['l_href']) : $l_href;
			$l_date = date('Y-m-d H:i:s', time());
			$l_cat = !empty($_POST['l_cat']) ? trim($_POST['l_cat']) : $l_cat;
			$l_desc = !empty($_POST['l_desc']) ? trim($_POST['l_desc']) : $l_desc;
			$l_lang = !empty($_POST['l_lang']) ? trim($_POST['l_lang']) : $l_lang;

			if (($entry_id = $dir->setLink($l_titre,$l_href,$l_date,'0',$l_cat,$l_desc,$l_lang,0)) !== false)
			{
				$puntal->redirect($puntal->url('directory'), __('Your site was submited, an administrator will examine your request.'));
			}
		} else $puntal->setToken();
	}	
}

?>