<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

$p_forum = pt_mod_downloads_forum_id;
$p_guest = pt_mod_downloads_guest;
$p_extern = pt_mod_downloads_leech;
$p_path = pt_mod_downloads_path;
$p_last_dl = pt_mod_downloads_last_dl;
$p_popular_dl = pt_mod_downloads_popular_dl;
$p_num_home = pt_mod_downloads_num;
$p_num_bloc = pt_bloc_downloads_num;
$p_top_num_bloc = pt_bloc_downloads_top_num;

/* Form sent */
if (!empty($_POST['form_sent']) && $puntal->checkToken())
{
	$p_forum = intval(trim($_POST['p_forum']));
	$p_guest = intval(trim($_POST['guest']));
	$p_extern = intval(trim($_POST['extern']));
	$p_path = trim($_POST['path']);
	$p_last_dl = intval(trim($_POST['last_dl']));
	$p_popular_dl = intval(trim($_POST['popular_dl']));
	$p_num_home = intval(trim($_POST['num_home']));
	$p_num_bloc = intval(trim($_POST['num_bloc']));
	$p_top_num_bloc = intval(trim($_POST['top_num_bloc']));
	
	// Mise  jour de la configuration
	$pt_settings->setNamespace('mod_downloads');
	
	$res = true;
	$res &= $pt_settings->put('pt_mod_downloads_forum_id', $p_forum);
	$res &= $pt_settings->put('pt_mod_downloads_guest', $p_guest);
	$res &= $pt_settings->put('pt_mod_downloads_leech', $p_extern);
	$res &= $pt_settings->put('pt_mod_downloads_path', $p_path);
	$res &= $pt_settings->put('pt_mod_downloads_last_dl', $p_last_dl);
	$res &= $pt_settings->put('pt_mod_downloads_popular_dl', $p_popular_dl);
	$res &= $pt_settings->put('pt_mod_downloads_num', $p_num_home );
	$res &= $pt_settings->put('pt_bloc_downloads_num', $p_num_bloc );
	$res &= $pt_settings->put('pt_bloc_downloads_top_num', $p_top_num_bloc );

	$pt_settings->setNamespace('');
	
	if ($res)
	{
		logIt('downloads module : edit config', 1);
		header('Location: module.php?id=downloads&action=5&updated=1');
		exit;
	}
}

# Message de confirmation
if (!empty($_GET['updated']))
	$common_message = __('Configuration updated');

# Liste des forums
$forums_array = array();
$forums_array['&nbsp;'] = 0;

$forums = punbb::getForums();

while ($forums->fetch())
	$forums_array[html::escapeHTML($forums->f('cat_name'))][html::escapeHTML($forums->f('forum_name'))] = $forums->f('fid');

# Set token
$puntal->setToken();

# Affichage
adminPage::open(__('Configuration').' - '.__('Downloads'));
?>

<h2 class="first"><img src="index.php?pf=downloads/img/ico_downloads_config.png" alt="" class="icon" /> <?php echo __('Downloads configuration') ?></h2>
<form method="post" action="module.php">
			
	<fieldset>
		<legend><?php echo __('Downloads configuration'); ?></legend>
		<p><?php echo __('So that the module can manage the downloads, transfer your files, via the FTP client software of your choice, in the directory which you will indicate below.') ?></p>
		
		<p class="field"><label for="path"><?php echo __('Directory where you put your downloadable files') ?></label>
		<?php echo form::field('path', 12,255, html::escapeHTML($p_path)) ?>
		<span class="desc"><?php printf(__('The directory of the downloads files from the directory of Puntal. Example: <code>files</code> for <code>%sfiles</code>'), PUNTAL_ROOT) ?></span></p>
		
		<p class="warn"><strong><?php echo __('Recommendations:'); ?></strong> <?php echo __('We recommend to you to place in this directory a file <code>index.php</code> satisfying the following code:') ?><br />
		<code>&lt;?php header ("location: /")?&gt;</code></p>

		<p class="field"><label for="p_forum"><?php echo __('Forum') ?></label>
		<?php echo form::combo('p_forum', $forums_array, $p_forum) ?>
		<span class="desc"><?php echo __('The forum in which a new topic will be started for each new download. Leave it blank to not start topic, the comments will then not be possible.') ?></span></p>
	</fieldset>
		
	<fieldset>
		<legend><?php echo __('Allow...'); ?></legend>
		
		<p><span class="fakelabel"><?php echo __('Guest to download?') ?></span>
		<label><?php echo form::radio(array('guest'),1,$p_guest, 'radio').__('Yes') ?></label>
		<label><?php echo form::radio(array('guest'),0,!$p_guest, 'radio').__('No') ?></label>
		<span class="desc"><?php echo __('If yes, everyone will be able to download; if not, only the members will be able to.') ?></span></p>
		
		<p><span class="fakelabel"><?php echo __('External links') ?></span>
		<label><?php echo form::radio(array('extern'),1,$p_extern, 'radio').__('Yes') ?></label>
		<label><?php echo form::radio(array('extern'),0,!$p_extern, 'radio').__('No') ?></label>
		<span class="desc"><?php echo __('Allows to authorize or not the direct links on the files without visiting your website.') ?></span></p>		
	</fieldset>

	<fieldset>
		<legend><?php echo __('How many download to display in the bloc named ...'); ?></legend>
		
		<p class="field"><label for="num_bloc"><?php echo __('Downloads') ?></label>
		<?php echo form::field('num_bloc', 2, 2, html::escapeHTML($p_num_bloc)) ?>
		<span class="desc"><?php echo __('Give the number of downloads to be displayed in the Download bloc of the module.') ?></span></p>

		<p class="field"><label for="top_num_bloc"><?php echo __('Top downloads') ?></label>
		<?php echo form::field('top_num_bloc', 2, 2, html::escapeHTML($p_top_num_bloc)) ?>
		<span class="desc"><?php echo __('Give the number of downloads to be displayed in the Top Download bloc of the module.') ?></span></p>
	</fieldset>
	
	<fieldset>
		<legend><?php echo __('Display on the home page of the module'); ?></legend>

		<p class="field"><label for="num_home"><?php echo __('Number of downloads') ?></label>
		<?php echo form::field('num_home', 2, 2, html::escapeHTML($p_num_home)) ?>
		<span class="desc"><?php echo __('Give the number of downloads to be displayed on the home page of the module.') ?></span></p>

		<p><span class="fakelabel"><?php echo __('Last downloads') ?></span>
		<label><?php echo form::radio(array('last_dl'),1,$p_last_dl, 'radio').__('Yes') ?></label>
		<label><?php echo form::radio(array('last_dl'),0,!$p_last_dl, 'radio').__('No') ?></label>
		<span class="desc"><?php echo __('Allows to display on the home page of the module the last downloads added.') ?></span></p>		

		<p><span class="fakelabel"><?php echo __('The most popular downloads') ?></span>
		<label><?php echo form::radio(array('popular_dl'),1,$p_popular_dl, 'radio').__('Yes') ?></label>
		<label><?php echo form::radio(array('popular_dl'),0,!$p_popular_dl, 'radio').__('No') ?></label>
		<span class="desc"><?php echo __('Allows to display on the home page of the module the downloads the most popular in all categories.') ?></span></p>
	</fieldset>

	<p><?php echo 
	form::hidden('form_sent','1')."\n".
	form::hidden('id','downloads')."\n".
	form::hidden('action',5)."\n".
	form::hidden(array('ptkn'),$puntal->getToken()); ?>
	<input class="submit" type="submit" value="<?php echo __('Save'); ?>" /></p>
</form>
<?php adminPage::close() ?>