<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

$cat_id = '';
$enable = '';
$show_filters = false;

if (!empty($_REQUEST['cat_id']))
{
	$cat_id = intval($_REQUEST['cat_id']);
	$show_filters = true;
}

if (!empty($_REQUEST['enable']))
{
	$enable = intval($_REQUEST['enable']);
	$show_filters = true;
}	

# Mise en ligne d'un tlchargement
if (!empty($_GET['online']))
{
	$dlid = intval($_GET['online']);
	$downloads->statusDownload($dlid,2);
	logIt('Downloads module : put online download '.$dlid, 2);
	header('Location: module.php?id=downloads&action=1&cat_id='.$cat_id.'&enable='.$enable.'&onlined=1');
	exit;
}

# Mise hors ligne d'un tlchargement
if (!empty($_GET['offline']))
{
	$dlid = intval($_GET['offline']);
	$downloads->statusDownload($dlid,1);
	logIt('Downloads module : put offline downloads '.$dlid, 2);
	header('Location: module.php?id=downloads&action=1&cat_id='.$cat_id.'&enable='.$enable.'&offlined=1');
	exit;
}

# Modifications d'un lot de tlchartements
if (!empty($_POST['lot']) && !empty($_POST['seldownloads']) && is_array($_POST['seldownloads']))
{
	# Mise en ligne
	if ($_POST['lot'] == 'online' && $puntal->checkToken())
	{
		foreach ($_POST['seldownloads'] as $v)
			$downloads->statusDownload($v,2);
		
		if (!$puntal->err->hasError())
		{
			logIt('Downloads module : put online downloads '.implode(', ', $_POST['seldownloads']), 2);
			header('Location: module.php?id=downloads&action=1&cat_id='.$cat_id.'&enable='.$enable.'&onlined=1');
			exit;
		}
	}
	
	# Mise hors ligne
	if ($_POST['lot'] == 'offline' && $puntal->checkToken())
	{
		foreach ($_POST['seldownloads'] as $v)
			$downloads->statusDownload($v,1);
		
		if (!$puntal->err->hasError())
		{
			logIt('Downloads module : put offline downloads '.implode(', ', $_POST['seldownloads']), 2);
			header('Location: module.php?id=downloads&action=1&cat_id='.$cat_id.'&enable='.$enable.'&offlined=1');
			exit;
		}
	}
	
	# Suppression
	if ($_POST['lot'] == 'delete' && $puntal->checkToken())
	{
		foreach ($_POST['seldownloads'] as $v)
			$downloads->delDownload($v);
		
		if (!$puntal->err->hasError())
		{
			logIt('Downloads module : Delete downloads '.implode(', ', $_POST['seldownloads']), 3);
			header('Location: module.php?id=downloads&action=1&deleted=1');
			exit;
		}
	}
}


# Messages de confirmation
if (!empty($_GET['onlined']))
	$common_message = __('Download(s) put online.');

if (!empty($_GET['offlined']))
	$common_message = __('Download(s) put offline.');

if (!empty($_GET['deleted']))
	$common_message = __('Download(s) deleted.');


/* Affichage
-------------------------------------------------------- */

# Liste des downloads
$rs = $downloads->getDownloads($cat_id,$enable);

# Liste des catgories
$cats = $downloads->getCat();
$cats_array = array();
$cats_array['&nbsp;'] = '';
while ($cats->fetch())
	$cats_array[$cats->f('dl_cat_name')] = $cats->f('id');

# Set token
$puntal->setToken();

# Javascript
$head = 
'<script type="text/javascript">'."\n".
"//<![CDATA[\n".
"function submitdownloadsForm(F,msg)
{
	var inputs = F.elements;
	var downloads_ids = new Array();
	var action;
	
	var i = 0;
	for (i=0; i<inputs.length; i++)
	{
		if (inputs[i].name == 'seldownloads[]') {
			downloads_ids.push(inputs[i]);
		}
		
		if (inputs[i].name == 'lot') {
			action = inputs[i].value;
		}
	}
	
	var selectfields = 0;
	for (i=0; i<downloads_ids.length; i++) {
		selectfields += downloads_ids[i].checked;
	}
	
	if (selectfields == 0) {
		return false;
	}
	
	if (action == 'delete') {
		return window.confirm(msg);
	}
	
	return true;
}

$(function() {
	$('.checkboxes-helpers').each(function() {
		puntal.checkboxesHelpers(this);
	});
});

//]]>
</script>";

if (!$show_filters)
	$head .= adminPage::jsLoad('js/filter-controls.js');

# Debut de page
adminPage::open(__('Downloads list').' - '.__('Downloads'),$head);
?>
<h2 class="first"><img src="index.php?pf=downloads/img/ico_downloads.png" alt="" class="icon" /> <?php echo __('Downloads list') ?></h2>

<?php # Filtres
if (!$show_filters)
	echo '<p><a id="filter-control" class="form-control" href="#">'.__('Filters').'</a></p>';
?>	

<form action="module.php" method="get" id="filters-form">
<div class="three-cols">
	<fieldset>
		<legend><?php echo __('Filters') ?></legend>
		<p class="col">
			<label for="cat_id"><?php echo __('Category') ?></label>
			<?php echo form::combo('cat_id', $cats_array,$cat_id) ?>
		</p>
		<p class="col">
			<label for="enable"><?php echo __('Status') ?></label>
			<?php echo form::combo('enable', array('&nbsp;'=>0, __('Offline')=>1, __('Online')=>2),$enable) ?>
		</p>
		<p class="col">
			<?php echo form::hidden('id','downloads')."\n".form::hidden('action',1); ?>
			<input class="submit" type="submit" value="<?php echo __('Display') ?>" />
		</p>
	</fieldset>
</div>
</form>

<?php if ($rs->isEmpty()) : 
		echo '<p class="clearb">'.__('No download').'</p>';
else : ?>

<form class="clearb" action="module.php" method="post" id="form-downloads-list" onsubmit="return submitdownloadsForm(this,'<?php echo html::escapeJS(__('Are you sure you want to delete selected downlaods?')) ?>');">
	<table>
	<thead>
		<tr>
			<th colspan="2" class="left"><?php echo __('Download name') ?></th>
			<th class="nowrap"><?php echo __('Category') ?></th>
			<th class="nowrap"><?php echo __('Status') ?></th>
		</tr>
	</thead>
	<tbody>
	
<?php 
while ($rs->fetch())
{
	$title = html::escapeHTML($rs->f('dl_name'));
	
	if ($rs->f('dl_enable') == 2)
		$cur_status = '<a href="module.php?id=downloads&amp;action=1&amp;offline='.$rs->f('id').'" title="'.sprintf(__('Put %s offline'),$title).'"><img src="style/img/on.png" alt="'.__('Online').'" class="icon" /></a>';
	else
		$cur_status = '<a href="module.php?id=downloads&amp;action=1&amp;online='.$rs->f('id').'" title="'.sprintf(__('Put %s online'),$title).'"><img src="style/img/off.png" alt="'.__('Offline').'" class="icon" /></a>';
	
	echo
	"\t\t".'<tr class="line" id="c_'.$rs->f('id').'">'."\n".
	"\t\t\t".'<td>'.form::checkbox(array('seldownloads[]'),$rs->f('id'),0,'checkbox').'</td>'."\n".
	"\t\t\t".'<td class="maximal"><a href="module.php?id=downloads&action=2&amp;pid='.$rs->f('id').'">'.$title.'</a></td>'."\n".
	"\t\t\t".'<td class="nowrap">'.html::escapeHTML($rs->f('dl_cat_name')).'</td>'."\n\n".
	"\t\t\t".'<td class="center">'.$cur_status.'</td>'."\n\n".
	"\t\t".'</tr>'."\n\n";
}
?>
	
	</tbody>
	</table>
	
	<div class="two-cols">
		<p class="col checkboxes-helpers"></p>
		
		<p class="col right">
			<?php echo 
			form::hidden('id','downloads')."\n".
			form::hidden('action',1)."\n".
			form::hidden('cat_id',$cat_id)."\n".
			form::hidden('enable',$enable)."\n".
			form::hidden(array('ptkn'),$puntal->getToken()); ?>
			<label for="lot"><?php echo __('For the selected downloads') ?></label>
			<?php echo form::combo('lot', array(__('Online')=>'online',__('Offline')=>'offline',__('Delete')=>'delete')) ?>
			<input class="submit" type="submit" value="<?php echo __('ok') ?>" />
		</p>
	</div>
</form>
	
<?php endif;

adminPage::close() ?>