<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

/**
 * 
	@brief download template class
	
*/
class download
{
	/**
	headRssPopular<br/>
	
	<strong>FR</strong> Affiche le lien d'entte vers le fil RSS des tlchargements populaires
	Seulement sur l'accueil du module.<br/>
	<strong>FR</strong> Display the link of the RSS feed of the populars download in the header.
	Only of the home of the module. 
	*/
	function headRssPopular()
	{
		if ($GLOBALS['download_mode'] == 'home' && pt_mod_downloads_popular_dl)
			echo '<link rel="alternate" type="application/rss+xml" href="'.$GLOBALS['puntal']->url('downloads_rss_popular').'" title="'.__('RSS feed of popular downloads').'" />'."\n";
	}
	
	/**
	headRssLatest<br/>
	
	<strong>FR</strong> Affiche le lien d'entte vers le fil RSS des derniers tlchargements.
	Seulement sur l'accueil du module.<br/>
	<strong>FR</strong> Display the link of the RSS feed of the lastest download in the header.
	Only of the home of the module.	
	*/
	function headRssLatest()
	{
		if ($GLOBALS['download_mode'] == 'home' && pt_mod_downloads_last_dl)
			echo '<link rel="alternate" type="application/rss+xml" href="'.$GLOBALS['puntal']->url('downloads_rss_latest').'" title="'.__('RSS feed of the last downloads added').'" />'."\n";
	}
	
	/**
	catsList<br/>
	
	<strong>FR</strong> Affiche la liste des catgories<br/>
	<strong>EN</strong> Display the list of the categories
	
	@param bloc <strong>string</strong> 		Formatting mask of the list of the bloc
	@param item <strong>string</strong> 		Formatting mask of the list of the item
	@param current <strong>string</strong> 		Formatting mask of the current item
	*/
	function catsList($bloc='<ul>%s</ul>', $item='<li>%s (%s)</li>', $current='<li class="current">%s (%s)</li>', $dl_number=' (%s)')
	{
		global $cats, $cat_id;
		
		$rs = '';
			
		$rs .= sprintf(($cat_id == '' ? $current : $item), '<a href="'.$GLOBALS['puntal']->url('downloads').'">'.__('Home').'</a>');
		
		while ($cats->fetch())
		{
			if ($cats->f('nb_files') > 0)
			{
				$rs .= sprintf(
				(($cat_id == $cats->f('id') || $cat_id == $cats->f('dl_cat_url')) ? $current : $item), 
				'<a href="'.$GLOBALS['puntal']->url('downloads').$cats->f('dl_cat_url').'">'.html::escapeHTML($cats->f('dl_cat_name')).'</a>'.sprintf($dl_number,$cats->f('nb_files')));
			}
		}
		
		printf($bloc, $rs);
	}

	/**
	downloadList<br/>
	
	<strong>FR</strong> Affiche une liste de tlchargements<br/>
	<strong>EN</strong> Display the list of the downloads
		
	@param string bloc		Masque de formatage du bloc de la liste
	@param string item		Masque de formatage d'un item de la liste
	*/
	function downloadList($bloc='<ul>%s</ul>', $item='<li>%s </li>')
	{
		global $download_list;
		
		$rs = '';
		
		if (!$download_list)
			return;
		
		while ($download_list->fetch())
		{
			$rs .= sprintf($item, '<a href="'.$GLOBALS['puntal']->url('downloads').$download_list->f('id').'">'.html::escapeHTML($download_list->f('dl_name')).'</a>' );
		}
		
		printf($bloc, $rs);
	}

	/**
	catDesc<br/>

	<strong>FR</strong> Affiche la description d'une catgorie<br/>
	<strong>EN</strong> Display the description of the category 	
	*/
	function catDesc()
	{
		if ($GLOBALS['cat_id'] != '')
			echo $GLOBALS['cat']->f('dl_cat_desc');
	}
	

	/**
	downloadTitle<br/>
		
	<strong>FR</strong> Affiche le titre d'un tlchargement<br/>
	<strong>EN</strong> Display the title of the download 
	*/	
	function downloadTitle()
	{
		echo html::escapeHTML($GLOBALS['download']->f('dl_name'));
	}
	
	/**
	downloadDesc<br/>
	
	Affiche la description d'un tlchargement
	<strong>FR</strong> Affiche la description d'un tlchargement<br/>
	<strong>EN</strong> Display the description of the download 
	*/
	function downloadDesc()
	{		
		echo parse_message($GLOBALS['download']->f('dl_desc'),0);
	}
	
	/**
	downloadLink<br/>
	
	<strong>FR</strong> Affiche le lien de tlchargement d'un fichier<br/>
	<strong>EN</strong> Display the link of the download of the file 
	*/
	function downloadLink($ok='<p class="conr"><a href="%s">%s</a></p>',$ko='<p class="conr"><strong>%s</strong></p>')
	{
		global $puntal;
		if ($GLOBALS['download']->f('dl_filename') == 'fake') return;
		if (pt_mod_downloads_guest || $puntal->user['g_id'] != PUN_GUEST)
			printf($ok, sprintf($puntal->url('downloads_file'),$GLOBALS['download']->f('id')), __('Download'));
		else
			printf($ko,__('You must be logged in to download this file.'));
	}
	
	/**
	downloadDate<br/>
	
	<strong>FR</strong> Affiche la date de dernire version d'un fichier<br/>
	<strong>EN</strong> Display the date of the last version of the file
	*/	
	function downloadDate($format='')
	{
		if ($format != '')
			echo dt::str($format, strtotime($GLOBALS['download']->f('dl_date')));
		else
			echo dt::str(pt_date_format, strtotime($GLOBALS['download']->f('dl_date')));
	}
	
	/**
	downloadSize<br/>
	
	<strong>FR</strong> Affiche la taille d'un fichier<br/>
	<strong>EN</strong> Display the size of one file

	*/
	function downloadSize()
	{
		if ($GLOBALS['download']->f('dl_filename') == 'fake') return; 
		// calculate the size of the file to download and display it
		$size = filesize(PUNTAL_ROOT.pt_mod_downloads_path.'/'.$GLOBALS['download']->f('dl_filename'));
		
		$i = 0;
		$iec = array("B", "KB", "MB", "GB", "TB", "PB", "EB", "ZB", "YB");
		while (($size/1024)>1)
		{
			$size=$size/1024;
			$i++;
		}
				
		echo substr($size,0,strpos($size,'.')+4).$iec[$i];
	}
	

	/**
	downloadCount<br/>
	
	<strong>FR</strong> Affiche le nombre de tlchargements d'un fichier<br/>
	<strong>EN</strong> Display the number of donwloads of one file
	*/	
	function downloadCount($s='<strong>%s</strong>')
	{
		printf(__('Downloaded %s times'), sprintf($s,$GLOBALS['download']->f('dl_count')));
	}
		
	/**
	dlAntiLeech<br/>
	
	<strong>FR</strong> Verifie que l'anti leech est actif <br/>
	<strong>EN</strong> Check the Anti Leech is loaded
	*/			
	function dlAntiLeech()
	{
		// anti-leech ?
		if (pt_mod_downloads_leech == false) 
		{
			$referer = getenv("HTTP_REFERER");
			$host = parse_url($referer);
						 
			# bug sous ie ; ne retourne pas de host
			if (!isset($host['host'])) return false;			
			
			$host_string='';
			
			if (array_key_exists('port',$host))
				if ( $host['port'] != '80' ) 
					$host_string = $host['host'].":".$host['port'];
				else 
					$host_string = $host['host'];
			else $host_string = $host['host'];
			 					
			if ($host_string != '' && $host_string != $_SERVER['HTTP_HOST'])
				return true; # yes it's a leecher ; we bloc it
			else
				return false;
		}
		
		return false;
	}
	
	/**
	popularDownloadsListURL<br/>
	
	<strong>FR</strong>  Affiche l'URL d'un tlchargement dans le contexte 
	de la liste	des tlchargements populaires<br/>
	<strong>EN</strong> Display the URL of one download in a context of the list of populars downloads
	*/		
	function popularDownloadsListURL()
	{
		echo $GLOBALS['puntal']->url('downloads').$GLOBALS['download_popular']->f('id');
	}
	
	/**
	popularDownloadsListCount<br/>
	
	<strong>FR</strong>  Affiche le titre de tlchargements d'un fichier dans le contexte 
	de la liste	des tlchargements populaires<br/>
	<strong>EN</strong> Display the title of download of one file   in a context of the list of populars downloads
	*/	
	function popularDownloadsListTitle()
	{
		echo html::escapeHTML($GLOBALS['download_popular']->f('dl_name'));
	}
	
	/**
	popularDownloadsListCount<br/>
	
	<strong>FR</strong>  Affiche le nombre de tlchargements d'un fichier dans le contexte 
	de la liste	des tlchargements populaires<br/>
	<strong>EN</strong> Display the number of download of one file   in a context of the list of populars downloads
	*/
	function popularDownloadsListCount()
	{
		echo $GLOBALS['download_popular']->f('dl_count');
	}
	
	/**
	popularDownloadsListDate<br/>
	
	<strong>FR</strong>  Affiche la date d'un tlchargement dans le contexte 
	de la liste	des tlchargements populaires<br/>
	<strong>EN</strong>  Display the date of the download in a context of the list of populars downloads	
	*/	
	
	function popularDownloadsListDate($format='')
	{
		if ($format != '')
			echo dt::str($format, strtotime($GLOBALS['download_popular']->f('dl_date')));
		else
			echo dt::str(pt_date_format, strtotime($GLOBALS['download_popular']->f('dl_date')));
	}
	
	/**
	lastDownloadsListURL<br/>
	
	<strong>FR</strong>  Affiche l'URL d'un tlchargement dans le contexte 
	de la liste	des  tlchargements<br/>
	<strong>EN</strong>  Display the URL of the download in a context of the list of lastest downloads	
	*/	
	function lastDownloadsListURL()
	{
		echo $GLOBALS['puntal']->url('downloads').$GLOBALS['download_last']->f('id');
	}
	
	/**
	lastDownloadsListTitle<br/>
	
	<strong>FR</strong>  Affiche le titre d'un tlchargement dans le contexte 
	de la liste	des derniers tlchargements<br/>
	<strong>EN</strong>  Display the title of the download in a context of the list of lastest downloads	
	*/
	function lastDownloadsListTitle()
	{
		echo html::escapeHTML($GLOBALS['download_last']->f('dl_name'));
	}
	
	/**
	lastDownloadsListDate<br/>
	
	<strong>FR</strong>  Affiche la date d'un tlchargement dans le contexte 
	de la liste	des tlchargements populaires<br/>
	<strong>EN</strong>  Display the date of the download in a context of the list of popular downloads
	
	*/
	function lastDownloadsListDate($format='')
	{
		if ($format != '')
			echo dt::str($format, strtotime($GLOBALS['download_last']->f('dl_date')));
		else
			echo dt::str(pt_date_format, strtotime($GLOBALS['download_last']->f('dl_date')));
	}
	
	/**
	downloadListPopularDlRSS<br/>
	
	<strong>FR</strong> Affiche une liste des tlchargements les plus populaires
	<strong>EN</strong> Display the list of the most popular downloads
	*/	
	function downloadListPopularDlRSS()
	{
		global $download_popular, $puntal;
	
		$rss_line = '';
		
		if (!$download_popular)
			return;
			
		while ($download_popular->fetch())
		{
			$rss_line .= "\t".'<item>'."\n".
			"\t\t".'<title>'.$download_popular->f('dl_count') . ' ' .html::escapeHTML($download_popular->f('dl_name')). ' '.dt::str(pt_date_format, strtotime($download_popular->f('dl_date'))).'</title>'."\n".
			"\t\t".'<link>'.puntal::getHost().$puntal->url('downloads').$download_popular->f('id').'</link>'."\n";
			$rss_line .= "\t"."</item>\n";
		}		
		printf($rss_line);
	}
	
	/**
	downloadListLastDlRSS<br/>
	
	<strong>FR</strong> Affiche une liste des derniers tlchargements ajouts sur puntal
	<strong>EN</strong> Display the list of the last downloads added on puntal 
	*/
	function downloadListLastDlRSS()
	{
		global $download_last, $puntal;
	
		$rss_line = '';
		
		if (!$download_last)
			return;
			
		while ($download_last->fetch())
		{
			$rss_line .= "\t".'<item>'."\n".
			"\t\t".'<title>'.dt::str(pt_date_format, strtotime($download_last->f('dl_date'))). ' ' .html::escapeHTML($download_last->f('dl_name')).'</title>'."\n".
			"\t\t".'<link>'.puntal::getHost().$puntal->url('downloads').$download_last->f('id').'</link>'."\n";
			$rss_line .= "\t"."</item>\n";
		}
		
		printf($rss_line);
	}	
    
	/**
	listUrl<br/>
	
	<strong>FR</strong> Affiche l'URL d'un tlchargement  dans le contexte d'une boucle sur une liste de telechargements.<br/>
	<strong>EN</strong> Display the URL of an download in loop 'download context' for the list of downloads
	*/
	function listUrl()
	{
		echo $GLOBALS['puntal']->url('downloads').$GLOBALS['downloads_list']->f('id');
	}	
	
	/**
	listTitle<br/>
	
	<strong>FR</strong> Affiche le titre d'un tlchargement dans le contexte d'une boucle sur une liste de telechargements.<br/>
	<strong>EN</strong> Display the title of an download in loop 'download context' for the list of download
	*/	function listTitle()
	{
		echo html::escapeHTML($GLOBALS['downloads_list']->f('dl_name'));
	}
	
	/**
	listContent<br/>
	
	<strong>FR</strong> Affiche le contenu d'un tlchargement dans le contexte d'une boucle sur une liste de tlchargements.<br/>
	<strong>EN</strong> Display the content of an download in loop 'download context' for the list of download	
	*/
	function listContent()
	{
		echo $GLOBALS['downloads_list']->f('dl_desc');
	}
}
?>