<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

/*
	Le fichier _public.php est charg en mme temps que le module sur la
	partie publique de Puntal.
	
	Ce fichier est utile pour effectuer des traitements ds le chargement
	du module sur la partie publique.
	
	A noter que ce fichier est inclu par une fonction ce qui veut dire que
	les variables dfinies dans ce fichier seront locales  ce fichier 
	moins que vous ne les dclariez explicitement comme globales.
	
	Par contre, grce  un dispositif, les variables globales de puntal 
	sont accessibles dans ce fichier.
*/

/*
	Nous utilisons souvent ce fichier pour dfinir les URLs qui lui sont
	propres. Parfois, si nous avons besoin de ces URLs  la fois sur la
	partie publique et la partie administration nous dfinirons les URLs
	plutt dans _prepend.php
	
	Ces dfinitions d'URLs ne sont pas obligatoires mais elles permettent
	aux webmasters de personnaliser les URLs de Puntal. Par exemple pour
	les mettres en franais.
*/

# URLs configuration
define('EXAMPLE_URL', 'example');
define('EXAMPLE_TRUC', 'trick');

# Par exemple en franais :
// define('EXAMPLE_URL', 'exemple');
// define('EXAMPLE_TRUC', 'truc');


#########################################################################

if (!defined('PUNTAL')) exit;

/*
	Ensuite, avec les dfinitions d'URLs fournis par les webmaster nous
	pouvons construire et enregistrer les URLs du module dans Puntal.
	Nous faisons ceci grce  la mthode registerURL() de l'objet $puntal
	Cette mthode prend deux arguments, l'identifiant de l'URL et l'URL
	en elle mme.
*/
$puntal->registerURL('example', pt_portal_url.EXAMPLE_URL.'/');
$puntal->registerURL('example_truc', pt_portal_url.EXAMPLE_URL.'/'.EXAMPLE_TRUC.'/');
/*
	Ceci permet d'acceder facilement aux diffrentes URLs via la seconde
	mthode de puntal url() ; par exemple comme ceci :
	
	$puntal->url('example')
*/


/*
	Nous utilisons galement ce fichier pour dfinir les parties publiques
	des blocs que le module ajoute. (voir _prepend.php)
*/

# La classe qui se charge de l'affichage des blocs sur la partie publique
class examplePublicBlocks
{
	# La mthode de cette classe qui se charge du premier bloc
	function example1()
	{
		# bloc exemple1
	}
	
	# La mthode qui se charge du second bloc
	function example1()
	{
		# bloc exemple2
	}
}

?>