<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

/* Nous sommes sur la page de configuration du module.
Ce fichier va donc servir  modifier les paramtres dfinis lors
de l'installation du module. Pour ce faire nous utilisons
videment un formulaire afin de rgler les diffrents paramtres. 

Comme l'indique le nom du module, ceci n'est qu'un exemple,
il peut y avoir moult autres faons de procder selon les besoins. */


/* Toujours ce petit test pour s'assurer que le fichier n'est
pas xcut en dehors de Puntal */
if (!defined('PUNTAL')) exit;

/* Initialisation des variables de configuration (facultatif mais pratique) */
$param1 = pt_mod_example_param_1;
$param2 = pt_mod_example_param_2;

/* Traitements...
----------------------------------------------------------*/

/* Si $_POST['form_sent'] est dfinie et qu'il n'est pas vide c'est que
le formulaire a t envoy.
On vrifie ici le token (scurit) */
if (!empty($_POST['form_sent']) && $puntal->checkToken())
{
	/* Rcupration et nettoyage des donnes du formulaire. */
	$param1 = intval(trim($_POST['param1']));
	$param2 = intval(trim($_POST['param2']));

	/* Ici on se place dans l'espace de nommage du module */
	$pt_settings->setNamespace('mod_example');    
	
	/* On change les valeurs de nos paramtres de configuration */
	$res = true;
	$res &= $pt_settings->put('pt_mod_example_param_1', $param1);
	$res &= $pt_settings->put('pt_mod_example_param_2', $param2);

	$pt_settings->setNamespace('');
	
	/* Si tout c'est bien pass... */
	if ($res)
	{
		# On enregistre un log
		logIt('Example module : edit config', 1);
		
		# Et on redirige
		header('Location: module.php?id=example&action=2&updated=1');
		exit;
	}
}

# Message de confirmation
if (!empty($_GET['updated']))
	$common_message = __('Configuration updated');


/* Affichage de la page
----------------------------------------------------------*/

/* On crer un token unique pour l'utilisateur en ligne */
$puntal->setToken();

/* Pour dmarrer l'affichage d'une page d'administration on utilise 
la fonction adminPage::open() Celle-ci doit prendre au moins un argument
qui est le titre de la page. Un deuxime argument est possible pour
ajouter du HTML  l'entte comme du JavaScript ou des CSS */
adminPage::open(__('Example configuration'),"<!-- Du HTML pour l'en-tte -->");
?>

<?php /* Ci-dessous le titre de la page. Notez l'adresse de l'icne,
on utilise ces adresses pour ne pas afficher clairement le chemin 
du module si jamais l'utilisateur dplaces les dossiers. */ ?>
<h2 class="first"><img src="index.php?pf=example/img/ico_example_config.png" alt="" class="icon" /> <?php echo __('Example configuration') ?></h2>

<?php /* L'URL du formulaire des fichiers d'administration des modules
est toujours module.php ; ensuite en fonction du module et de la page 
sur laquelle on se trouve on ajoutent des champs cachs adapts
(voir en bas du formulaire) */ ?>

<form action="module.php" method="post">

	<?php /* Afin d'obtenir une certaine cohrence visuelle, il est 
	de bon ton de reproduire sur vos modules la mise en forme gnrale
	de l'administration de Puntal et donc d'utiliser les classes CSS. */ ?>
	<p class="field"><label for="param1"><?php echo __('Param 1') ?></label>
	
	<?php /* Afin de gnrer les champs de formulaire nous utilisons la
	classe statique "form" ; celle-ci permet de gnrer tous les champs 
	de formulaire possible trs facilement. */ ?>
	<?php echo form::field('param1', 2, 5, html::escapeHTML($param1)) ?>
	
	<?php /* Parfois un label n'est pas assez explicite, vous pouvez
	alors ajouter une description. */ ?>
	<span class="desc"><?php echo __('Param 1 description') ?></span></p>
	
	
	<?php /* Comme nous avons dfinis le second paramtre tant du type boolen
	un jeu de bouton de radio "Oui/non" convient bien. Encore et toujours, nous 
	utilisons la mise en forme de Puntal retrouve en d'autres endroits. */ ?>
	<p><span class="fakelabel"><?php echo __('Param 2'); ?></span>
	<label><?php echo form::radio(array('param2'), 1, $param2, 'radio').__('Yes'); ?></label>
	<label><?php echo form::radio(array('param2'), 0, !$param2, 'radio').__('No'); ?></label>
	<span class="desc"><?php echo __('Param 2 description'); ?></span></p>
	
	
	<?php /* Les champs cachs pour que retombions bien sur notre
	page quand le formulaire est envoy. Correspond  l'URL :
	module.php?id=example&action=2 
	form_sent est utilis pour la traitement (en haut) pour voir 
	si le formulaire  bien t envoy. 
	ptkn est le token unique attribu  l'utilisateur en cours */ ?>
	<p><?php echo 
	form::hidden(array('id'),'example')."\n".
	form::hidden(array('action'),2)."\n".
	form::hidden(array('form_sent'),'1')."\n".
	form::hidden(array('ptkn'),$puntal->getToken()); ?>
	
	<input class="submit" type="submit" value="<?php echo __('Save') ?>" /></p>
	
</form>
	
<?php /* Comme nous avons commenc la page avec une fonction, nous la terminons
avec une autre : adminPage::close() */
adminPage::close() ?>
