<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

/*
 Actions :
 
 1 : list
 2 : post
 3 : config
*/

if (pt_mod_lexicon && checkPerm('mod_lexicon'))
{
	# Menu lexique
	$on_lexicon = ($module_id == 'lexicon') ? true : false;
	
	$menu->newMenu('lexicon',__('Lexicon'));
	
	$menu->addItem('lexicon',
				__('Words list'),
				'module.php?id=lexicon&amp;action=1',
				($on_lexicon && $action == 1)
	);
	
	$menu->addItem('lexicon',
				__('Add'),
				'module.php?id=lexicon&amp;action=2',
				($on_lexicon && $action == 2 && empty($_REQUEST['wid']))
	);
	
	$menu->addItem('lexicon',
				__('Configuration'),
				'module.php?id=lexicon&amp;action=3',
				($on_lexicon && $action == 3)
	);
	
	# Signalisation mots  valider
	$puntal->addBehavior('adminIndexHTML', array('lexiconBehavior','getValidateWords'));
}

class lexiconBehavior
{
	function getValidateWords()
	{
		global $puntal;
		
		$rs = $puntal->con->select('SELECT COUNT(def_id) AS total_words FROM '.DB_PREFIX.'pt_lexique WHERE def_status=0') or $puntal->err->fatalError($puntal->con->error());
				
		if ($rs->f('total_words') > 0)
		{
			echo '<div class="warningbox"><h2>'.__('Lexicon').'</h2>'.
			'<p><a href="module.php?id=lexicon&amp;action=1">'.
			sprintf(__('There are %s word(s) on standby of validation.'), $rs->f('total_words')).
			'</a></p></div>';
		}
	}
}


?>