<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;


# Recherche sur les lexique
$GLOBALS['puntal']->addBehavior('searchPerform', array('lexiqueBehavior','performSearch'));
	
# Rsultats de recherche
$GLOBALS['puntal']->addBehavior('searchResults', array('lexiqueBehavior','searchResults'));

# Affiche le nombre de Rsultats de recherche
$GLOBALS['puntal']->addBehavior('searchResultsTtl', array('lexiqueBehavior','searchResultsTtl'));

class lexiqueBehavior
{

	function performSearch()
	{
		global $puntal;
		
		if (file_exists(PT_THEMES_PATH.pt_theme.'/lexicon/lexicon.css'))
			$GLOBALS['extra_header'] .= '<link rel="stylesheet" type="text/css" href="'.PT_THEMES_URL.pt_theme.'/lexicon/lexicon.css'.'" />';
		else
			$GLOBALS['extra_header'] .= '<link rel="stylesheet" type="text/css" href="'.PT_THEMES_URL.PT_DEFAULT_THEME.'/lexicon/lexicon.css'.'" />';
				
		require dirname(__FILE__).'/inc/lexique.class.php';
		$lexique = new lexiqueManager($puntal);
		
		#la recherche est-elle vide ?
		if (strlen(trim($_GET['q'])) > 2 )  				
			$GLOBALS['lexique_list'] = $lexique->searchEntry($_GET['q'], pt_mod_search_num_per_page );
	}
	
	
	function searchResults()
	{
		global $lexique_list;
		
		#on teste que $lexique_list existe ET qu'il n'est pas vide
		if ($lexique_list and !$lexique_list->isEmpty())
		{
			require dirname(__FILE__).'/inc/tpl_functions.php';
			
			if (file_exists(PT_THEMES_PATH.pt_theme.'/lexicon/search_results.php'))
				require PT_THEMES_PATH.pt_theme.'/lexicon/search_results.php';
			else
				require PT_THEMES_PATH.PT_DEFAULT_THEME.'/lexicon/search_results.php';
		}
	}
	
	function searchResultsTtl() {
		global $lexique_list;
		
		if ($lexique_list and !$lexique_list->isEmpty()) {			
			$GLOBALS['search_ttl'] += $lexique_list->nbRow();
			return $GLOBALS['search_ttl'];			
		}		
	}	
}

?>