<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

$p_validate = pt_mod_lexique_validate;
$p_num_per_page = pt_mod_lexique_num_per_page;

/* Form sent */
if (!empty($_POST['form_sent']) && $puntal->checkToken())
{
	$p_validate = intval($_POST['p_validate']);
	$p_num_per_page = intval(trim($_POST['p_num_per_page']));
	
	# Mise  jour de la configuration
	$pt_settings->setNamespace('mod_lexicon');    
	
	$res = true;
	$res &= $pt_settings->put('pt_mod_lexique_validate', $p_validate);
	$res &= $pt_settings->put('pt_mod_lexique_num_per_page', $p_num_per_page);

	$pt_settings->setNamespace('');
	
	if ($res)
	{
		logIt('Lexique module : edit config', 1);
		header('Location: module.php?id=lexicon&action=3&updated=1');
		exit;
	}
}

# Message de confirmation
if (!empty($_GET['updated']))
	$common_message = __('Configuration updated');

# Set token
$puntal->setToken();

# Affichage
adminPage::open(__('Configuration').' - '.__('Lexicon')); ?>

<h2 class="first"><img src="index.php?pf=lexicon/img/ico_lexique_config.png" alt="" class="icon" /> <?php echo __('Lexicon configuration') ?></h2>

<form method="post" action="module.php">
	<fieldset>
		<legend><?php echo __('Lexicon configuration'); ?></legend>
			
		<p><span class="fakelabel"><?php echo __('Validation before publication') ?></span>
		<label><?php echo form::radio(array('p_validate'), 1, $p_validate, 'radio').__('Yes') ?></label>
		<label><?php echo form::radio(array('p_validate'), 0, !$p_validate, 'radio').__('No') ?></label>
		<span class="desc"><?php echo __('If this option is activated, the words added by the users will owe beings validated by an administrator or a moderatot to be visible on the portal. If not it will be directly published.') ?></span></p>
	
		<p class="field"><label for="p_num_per_page"><?php echo __('Number of words per page'); ?></label>
		<?php echo form::field('p_num_per_page', 2, 3, html::escapeHTML($p_num_per_page)) ?>
		<span class="desc"><?php echo __('The number of words per page on the complete list.') ?></span></p>

	</fieldset>
	
	<p><?php echo 
	form::hidden('form_sent','1')."\n".
	form::hidden('id','lexicon')."\n".
	form::hidden('action',3)."\n".
	form::hidden(array('ptkn'),$puntal->getToken()); ?>
	<input class="submit" type="submit" value="<?php echo __('Save'); ?>" /></p>

</form>
<?php adminPage::close() ?>