<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

/**
	La classe d'affichage du lexique
*/
class lexique
{
	/**
	@function url
	
	Affiche une url suivant le paramtre pass
	*/
	function url($type='')
	{
		switch ($type)
		{
			case 'add':
				echo $GLOBALS['puntal']->url('lexicon_add');
				break;
				
			case 'edit':
				echo $GLOBALS['puntal']->url('lexicon_add');
				break;
				
			case 'lexicon':
			default :
				echo $GLOBALS['puntal']->url('lexicon');
				break;
		}
	}

	/**
	@function editFormAction
	
	Affiche l'URL du formulaire de modification
	*/
	function editFormAction()
	{
		printf($GLOBALS['puntal']->url('lexicon_edit'),$GLOBALS['edit_id']);
	}
	
	/**
	@function letter
	
	Affiche la lettre courante
	*/
	function letter()
	{
		echo $GLOBALS['cur_lettre'];
	}
	
	/**
	@function noWordLetter
	
	Affiche le message si pas de mot pour la lettre courante
	*/
	function noWordLetter()
	{
		printf(__('There is no word starting with the letter %s.'), $GLOBALS['cur_lettre']);
	}
	
	/**
	@function numWords
	
	Affiche un nombre de mot en "plurialisant".
	*/
	function numWords()
	{
		global $num_words, $lang_mod_lexique;
		
		if ($num_words > 1)
			echo __('One word');
		else
			printf(__('%s words'), $num_words);
	}
		
	/**
	@function totalWords
	
	Affiche le nombre total de mots dans le lexique.
	
	@param	string	s		Masque de formatage de la chaine ('<span>%s</span>')
	*/
	function totalWords($s='<span>%s</span>')
	{
		printf($s,sprintf(__('The lexicon contains a total of %s words'),$GLOBALS['lexique']->getTotalWord()));
	}
	
	/**
	@function totalToValidateWords
	
	Affiche le nombre total de mots  valider.
	
	@param	string	s		Masque de formatage de la chaine ('<span>%s</span>')
	*/
	function totalToValidateWords($s='<span>%s</span>')
	{
		$total_words_validate = $GLOBALS['lexique']->getTotalValidateWord();
		
		if ($total_words_validate > 0)
			printf($s,sprintf(__('(of which %s on standby of validation)'), $total_words_validate));
	}
	
	/**
	@function addLink
	
	Affiche le lien "Ajouter un mot".
	
	@param	string	normal		Masque de formatage du lien normal (' - <a href="%s">%s</a>')
	@param	string	active		Masque de formatage du lien actif (' - <a href="%s"><strong>%s</strong></a>')
	*/
	function addLink($normal=' - <a href="%s">%s</a>', $active=' - <a href="%s"><strong>%s</strong></a>')
	{
		if (!$GLOBALS['puntal']->user['is_guest'])
			printf( (($GLOBALS['lexique_mode'] == 'ajouter') ? $active : $normal), $GLOBALS['puntal']->url('lexicon_add'), __('Add a word'));
	}
	
	/**
	@function validateLink
	
	Affiche le lien "Liste de validation".
	
	@param	string	normal		Masque de formatage du lien normal (' - <a href="%s">%s</a>')
	@param	string	active		Masque de formatage du lien actif (' - <a href="%s"><strong>%s</strong></a>')
	*/
	function validateLink($normal=' - <a href="%s">%s</a>', $active=' - <a href="%s"><strong>%s</strong></a>')
	{
		if (pt_mod_lexique_validate && $GLOBALS['puntal']->user['g_id'] < PUN_GUEST)
			printf( (($GLOBALS['lexique_mode'] == 'valider') ? $active : $normal), $GLOBALS['puntal']->url('lexicon_valide_page'), __('Validating list'));
	}
	
	/**
	@function allLink
	
	Affiche le lien "Liste complte".
	
	@param	string	normal		Masque de formatage du lien normal (' - <a href="%s">%s</a>')
	@param	string	active		Masque de formatage du lien actif (' - <a href="%s"><strong>%s</strong></a>')
	*/
	function allLink($normal=' - <a href="%s">%s</a>', $active=' - <a href="%s"><strong>%s</strong></a>')
	{
		printf( (($GLOBALS['lexique_mode'] == 'tous') ? $active : $normal), $GLOBALS['puntal']->url('lexicon_list_all'), __('Complete list'));
	}
	
	/**
	@function letters
	
	Affiche de la liste des lettres.
	
	@param	string	normal		Masque de formatage du lien normal ('<a href="%s">%s</a>')
	@param	string	active		Masque de formatage du lien actif ('<a href="%s"><strong>%s</strong></a>')
	*/
	function letters($normal='<a href="%s">%s</a>', $active='<a href="%s"><strong>%s</strong></a>', $sep=' - ')
	{
		$lettres = array();
		foreach (range('A','Z') as $lettre)
			$lettres[] = sprintf( (($lettre == $GLOBALS['cur_lettre']) ? $active : $normal),$GLOBALS['puntal']->url('lexicon').$lettre, $lettre);
	
		echo implode($sep,$lettres);
	}
	
	/**
	@function errors
	
	Affiche une liste d'erreurs
	*/
	function errors($block='<ul>%s</ul>',$item='<li>%s</li>')
	{
		$items = '';
		foreach ($GLOBALS['errors'] as $err)
			$items .= sprintf($item,$err);
		
		printf($block, $items);
	}
	
	/**
	@function formValue
	
	Affiche un des champs du formulaire.
	
	@param	string	var		Nom de la variable  afficher
	*/
	function formValue($var='')
	{
		if ($var == '')
			return;
		
		echo html::escapeHTML($GLOBALS[$var]);
	}
	
	/**
	@function word
	
	Affiche un mot dans le contexte d'une boucle 
	sur une liste de mots.
	
	*/
	function word()
	{
		
		echo html::escapeHTML($GLOBALS['words']->f('def_word'));
		
	}
	
	/**
	@function wordStatusClass
	
	Affiche (ou retourne) une chaine pour tre utilise comme 
	class CSS suivant le statut du mot.
	
	*/
	function wordStatusClass($inactive=' inactive', $active=' active', $return=false)
	{
		if ($GLOBALS['words']->f('def_status') == 0)
			$class = $inactive;
		else
			$class = $active;
			
		if ($return)
			return $class;
		else
			echo $class;
	}
	
	/**
	@function wordEditLink
	
	Affiche le lien de modification d'un mot dans le contexte
	d'une boucle sur les mots.
	
	*/
	function wordEditLink($s=' | <a href="%s">%s</a>')
	{
		printf($s,sprintf($GLOBALS['puntal']->url('lexicon_edit'),$GLOBALS['words']->f('def_id')),__('Edit'));
	}
	
	/**
	@function wordDeleteLink
	
	Affiche le lien de supression d'un mot dans le contexte
	d'une boucle sur les mots.
	
	*/
	function wordDeleteLink($s=' | <a href="%s"%s>%s</a>')
	{
		printf($s,
		sprintf($GLOBALS['puntal']->url('lexicon_del'),$GLOBALS['words']->f('def_id')),
		' onclick="return window.confirm(\''.html::escapeJS(__('Are you sure you want to delete this word?')).'\')"',
		__('Delete')
		);
	}
	
	/**
	@function wordValidLink
	
	Affiche le lien de validation d'un mot dans le contexte
	d'une boucle sur les mots.
	
	*/
	function wordValidLink($s=' | <a href="%s">%s</a>')
	{
		if ($GLOBALS['words']->f('def_status') == 0)
			printf($s,sprintf($GLOBALS['puntal']->url('lexicon_valide_word'),$GLOBALS['words']->f('def_id')),__('Validate'));
	}
	
	/**
	@function wordId
	
	Affiche l'identifiant d'un mot dans le contexte 
	 d'une boucle sur une liste de mots.
	
	*/
	function wordId()
	{
		echo $GLOBALS['words']->f('def_id');
	}
	
	/**
	@function wordDefinition
	
	Affiche la dfinition d'un mot dans le contexte d'une boucle 
	sur une liste de mots.
	
	*/
	function wordDefinition()
	{
		echo parse_message($GLOBALS['words']->f('def_def'),false);
		
	}
	
	/**
	@function wordExample
	
	Affiche l'exemple d'un mot dans le contexte d'une boucle 
	sur une liste de mots.
	
	*/
	function wordExample($s='<dd class="word_example">%s</dd>')
	{
		if ($GLOBALS['words']->f('def_ex') != '') 
			printf($s,parse_message($GLOBALS['words']->f('def_ex'),false));
	}
	
	/**
	@function wordUserId
	
	Affiche l'identifiant de l'utilisateur qui a ajout
	un mot dans le contexte d'une boucle sur une liste de mots.
	
	*/
	function wordUserId()
	{
		echo $GLOBALS['words']->f('def_user_id');
	}
	
	/**
	@function wordUsername
	
	Affiche le nom de l'utilisateur qui a ajout
	un mot dans le contexte d'une boucle sur une liste de mots.
	
	*/
	function wordUsername()
	{
		echo html::escapeHTML($GLOBALS['words']->f('def_username'));
	}
	
	/**
	@function wordEditor
	
	Inidque si l'utilisateur courant est un diteur du mot
	dans le contexte d'une boucle sur une liste de mots.
	
	*/
	function wordEditor()
	{
		global $puntal;
		
		if ($puntal->user['g_id'] < PUN_GUEST || $puntal->user['id'] == $GLOBALS['words']->f('def_user_id'))
			return true;
		else
			return false;
	}	
	
	/**
	@function getPagesLinks
	
	Affiche les liens de pages sur la liste complte
	*/
	function getPagesLinks()
	{
		echo $GLOBALS['lum']->getLinks();
	}
	
	/**
	@function getBugsTable
	
	Affiche le tableau de la liste complte
	*/
	function getWordsTable()
	{
		echo $GLOBALS['lum']->getPage();
	}

    
    
	/**
	@function listUrl
	
	Affiche le titre d'un article dans le contexte 
	d'une boucle sur une liste d'articles.
	*/
	function listUrl()
	{
		echo $GLOBALS['puntal']->url('lexicon').$GLOBALS['lexique_list']->f('def_letter');
	}	
	/**
	@function listTitle
	
	Affiche le titre d'un article dans le contexte 
	d'une boucle sur une liste d'articles.
	*/
	function listTitle()
	{
		echo html::escapeHTML($GLOBALS['lexique_list']->f('def_word'));
	}
	/**
	@function listContent
	
	Affiche le contenu d'un article dans le contexte 
	d'une boucle sur une liste d'articles.
	*/
	function listContent()
	{
		echo parse_message($GLOBALS['lexique_list']->f('def_def') . "\n" . $GLOBALS['lexique_list']->f('def_ex'),false);
	}
		
    
} # end class


/*
@function allWordsBlock

Modle du bloc pour la liste complte

Important : N'est pas utilise directement
dans les templates mais par la classe multipage
*/
function allWordsBlock()
{
	global $lang_mod_lexique;
	
	return
	'<table class="bugs" cellpadding="0" cellspacing="0">
		<thead>
			<tr>
				<th class="tcl" scope="col">'.__('Word').'</th>
				<th class="tc2" scope="col">'.__('In').'</th>
				<th class="tcr" scope="col">'.__('By').'</th>
			</tr>
		</thead>
		<tbody>%s</tbody>
	</table>';
}

/*
@function allWordsLine

Modle des lignes de mots pour la liste complte

Important : N'est pas utilise directement
dans les templates mais par la classe multipage

@param array data	Donnes  utiliser
@param integer id	Compteur
*/
function allWordsLine($data,$i)
{
	$lettre = strtoupper($data['def_word']{0});
				
	return
	'<td class="tcl"><h3 class="word"><span><a href="'.$GLOBALS['puntal']->url('lexicon').$lettre.'">'.$data['def_word'].'</a></span></h3></td>'.
	'<td class="tc2"><a href="'.$GLOBALS['puntal']->url('lexicon').$lettre.'">'.$lettre.'</a></td>'.
	'<td class="tcr"><a href="'.pt_forum_url.'profile.php?id='.$data['def_user_id'].'">'.html::escapeHTML($data['def_username']).'</a></td>';

}

?>