<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

$p_mode 			= pt_mod_news_mode;
$p_fid 				= unserialize(pt_mod_news_forum_id);
$p_num_posts 		= pt_mod_news_num_posts;
$p_display_post_it 	= pt_mod_news_display_post_it; 
$p_display_avatar 	= pt_mod_news_display_avatar; 

/* Form sent */
if (!empty($_POST['form_sent']) && $puntal->checkToken())
{
	$p_mode 			= intval(trim($_POST['p_mode']));
	$p_fid 				= !empty($_POST['p_fid']) ? array_map('intval',array_map('trim',$_POST['p_fid'])) : array();
	$p_num_posts 		= intval(trim($_POST['p_num_posts']));
	$p_display_post_it 	= intval(trim($_POST['p_display_post_it'])); 
	$p_display_avatar 	= intval(trim($_POST['p_display_avatar'])); 
	
    if (empty($p_fid))
		$puntal->err->setError(__('Select at least one forum'));
	
	if (!$puntal->err->hasError())
	{
		// Mise  jour de la configuration
		$pt_settings->setNamespace('mod_news');
		
		$res = true;
		$res &= $pt_settings->put('pt_mod_news_mode'			, $p_mode);
		$res &= $pt_settings->put('pt_mod_news_forum_id'		, serialize($p_fid));
		$res &= $pt_settings->put('pt_mod_news_num_posts'		, $p_num_posts);
		$res &= $pt_settings->put('pt_mod_news_display_post_it'	, $p_display_post_it);
		$res &= $pt_settings->put('pt_mod_news_display_avatar'	, $p_display_avatar);
	
		$pt_settings->setNamespace('');
		
		if ($res)
		{
			logIt('News module : edit config', 1);
			header('Location: module.php?id=news&action=3&updated=1');
			exit;
		}
	}
}

# Message de confirmation
if (!empty($_GET['updated']))
	$common_message = __('Configuration updated');

# Set token
$puntal->setToken();

# Affichage
adminPage::open(__('Configuration').' - '.__('News'),	
'<script type="text/javascript">'."\n".
"//<![CDATA[\n".
"$(function() {
	$('.checkboxes-helpers').each(function() {
		puntal.checkboxesHelpers(this);
	});
});".
"//]]>\n".
"</script>"."\n");
?>

<h2 class="first"><img src="index.php?pf=news/img/ico_news_config.png" alt="" class="icon" /> <?php echo __('News configuration') ?></h2>
<form method="post" action="module.php" id="form-news-config">
					
	<fieldset>
		<legend><?php echo __('News configuration'); ?></legend>
			
		<p><span class="fakelabel"><?php echo __('Mode') ?></span>
		<label><?php echo form::radio(array('p_mode'), 1, ($p_mode == 1), 'radio').__('Dynamics') ?></label>
		<label><?php echo form::radio(array('p_mode'), 0, ($p_mode == 0), 'radio').__('Statics') ?></label>
		<span class="desc"><?php echo __('The static mode makes it possible to generate cache files, each time you publish on your forum a news you must generate the news. The dynamic mode generates the news on each page displayin, this mode is greedier in resources server and run much more queries to the database.') ?></span></p>

		<p><span class="fakelabel"><?php echo __('Get messages from the forum') ?></span>
		<span class="desc"><?php echo __('The forum whose the news owes beings extracted.') ?></span></p>
<?php 
# Get all the categories and forums
$forums = punbb::getForums();

$cur_category = 0;
while ($forums->fetch()) :
	if ($forums->f('cid') != $cur_category)	// A new category since last iteration?
	{
		if ($cur_category != 0)
			echo "\t\t\t".'</ul>'."\n";
?>
		<p><?php echo html::escapeHTML($forums->f('cat_name')) ?></p>
		<ul class="checklist">
<?php
		$cur_category = $forums->f('cid');
	}
?>
			<li><label><?php echo form::checkbox(array('p_fid[]'),$forums->f('fid'),in_array($forums->f('fid'),$p_fid),'checkbox').html::escapeHTML($forums->f('forum_name')) ?></label></li>
<?php endwhile; ?>
		</ul>
		<p><span class="desc checkboxes-helpers"></span></p>
	
		<p class="field"><label for="p_num_posts"><?php echo __('Number of messages'); ?></label>
		<?php echo form::field('p_num_posts', 2, 5, $p_num_posts) ?>
		<span class="desc"><?php echo __('The number of news to be displayed on the home page of the module.');  if (pt_mod_news_mode == 0) echo '<br />'.__('Note: in statics mode, if you change this value you will have to regenerate your news.'); ?></span></p>
		
		<p class="field"><label for="p_display_post_it"><?php echo __('Display the Post IT ?'); ?></label>		
		<label><?php echo form::radio(array('p_display_post_it'), 1, ($p_display_post_it == 1), 'radio').__('Yes') ?></label>
		<label><?php echo form::radio(array('p_display_post_it'), 0, ($p_display_post_it == 0), 'radio').__('No') ?></label>		
		<span class="desc"><?php echo __('Do you want the post-it to be displayed ?');  ?></span></p>

		<p class="field"><label for="p_display_avatar"><?php echo __('Display the Avatar on the News ?'); ?></label>		
		<label><?php echo form::radio(array('p_display_avatar'), 1, ($p_display_avatar == 1), 'radio').__('Yes') ?></label>
		<label><?php echo form::radio(array('p_display_avatar'), 0, ($p_display_avatar == 0), 'radio').__('No') ?></label>		
		<span class="desc"><?php echo __('Do you want the avatar\'s poster to be displayed ?');  ?></span></p>
		
		
	</fieldset>
	
	<p><?php echo form::hidden('form_sent','1')."\n".
	form::hidden('id','news')."\n".
	form::hidden('action',3)."\n".
	form::hidden(array('ptkn'),$puntal->getToken()); ?>
	<input class="submit" type="submit" value="<?php echo __('Save'); ?>" /></p>

</form>
<?php adminPage::close() ?>