<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

/* Form sent */
if (isset($_REQUEST['gen_news']))
{
	require_once PT_INC_PATH.'/libs/punbb_parser.php';

	if (file_exists(PT_THEMES_PATH.pt_theme.'/news/news_static.tpl'))
		$tpl_file = PT_THEMES_PATH.pt_theme.'/news/news_static.tpl';
	else
		$tpl_file = PT_THEMES_PATH.PT_DEFAULT_THEME.'/news/news_static.tpl';
			
	
	$p_fid = unserialize(pt_mod_news_forum_id);
	
	if (count($p_fid) < 1)
		adminPage::fatalErrorPage(__('unselected_forum_id'));
	
	// Generate front page news
	$tmp_news_id = array(); 
	foreach ($p_fid as $id)
		$tmp_news_id[] = " t.forum_id='".$id."'";

	//Get news		
	$sticky=' AND t.sticky=0 ';
	if (pt_mod_news_display_post_it) 
		$sticky = 'AND ( t.sticky=0 OR t.sticky=1 )';
		

	$query = 'SELECT t.id, t.subject, f.id AS fid, f.forum_name FROM '
		.DB_PREFIX.'topics t LEFT JOIN '
		.DB_PREFIX.'forums f ON t.forum_id=f.id WHERE ('
		.implode(' OR ', $tmp_news_id).') AND t.moved_to IS NULL ' .
		$sticky.
		'ORDER BY t.sticky DESC, t.posted DESC LIMIT 0, '.pt_mod_news_num_posts;
	
	$topics = $con->select($query) or $puntal->err->fatalError($con->error());

	if ($topics->isEmpty())
		$puntal->err->setError(sprintf(__('no_topics_to_generate'),implode(",",$p_fid)));
	
	$news_tpl = file_get_contents($tpl_file) or $puntal->err->fatalError(__('unable_to_open_tpl'));

	$fh = @fopen(PT_CACHE_PATH.'news/news.html', 'wb');
	if (!$fh)
		$puntal->err->fatalError(__('unable_to_write_news'));

	// boucle sur les sujets
	while ($topics->fetch())
	{
		$titre_news = '';
		$url_news = '';
		$date_news = '';
		$auteur_news = '';
		$auteur_profil = '';
		$avatar_auteur = '';
		$message_news = '';
		$forum_link = '';
		$forum_name = '';
		
		// rcupration news				
		
		if (pt_mod_news_display_avatar) 
			$cur_post = $con->select('SELECT u.use_avatar, p.posted, p.poster, p.poster_id, p.message, p.hide_smilies FROM '.DB_PREFIX.'posts AS p INNER JOIN '.DB_PREFIX.'users AS u ON u.id=p.poster_id WHERE topic_id='.$topics->f('id').' ORDER BY posted ASC LIMIT 1') or $puntal->err->fatalError($con->error());
		else 
			$cur_post = $con->select('SELECT p.posted, p.poster, p.poster_id, p.message, p.hide_smilies FROM '.DB_PREFIX.'posts AS p WHERE topic_id='.$topics->f('id').' ORDER BY posted ASC LIMIT 1') or $puntal->err->fatalError($con->error());		
			
		// titre news
		if ($puntal->pun_config['o_censoring'] == '1')
			$topics->setField('subject', $puntal->censor_words($topics->f('subject')));
		
		// contenu news
		$tmp_message = '';

		if (strpos($cur_post->f('message'),'[---]') > 0 ) 
			list($tmp_message) = split('\[---\]',$cur_post->f('message'));
		else $tmp_message = $cur_post->f('message');

		$port = '';
		if ( $_SERVER['SERVER_PORT'] != '80' ) 
			$port = ":".$_SERVER['SERVER_PORT'];
					
		$tmp_message .=	"\n".'[url='.$_SERVER['SERVER_NAME'].$port.pt_forum_url.'viewtopic.php?id='.$topics->f('id').']'.__('Read more').'[/url]';
				
		// set message
		
		$cur_post->setField('message',parse_message($tmp_message, $cur_post->f('hide_smilies')));
		
		// avatar poster

		if (pt_mod_news_display_avatar && $puntal->pun_config['o_avatars'] == '1' && $cur_post->f('use_avatar') == '1')
		{
			if ($img_size = @getimagesize(PUN_ROOT.$puntal->pun_config['o_avatars_dir'].'/'.$cur_post->f('poster_id').'.gif'))
				$user_avatar = '<p class="newsAvatar"><img src="'.pt_forum_url.$puntal->pun_config['o_avatars_dir'].'/'.$cur_post->f('poster_id').'.gif" '.$img_size[3].' alt="" /></p>';
			else if ($img_size = @getimagesize(PUN_ROOT.$puntal->pun_config['o_avatars_dir'].'/'.$cur_post->f('poster_id').'.jpg'))
				$user_avatar = '<p class="newsAvatar"><img src="'.pt_forum_url.$puntal->pun_config['o_avatars_dir'].'/'.$cur_post->f('poster_id').'.jpg" '.$img_size[3].' alt="" /></p>';
			else if ($img_size = @getimagesize(PUN_ROOT.$puntal->pun_config['o_avatars_dir'].'/'.$cur_post->f('poster_id').'.png'))
				$user_avatar = '<p class="newsAvatar"><img src="'.pt_forum_url.$puntal->pun_config['o_avatars_dir'].'/'.$cur_post->f('poster_id').'.png" '.$img_size[3].' alt="" /></p>';
			else
				$user_avatar = '';
		}
		else
			$user_avatar = '';
		
		$titre_news 	= html::escapeHTML($topics->f('subject'));
		$url_news 		= pt_forum_url.'viewtopic.php?id='.$topics->f('id');
		$date_news 		= dt::str(pt_date_format.' '.pt_time_format, $cur_post->f('posted'));
		$auteur_news 	= html::escapeHTML($cur_post->f('poster'));
		$auteur_profil 	= pt_forum_url.'profile.php?id='.$cur_post->f('poster_id');
		$avatar_auteur 	= $user_avatar;
		$message_news 	= $cur_post->f('message');
		$forum_link 	= pt_forum_url.'viewforum.php?id='.$topics->f('fid');
		$forum_name 	= html::escapeHTML($topics->f('forum_name'));
				
		$search = array(
            '<read>',
            '<see_profile>',
            '<see_comment_of>',
            '<comments>',
            '<readings>',      
            '<written_by>',
			'<on>',
			'<in>',
			'<titre_news>',
			'<url_news>',
			'<date_news>',
			'<auteur_news>',
			'<auteur_profil>',
			'<avatar_auteur>',
			'<message_news>',
			'<forum_link>',
			'<forum_name>'
			);
			
		$replace = array(
            __('Read'),
            __('See profile of'),
            __('See comments of'),
            __('Comments'),
            __('Readings'),
            __('Written by'), 
            __('on'), 
            __('in'), 
			$titre_news,
			$url_news,
			$date_news,
			$auteur_news,
			$auteur_profil,
			$avatar_auteur,
			$message_news,
			$forum_link,
			$forum_name
			);

		fwrite($fh, str_replace($search, $replace, $news_tpl));
	}

	fclose($fh);


	// Generate monthly archives
	$year_end = intval(date('Y'));
	$month_end = intval(date('n'));

	$year_start = ($month_end != 1) ? $year_end : $year_end-1;
	$month_start = ($month_end != 1) ? $month_end-1 : 12;
	
	// How far back should we go?
	$tmp_news_id = array(); 
	foreach ($p_fid as $id)
		$tmp_news_id[] = " forum_id='".$id."'";
		
	$query = 'SELECT MIN(posted) AS history_limit FROM '.DB_PREFIX.'topics WHERE ( '.implode(' OR ', $tmp_news_id).' ) ';
	
	$result = $con->select($query) or $puntal->err->fatalError($con->error());

	$year_limit = intval(date('Y', $result->f('history_limit')));
	$month_limit = intval(date('n', $result->f('history_limit')));

	// boucle sur les sujets
	while ($year_end > $year_limit || $month_end > $month_limit)
	{			
		// getting news			
		$tmp_news_id = array(); 
		foreach ($p_fid as $id)
			$tmp_news_id[] = " t.forum_id='".$id."'";
		
		$query = 'SELECT t.id, t.subject, f.id AS fid, f.forum_name FROM '.DB_PREFIX.'topics t LEFT JOIN '.DB_PREFIX.'forums f ON t.forum_id=f.id WHERE ( '.implode(' OR ', $tmp_news_id).' ) AND t.posted>=UNIX_TIMESTAMP(\''.$year_start.'-'.$month_start.'-01\') AND t.posted<UNIX_TIMESTAMP(\''.$year_end.'-'.$month_end.'-01\') AND t.moved_to IS NULL ORDER BY t.posted DESC' ;

		$topics = $con->select($query) or $puntal->err->fatalError($con->error());
		
		if (!$topics->isEmpty())
		{
			$news_tpl = file_get_contents($tpl_file) or $puntal->err->fatalError(__('unable_to_open_tpl'));
						
			$fh = @fopen(PT_CACHE_PATH.'news/archives/'.$year_start.'-'.($month_start > 9 ? $month_start : '0'.$month_start).'.html', 'wb');

			if (!$fh)
				$puntal->err->fatalError(sprintf(__('unable_to_write_archives'), $year_start.'-'.($month_start > 9 ? $month_start : '0'.$month_start)), __FILE__, __LINE__);

			while ($topics->fetch())
			{
				$titre_news = '';
				$url_news = '';
				$date_news = '';
				$auteur_news = '';
				$auteur_profil = '';
				$avatar_auteur = '';
				$message_news = '';
				$forum_link = '';
				$forum_name = '';
				
				if (pt_mod_news_display_avatar)
					$cur_post = $con->select('SELECT u.use_avatar, p.posted, p.poster, p.poster_id, p.message, p.hide_smilies FROM '.DB_PREFIX.'posts AS p INNER JOIN '.DB_PREFIX.'users AS u ON u.id=p.poster_id WHERE topic_id='.$topics->f('id').' ORDER BY posted ASC LIMIT 1') or $puntal->err->fatalError($con->error());
				else 
					$cur_post = $con->select('SELECT p.posted, p.poster, p.poster_id, p.message, p.hide_smilies FROM '.DB_PREFIX.'posts AS p WHERE topic_id='.$topics->f('id').' ORDER BY posted ASC LIMIT 1') or $puntal->err->fatalError($con->error());
				
				// titre news
				if ($puntal->pun_config['o_censoring'] == '1')
					$topics->setField('subject', $puntal->censor_words($topics->f('subject')));
				
				// contenu news
				$tmp_message = '';
				if (strpos($cur_post->f('message'),'[---]') > 0 ) 
				list($tmp_message) = split('\[---\]',$cur_post->f('message'));
				else $tmp_message = $cur_post->f('message');				
				
				
				// fix smiley url
				$cur_post->setField('message',str_replace('img/smilies/', pt_forum_url.'img/smilies/', $tmp_message));
				
				// avatar poster
				
				if (pt_mod_news_display_avatar && $puntal->pun_config['o_avatars'] == '1' && $cur_post->f('use_avatar') == '1')
				{
					if ($img_size = @getimagesize(PUN_ROOT.$puntal->pun_config['o_avatars_dir'].'/'.$cur_post->f('poster_id').'.gif'))
						$user_avatar = '<img src="'.pt_forum_url.$puntal->pun_config['o_avatars_dir'].'/'.$cur_post->f('poster_id').'.gif" '.$img_size[3].' alt="" />';
					else if ($img_size = @getimagesize(PUN_ROOT.$puntal->pun_config['o_avatars_dir'].'/'.$cur_post->f('poster_id').'.jpg'))
						$user_avatar = '<img src="'.pt_forum_url.$puntal->pun_config['o_avatars_dir'].'/'.$cur_post->f('poster_id').'.jpg" '.$img_size[3].' alt="" />';
					else if ($img_size = @getimagesize(PUN_ROOT.$puntal->pun_config['o_avatars_dir'].'/'.$cur_post->f('poster_id').'.png'))
						$user_avatar = '<img src="'.pt_forum_url.$puntal->pun_config['o_avatars_dir'].'/'.$cur_post->f('poster_id').'.png" '.$img_size[3].' alt="" />';
					else
						$user_avatar = '';
				}
				else
					$user_avatar = '';
				
				$titre_news 	= html::escapeHTML($topics->f('subject'));
				$url_news 		= pt_forum_url.'viewtopic.php?id='.$topics->f('id');
				$date_news 		= dt::str(pt_date_format.' '.pt_time_format, $cur_post->f('posted'));
				$auteur_news 	= html::escapeHTML($cur_post->f('poster'));
				$auteur_profil 	= pt_forum_url.'profile.php?id='.$cur_post->f('poster_id');
				$avatar_auteur 	= $user_avatar;
				$message_news 	= $cur_post->f('message');
				$forum_link 	= pt_forum_url.'viewforum.php?id='.$topics->f('fid');
				$forum_name 	= html::escapeHTML($topics->f('forum_name'));
						
				$search = array(
                    '<read>',
                    '<see_profile>',
                    '<see_comment_of>',
                    '<comments>',
                    '<readings>',
                    '<written_by>',
                    '<on>',
                    '<in>',
					'<titre_news>',
					'<url_news>',
					'<date_news>',
					'<auteur_news>',
					'<auteur_profil>',
					'<avatar_auteur>',
					'<message_news>',
					'<forum_link>',
					'<forum_name>'
					);
					
				$replace = array(
                    __('Read'),
                    __('See profile og'),
                    __('See comment of'),
                    __('Comments'),
                    __('Readings'),
                    __('Written by'),
                    __('on'),
                    __('in'),
					$titre_news,
					$url_news,
					$date_news,
					$auteur_news,
					$auteur_profil,
					$avatar_auteur,
					$message_news,
					$forum_link,
					$forum_name
					);
		
				fwrite($fh, str_replace($search, $replace, $news_tpl));
			}
			fclose($fh);
		}

		$year_end = $year_start;
		$month_end = $month_start;
		$year_start = ($month_end != 1) ? $year_end : $year_end-1;
		$month_start = ($month_end != 1) ? $month_end-1 : 12;
	}
	
	if ($puntal->err->hasError())
		adminPage::fatalErrorPage($puntal->err->getError());
	else {
		logIt("News module : generate news");
		
		if (isset($_REQUEST['from_post']))
		{
			header('Location: module.php?id=news&action=1&addgen=1');
			exit;
		}
		else {
			header('Location: module.php?id=news&action=2&generated=1');
			exit;
		}
	}
}

# Messages de confirmation
if (!empty($_GET['addgen']))
	$common_message = __('News added').' '.__('Generated news');
	
if (!empty($_GET['generated']))
	$common_message = __('Generated news');

# Affichage
adminPage::open(__('Generate news').' - '.__('News'));
?>

<h2 class="first"><img src="index.php?pf=news/img/ico_news_generate.png" alt="" class="icon" /> <?php echo __('Generate news') ?></h2>
<form method="post" action="module.php">
					
	<p><?php echo __('Puntal generates static contents in order not to systematically launch requests at the data base to recover contents which change only seldom. To generate the news, click on the button below.'); ?></p>
	
	<p><input type="hidden" name="gen_news" value="1" />
	<input type="hidden" name="id" value="news" />
	<input type="hidden" name="action" value="2" />
	<input class="submit" type="submit" value="<?php echo __('Generate') ?>" /></p>

</form>
<?php adminPage::close() ?>