<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

# URLs configuration
define('PLANET_URL', 'planet');

# Par exemple en franais :
// define('PLANET_URL', 'planet'); # pareil :)


#########################################################################

if (!defined('PUNTAL')) exit;

# Enregistrement des modles d'URLs du module
$puntal->registerURL('planet', pt_portal_url.PLANET_URL.'/');


# classe du bloc lecteur de feed
class planetPublicBlocks
{
	/**
	@function rssreader
	
	Affiche le bloc feeds
	*/
	function rssreader()
	{
		global $puntal;

		if (pt_mod_planet) {		
			
			require_once dirname(__FILE__).'/inc/planet.class.php';
			$planet = new planetManager($puntal);
			
			$feed_list = $planet->getFeed('',true,false,true);
			
			if (!$feed_list->isEmpty())
			{
				startBloc(__('RSS reader'), 'rssreader');
				
				while ($feed_list->fetch())
				{
					$feed = new SimplePie();
					$feed->feed_url($feed_list->f('rss_url'));
					$feed->output_encoding(__('lang_encoding'));
					$feed->enable_caching(true);
					$feed->cache_location(PT_CACHE_PATH.'rss/');
					$feed->cache_max_minutes(pt_mod_planet_cache_ttl);
					$feed->init();
					
					# si on as des donnes dans le fil
					if ($feed->data)
					{
						$i=0;
							  
						echo "\t\t\t\t".'<h3><a href="'.$feed->get_feed_link().'">'.$feed->get_feed_title().'</a></h3>'."\n";
						echo "\t\t\t\t".'<ul>'."\n";
						foreach ($feed->get_items(0,pt_bloc_rssreader_num) as $item)
						{
							# description
							$desc = '';
							if (pt_bloc_rssreader_desc > 0)
							{
								$desc = strip_tags($item->get_description());
								if (strlen($desc) > pt_bloc_rssreader_desc)
									$desc = substr($desc,0,pt_bloc_rssreader_desc).'...';
							}
							
							echo "\t\t\t\t\t".'<li><a href="'.$item->get_permalink().'" title="'.html::escapeHTML($desc).'">'.$item->get_title().'</a></li>'."\n";  
						}
						echo "\t\t\t\t".'</ul>'."\n";
					}
					
					# simple prcaution
					unset($feed);
				}
			
				endBloc();
			}
		}
	}

}

?>