<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;


/* Traitements
-------------------------------------------------------- */


# Ordonner les feeds
$order = array();
if (empty($_POST['feeds_order']) && !empty($_POST['order']))
{
	$order = $_POST['order'];
	asort($order);
	$order = array_keys($order);
}
elseif (!empty($_POST['feeds_order']))
	$order = explode(',',$_POST['feeds_order']);

if (!empty($_POST['saveorder']) && !empty($order) && $puntal->checkToken())
{
	if ($planet->ordFeeds($order))
	{
		header('Location: module.php?id=planet&action=1&ordered=1');
		exit;
	}
}

# Mise en ligne d'un feed
if (!empty($_GET['online']))
{
	$feed_id = intval($_GET['online']);
	
	$planet->statusFeed($feed_id,1);
	logIt('Planet module : enabled feed '.$feed_id, 2);
	header('Location: module.php?id=planet&action=1&enabled=1');
	exit;
}	
	
# Mise hors ligne d'un feed
if (!empty($_GET['offline']))
{
	$feed_id = intval($_GET['offline']);
	
	$planet->statusFeed($feed_id,0);
	logIt('Planet module : disabled feed '.$feed_id, 2);
	header('Location: module.php?id=planet&action=1&disabled=1');
	exit;
}

# Mettre sur le planet un feed
if (!empty($_GET['onplanet']))
{
	$feed_id = intval($_GET['onplanet']);
	
	$planet->planetFeed($feed_id,1);
	logIt('Planet module : put feed '.$feed_id.' on the planet', 2);
	header('Location: module.php?id=planet&action=1&putonplanet=1');
	exit;
}

# Retire un feed du planet
if (!empty($_GET['notonplanet']))
{
	$feed_id = intval($_GET['notonplanet']);
	
	$planet->planetFeed($feed_id,0);
	logIt('Planet module : remove feed '.$feed_id.' from the planet', 2);
	header('Location: module.php?id=planet&action=1&removedplanet=1');
	exit;
}

# Mettre sur le bloc un feed
if (!empty($_GET['onblock']))
{
	$feed_id = intval($_GET['onblock']);
	
	$planet->blockFeed($feed_id,1);
	logIt('Planet module : put feed '.$feed_id.' on the block', 2);
	header('Location: module.php?id=planet&action=1&putonblock=1');
	exit;
}

# Retire un feed du bloc
if (!empty($_GET['notonblock']))
{
	$feed_id = intval($_GET['notonblock']);
	
	$planet->blockFeed($feed_id,0);
	logIt('Planet module : remove feed '.$feed_id.' from the block', 2);
	header('Location: module.php?id=planet&action=1&removedblock=1');
	exit;
}

# Modifications d'un lot de feed
if (!empty($_POST['lot']) && !empty($_POST['selfeeds']) && is_array($_POST['selfeeds']))
{
	# Mise en ligne
	if ($_POST['lot'] == 'enable' && $puntal->checkToken())
	{
		foreach ($_POST['selfeeds'] as $v)
			$planet->statusFeed($v,1);
		
		if (!$puntal->err->hasError())
		{
			logIt('Planet module : enabled feeds '.implode(', ', $_POST['selfeeds']), 2);
			header('Location: module.php?id=planet&action=1&enableds=1');
			exit;
		}
	}
		
	# Mise hors ligne
	if ($_POST['lot'] == 'disable' && $puntal->checkToken())
	{
		foreach ($_POST['selfeeds'] as $v)
			$planet->statusFeed($v,0);
		
		if (!$puntal->err->hasError())
		{
			logIt('Planet module : disabled feeds '.implode(', ', $_POST['selfeeds']), 2);
			header('Location: module.php?id=planet&action=1&disableds=1');
			exit;
		}
	}

	# Mettre sur le planet
	if ($_POST['lot'] == 'onplanet' && $puntal->checkToken())
	{
		foreach ($_POST['selfeeds'] as $v)
			$planet->planetFeed($v,1);
		
		if (!$puntal->err->hasError())
		{
			logIt('Planet module : put feeds '.implode(', ', $_POST['selfeeds']).' on the planet', 2);
			header('Location: module.php?id=planet&action=1&putonplanet=1');
			exit;
		}
	}
	
	# Retirer du planet
	if ($_POST['lot'] == 'notonplanet' && $puntal->checkToken())
	{
		foreach ($_POST['selfeeds'] as $v)
			$planet->planetFeed($v,0);
		
		if (!$puntal->err->hasError())
		{
			logIt('Planet module : remove feeds '.implode(', ', $_POST['selfeeds']).' from the planet', 2);
			header('Location: module.php?id=planet&action=1&removedplanet=1');
			exit;
		}
	}

	# Mettre sur le bloc
	if ($_POST['lot'] == 'onblock' && $puntal->checkToken())
	{
		foreach ($_POST['selfeeds'] as $v)
			$planet->blockFeed($v,1);
		
		if (!$puntal->err->hasError())
		{
			logIt('Planet module : put feeds '.implode(', ', $_POST['selfeeds']).' on the block', 2);
			header('Location: module.php?id=planet&action=1&putonblock=1');
			exit;
		}
	}
	
	# Retirer du bloc
	if ($_POST['lot'] == 'notonblock' && $puntal->checkToken())
	{
		foreach ($_POST['selfeeds'] as $v)
			$planet->blockFeed($v,0);
		
		if (!$puntal->err->hasError())
		{
			logIt('Planet module : remove feeds '.implode(', ', $_POST['selfeeds']).' from the block', 2);
			header('Location: module.php?id=planet&action=1&removedblock=1');
			exit;
		}
	}
	
	# Suppression
	if ($_POST['lot'] == 'delete' && $puntal->checkToken())
	{
		foreach ($_POST['selfeeds'] as $v)
			$planet->delFeed($v);
		
		if (!$puntal->err->hasError())
		{
			logIt('Planet module : delete feed '.implode(', ', $_POST['selfeeds']), 3);
			header('Location: module.php?id=planet&action=1&deleted=1');
			exit;
		}
	}
}


# Messages de confirmation
if (!empty($_GET['ordered']))
	$common_message = __('Feeds ordered');

if (!empty($_GET['enabled']))
	$common_message = __('Feed enabled');

if (!empty($_GET['disabled']))
	$common_message = __('Feed disabled');

if (!empty($_GET['putonplanet']))
	$common_message = __('Put on planet');

if (!empty($_GET['removedplanet']))
	$common_message = __('Removed from the planet');

if (!empty($_GET['putonblock']))
	$common_message = __('Put on block');

if (!empty($_GET['removedblock']))
	$common_message = __('Removed from the block');

if (!empty($_GET['enableds']))
	$common_message = __('Feed(s) enabled');

if (!empty($_GET['disableds']))
	$common_message = __('Feed(s) disabled');

if (!empty($_GET['deleted']))
	$common_message = __('Feed(s) deleted');


/* Affichage
-------------------------------------------------------- */

# Set token
$puntal->setToken();

# Liste des feed
$feeds = $planet->getFeed('',false,false,false);

$head = '';

if (!$feeds->isEmpty())
{
	$head = 
	adminPage::jsToolMan().
	'<script type="text/javascript">'."\n".
	"//<![CDATA[\n".
	"var dragsort = ToolMan.dragsort();
	chainHandler(window, 'onload', function() {
		dragsort.makeTableSortable(document.getElementById('feeds-list'),
		setHandle,saveFeedsOrder);
	});
	
	function setHandle(item) {
		var handle = getElementsByNameAndClass('td','handle',item)[0];
		
		while (handle.firstChild) {
			handle.removeChild(handle.firstChild);
		}
		
		item.toolManDragGroup.setHandle(handle);
		handle.className = handle.className+' handler';
	}
	
	function saveFeedsOrder(item) {
		var group = item.toolManDragGroup;
		var order = document.getElementById('feeds_order');
		group.register('dragend', function() {
			order.value = '';
			items = item.parentNode.getElementsByTagName('tr');
			
			for (var i=0; i<items.length; i++) {
				order.value += items[i].id.substr(2)+',';
			}
		});
	}
	
	function submitFeedsForm(F,msg)
	{
		var inputs = F.elements;
		var feeds_ids = new Array();
		var action;
		
		var i = 0;
		for (i=0; i<inputs.length; i++)
		{
			if (inputs[i].name == 'selfeeds[]') {
				feeds_ids.push(inputs[i]);
			}
			
			if (inputs[i].name == 'lot') {
				action = inputs[i].value;
			}
		}
		
		var selectfields = 0;
		for (i=0; i<feeds_ids.length; i++) {
			selectfields += feeds_ids[i].checked;
		}
		
//		if (selectfields == 0) {
//			return false;
//		}
		
		if (action == 'delete') {
			return window.confirm(msg);
		}
		
		return true;
	}
	
	$(function() {
		$('.checkboxes-helpers').each(function() {
			puntal.checkboxesHelpers(this);
		});
	});
	
	//]]>
	</script>";
}	

adminPage::open(__('Manage feeds').' - '.__('Planet'),$head);
?>
<h2 class="first"><img src="style/img/ico_feed.png" alt="" class="icon" /> <?php echo __('Manage feeds') ?></h2>

<?php
if ($feeds->isEmpty()) :
	echo '<p>'.__('No feed').'</p>';
else : ?>

<form action="module.php" method="post" id="feeds-form" onsubmit="return submitFeedsForm(this,'<?php echo html::escapeJS(__('Are you sure you want to delete the selected feeds?')) ?>');">
	<table class="dragable">
	<thead>
		<tr>
			<th colspan="3" class="left"><?php echo __('Feed <acronym title="Uniform Resource Locator">URL</acronym>') ?></th>
			<th class="nowrap center"><?php echo __('Planet') ?></th>
			<th class="nowrap center"><?php echo __('Block') ?></th>
			<th class="nowrap center"><?php echo __('Status') ?></th>
		</tr>
	</thead>
	<tbody id="feeds-list">
	
<?php
$position = 1;
while ($feeds->fetch())
{
	# Statut
	if ($feeds->f('rss_status') == 1)
		$cur_status = '<a href="module.php?id=planet&amp;action=1&amp;offline='.$feeds->f('rss_id').'" title="'.__('Disable').'"><img src="style/img/on.png" class="icon" alt="'.__('Enable').'" /></a>';
	else
		$cur_status = '<a href="module.php?id=planet&amp;action=1&amp;online='.$feeds->f('rss_id').'" title="'.__('Enable').'"><img src="style/img/off.png" class="icon" alt="'.__('Disable').'" /></a>';
	
	# Planet
	if ($feeds->f('rss_planet') == 1)
		$cur_planet = '<a href="module.php?id=planet&amp;action=1&amp;notonplanet='.$feeds->f('rss_id').'" title="'.__('Remove from the planet').'"><img src="style/img/ico_desactiver.png" class="icon" alt="'.__('On the planet').'" /></a>';
	else
		$cur_planet = '<a href="module.php?id=planet&amp;action=1&amp;onplanet='.$feeds->f('rss_id').'" title="'.__('Put on the planet').'"><img src="style/img/ico_activer.png" class="icon" alt="'.__('Not on the planet').'" /></a>';
	
	# Bloc
	if ($feeds->f('rss_bloc') == 1)
		$cur_bloc = '<a href="module.php?id=planet&amp;action=1&amp;notonblock='.$feeds->f('rss_id').'" title="'.__('Remove from the block').'"><img src="style/img/ico_desactiver.png" class="icon" alt="'.__('On the block').'" /></a>';
	else
		$cur_bloc = '<a href="module.php?id=planet&amp;action=1&amp;onblock='.$feeds->f('rss_id').'" title="'.__('Put on the block').'"><img src="style/img/ico_activer.png" class="icon" alt="'.__('Not on the block').'" /></a>';
	
	# Ligne
	echo
	"\t\t".'<tr class="line" id="f_'.$feeds->f('rss_id').'">'."\n".
	"\t\t\t".'<td class="handle">'.form::field(array('order['.$feeds->f('rss_id').']'), 2, 5, $position++).'</td>'."\n".
	"\t\t\t".'<td>'.form::checkbox(array('selfeeds[]'),$feeds->f('rss_id'),0,'checkbox').'</td>'."\n".
	"\t\t\t".'<td class="maximal"><a href="module.php?id=planet&amp;action=2&amp;fid='.$feeds->f('rss_id').'">'.html::escapeHTML($feeds->f('rss_url')).'</a></td>'."\n".
	"\t\t\t".'<td class="center">'.$cur_planet.'</td>'."\n\n".
	"\t\t\t".'<td class="center">'.$cur_bloc.'</td>'."\n\n".
	"\t\t\t".'<td class="center">'.$cur_status.'</td>'."\n\n".
	"\t\t".'</tr>'."\n\n";
}
?>
	</tbody>
	</table>
	
	<div class="two-cols">
		<div class="col">
			<p class="checkboxes-helpers"></p>
			<p><?php echo 
			form::hidden(array('id'),'planet')."\n".
			form::hidden(array('action'),1)."\n".
			form::hidden(array('ptkn'),$puntal->getToken()); ?>
			<input type="hidden" id="feeds_order" name="feeds_order" value="" />
			<input class="submit" type="submit" name="saveorder" value="<?php echo __('Save order') ?>" /></p>
		</div>
		
		<p class="col right">
		<label for="lot"><?php echo __('For the selected feeds:') ?></label>
		<?php echo form::combo('lot', array(
										__('Enable')=>'enable',
										__('Disable')=>'disable',
										__('On the planet')=>'onplanet',
										__('Not on the planet')=>'notonplanet',
										__('On the block')=>'onblock',
										__('Not on the block')=>'notonblock',
										__('Delete')=>'delete'
										)) ?>
		<input class="submit" type="submit" value="<?php echo __('ok') ?>" />
		</p>
	</div>
</form>
	
<?php endif;

adminPage::close() ?>