<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;
		
require_once PT_INC_PATH.'libs/simplepie.inc';

/**
	La classe de gestion du planet
*/
class planetManager
{
	var $pt;
	var $table;
	
	/*
	@function planetManager
	
	"Constructeur"
	
	@param object pt	objet type puntal
	*/
	function planetManager(&$puntal)
	{
		$this->pt =& $puntal;
		$this->table = DB_PREFIX.'pt_planet';
	}
		
	/**
	@function getFeed
	
	Rcupration d'un ou de plusieurs feed.
	
	@param	integer	id			Identifiant d'un feed prcis  rcuprer ('')
	@param	boolean	status		Status des feed  rcuprer (true)
	@param	boolean	planet		Retrouver les feeds du planet (true)
	@param	boolean	bloc		Retrouver les feeds du bloc (false)
	@return	object recordset
	*/
	function getFeed($id='',$status=true,$planet=true,$bloc=false)
	{
		$req_plus = ' 1';
		
		if ($id != '') $req_plus .= ' AND rss_id='.(integer) $id.' ';
				
		if ($planet) $req_plus .= ' AND rss_planet=1';
				
		if ($status) $req_plus .= ' AND rss_status=1';
				
		if ($bloc) $req_plus .= ' AND rss_bloc=1';
		
		$sql = 
		'SELECT * '.
		'FROM '.$this->table.' P '.
		'WHERE '.$req_plus.' '.
		'ORDER BY rss_ord ASC';
		
		$rs = $this->pt->con->select($sql) or $this->pt->err->fatalError($this->pt->con->error());
		
		return $rs;
	}
		
	/**
	@function getPlanetFeed
	
	Rcupration des feeds pour le planet et tri. Retourne un recordset.
	
	@return	object recordset
	*/
	function getPlanetFeed()
	{
		$data = array();
		$feeds = $this->getFeed();
		
		# boucle sur les feeds
		while ($feeds->fetch()) 
		{
			$feed = new SimplePie();
			$feed->feed_url($feeds->f('rss_url'));
			$feed->output_encoding(__('lang_encoding'));
			$feed->enable_caching(true);
			$feed->cache_location(PT_CACHE_PATH.'rss/');
			$feed->cache_max_minutes(pt_mod_planet_cache_ttl);
			$feed->init();
			
			# boucle sur les items
			foreach ($feed->get_items(0, 10) as $item) 
			{
				$ts = $item->get_date('U');
				
				$current = array(
					'ts' => $ts,
					'date' => dt::str(pt_date_format.' '.pt_time_format,$ts),
					
					'title' => $item->get_title(),
					'permalink' => $item->get_permalink(),
					'description' => $item->get_description(),
					
					'feed_title' => $feed->get_feed_title(),
					'feed_link' => $feed->get_feed_link(),
					
					'blinklist' => $item->add_to_blinklist(),
					'delicious' => $item->add_to_delicious(),
					'digg' => $item->add_to_digg(),
					'furl' => $item->add_to_furl(),
					'magnolia' => $item->add_to_magnolia(),
					'newsvine' => $item->add_to_newsvine(),
					'spurl' => $item->add_to_spurl(),
					'technorati' => $item->search_technorati()
				);
				
// a, on verra plus tard				
//				if ($enclosure = $item->get_enclosure(0))
//					$current['enclosure'] = $enclosure;
				
				$data[] = $current;
			}
			unset($feed);
		}
		
		usort($data, create_function('$a, $b', 'if ($a[\'ts\'] == $b[\'ts\']) return 1; return ($a[\'ts\'] < $b[\'ts\']) ? 1 : -1;'));
		
		return new recordset($data);
	}
}

?>