<?php
/***********************************************************************

  Copyright (C) 2005-2006 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;

$p_num_per_page = pt_mod_search_num_per_page;


/* Traitements...
----------------------------------------------------------*/
if (!empty($_POST['form_sent']) && $puntal->checkToken())
{
	# Rcupration et nettoyage des donnes du formulaire.
	$p_num_per_page = intval(trim($_POST['p_num_per_page']));
    
	# Ici on se place dans l'espace de nommage du module
	$pt_settings->setNamespace('mod_search');    
	
	# On change les valeurs de nos paramtres de configuration
	$res = true;
	$res &= $pt_settings->put('pt_mod_search_num_per_page', $p_num_per_page);	

	$pt_settings->setNamespace('');
	
	# Si tout c'est bien pass...
	if ($res)
	{
		# On enregistre un log
		logIt('search module : edit config', 1);
		
		# Et on redirige
		header('Location: module.php?id=search&action=1&updated=1');
		exit;
	}
	# Sinon on fixe un message d'erreur
	else
		$puntal->setError(__('Unable to update the Puntal configuration'));
}
# Message de confirmation
if (!empty($_GET['updated']) and $common_error == '')
	$common_message = __('Configuration updated');

# Set token
$puntal->setToken();

/* Affichage
---------------------------------------------------*/
adminPage::open(__('Search configuration'));	
?>

<h2 class="first"><img src="index.php?pf=search/img/ico_search_config.png" alt="" class="icon" /> <?php echo __('Search configuration') ?></h2>

<form action="module.php" method="post" id="form-search-config">
	<fieldset>
		<legend><?php echo __('Search configuration'); ?></legend>
	
		<p class="field"><label for="p_num_per_page"><?php echo __('Number of results per page'); ?></label>
		<?php echo form::field('p_num_per_page', 2, 3, html::escapeHTML($p_num_per_page)) ?>
		<span class="desc"><?php echo __('The number of results per module to be display on the complete list.') ?></span></p>
    </fieldset>
    
    <p><?php echo 
	form::hidden(array('id'),'search')."\n".
	form::hidden(array('action'),1)."\n".
	form::hidden(array('form_sent'),'1')."\n" .
    form::hidden(array('ptkn'),$puntal->getToken()); ?>
	<input class="submit" type="submit" value="<?php echo __('Save') ?>" /></p>
	
</form>
	
<?php adminPage::close() ?>