<?php
/***********************************************************************

  Copyright (C) 2005-2007 Vincent Garnier and contributors. All rights
  reserved.
  
  This file is part of Puntal 2.

  Puntal 2 is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  Puntal 2 is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/

if (!defined('PUNTAL')) exit;


# La classe qui se charge de l'affichage des blocs sur la partie administration
class tribuneAdminBlocks
{
	# La mthode de cette classe qui se charge du bloc
	function tribune()
	{
		global $puntal, $pt_settings;
		/* Initialisation des variables de configuration (facultatif mais pratique) */
		$nb_tribune = pt_bloc_tribune_num;
				
		/* Traitements...
		----------------------------------------------------------*/
		
		/* Si $_POST['form_sent'] est dfinie et qu'il n'est pas vide c'est que
		le formulaire a t envoy.
		On vrifie ici le token (scurit) */
		if (!empty($_POST['form_sent']) && $puntal->checkToken())
		{
			/* Rcupration et nettoyage des donnes du formulaire. */
			$nb_tribune = intval(trim($_POST['nb_tribune']));			
		
			/* Ici on se place dans l'espace de nommage du module */
			$pt_settings->setNamespace('mod_tribune');    
			
			/* On change les valeurs de nos paramtres de configuration */
			$res = true;
			$res &= $pt_settings->put('pt_bloc_tribune_num', $nb_tribune);
		
			$pt_settings->setNamespace('');
			
			/* Si tout c'est bien pass... */
			if ($res)
			{
				# On enregistre un log
				logIt('tribune bloc : edit config', 1);
				
				# Et on redirige
				header('Location: bloc.php?id=tribune&updated=1');
				exit;
			}
		}
		
		# Message de confirmation
		if (!empty($_GET['updated']))
			$common_message = __('Configuration updated');
				
		
		/* Affichage de la page
		----------------------------------------------------------*/
		
		/* On crer un token unique pour l'utilisateur en ligne */
		$puntal->setToken();
		
		# Affichage
		adminPage::open(sprintf(__('Settings of the "%s" block'), __('bloc_tribune')));

		?>
		
		<?php /* Ci-dessous le titre de la page. Notez l'adresse de l'icne,
		on utilise ces adresses pour ne pas afficher clairement le chemin 
		du module si jamais l'utilisateur dplaces les dossiers. */ ?>
		<h2 class="first"><img src="index.php?pf=tribune/img/ico_tribune_config.png" alt="" class="icon" /> <?php echo __('Tribune Configuration') ?></h2>
		
		
		<form action="bloc.php" method="post">
		
			<?php /* Afin d'obtenir une certaine cohrence visuelle, il est 
			de bon ton de reproduire sur vos modules la mise en forme gnrale
			de l'administration de Puntal et donc d'utiliser les classes CSS. */ ?>
			<p class="field"><label for="nb_tribune"><?php echo __('nb_tribune') ?></label>
			
			<?php /* Afin de gnrer les champs de formulaire nous utilisons la
			classe statique "form" ; celle-ci permet de gnrer tous les champs 
			de formulaire possible trs facilement. */ ?>
			<?php echo form::field('nb_tribune', 2, 5, html::escapeHTML($nb_tribune)) ?>
			
			<?php /* Parfois un label n'est pas assez explicite, vous pouvez
			alors ajouter une description. */ ?>
			<span class="desc"><?php echo __('nb_tribune_infos') ?></span></p>
			
			
			<?php /* Les champs cachs pour que retombions bien sur notre
			page quand le formulaire est envoy. Correspond  l'URL :
			module.php?id=tribune&action=2 
			form_sent est utilis pour la traitement (en haut) pour voir 
			si le formulaire  bien t envoy. 
			ptkn est le token unique attribu  l'utilisateur en cours */ ?>
			<p><?php echo 
			form::hidden(array('id'),'tribune')."\n".
			form::hidden(array('action'),1)."\n".
			form::hidden(array('form_sent'),'1')."\n".
			form::hidden(array('ptkn'),$puntal->getToken()); ?>
			
			<input class="submit" type="submit" value="<?php echo __('Save') ?>" /></p>
			
		</form>
			
		<?php /* Comme nous avons commenc la page avec une fonction, nous la terminons
		avec une autre : adminPage::close() */
		adminPage::close() ;
	}
}

?>